#ifndef OBJECTIONH
#define OBJECTIONH

#include <stream.h>

typedef int Objection_action();

static Objection_action *const OBJECTION_DEFAULT = (Objection_action*) 0;
static Objection_action *const OBJECTION_IGNORE = (Objection_action*) 1;

class Objection {
private:
    Objection_action* action;
public:
    Objection() { 
        action = OBJECTION_DEFAULT;
    }
    Objection(Objection_action* f) { 
        action = f;
    }
    int raise() { 
        if(action == OBJECTION_DEFAULT ) return 0;
        else if(action == OBJECTION_IGNORE ) return 1;
        else return (*action)();
    }
    void abort(char* s = "") { 
        if(raise() == 0 ) {
            cerr << s << "\n";
            ::abort();
        }
    }
    Objection_action* appoint(Objection_action *const f) {
        Objection_action* old_action = action;
        action = f;
        return old_action;
    }
    Objection_action* ignore() {
        return appoint(OBJECTION_IGNORE);
    }
};

#endif
