// MOOD Embedded SQL Exmaple
// Just takes a ssno from the user and returns the Employee's name, salary,
//  vehicles company's division's location, managers name, and age 
// To get the proper values from the database, you should have constructed
//  the demo database using the script files in the moodsql_script directory.

// Necessary include files from the source directory
#include "mood_catalog.h"
#include "userreq.h"
#include "smex.h"
#include "dbi_gen.h"
#include "opt_defs.h"
#include "dbi.h"

int 		User;
UserRequest 	*userRequest; // User request

// Function for displaying the results that handels the oprations
extern int  PrintQueryResult(BULK_SCHEMA *); 

BULK_SCHEMA *QueryResult; // Query result structure

main(int argc, char **argv)
{
        char 		querybuf[500];
        int 		eno;

	userRequest = new UserRequest(); // Create the user request
	if( !userRequest->initESM( argv[0] )) // Connect to ESM
	{
		userRequest->handleError();
		exit( 1 );
	}

        userRequest->startXAct(); // Start the xact
        userRequest->execute_MSQL("use db demo"); // Use the demo database
        userRequest->commitXAct(); // Commit this xact and start new one

        printf("\nEnter the Employee ssno : "); 
        scanf("%d",&eno);  // Get the ssno from the user
        // Construct the query
        sprintf(querybuf,"select e.name, e.salary, \
                          e.drives.manufacturer.division.location.name,\
                          e.manager.name, e.age \
                          from Employee e where e.ssno = %d",eno);
        // Execute the query
        userRequest->execute_MSQL(querybuf);
	userRequest->handleError();
	QueryResult  = userRequest->getBulkSchema();
        // Print the result
        if (QueryResult) {
	    if (!PrintQueryResult(QueryResult))
	       userRequest->handleError();
        }
        // Commit the xact
	userRequest->commitXAct();

        // Close the ESM
	if( !userRequest->closeESM())
	{
		userRequest->handleError();
		exit( 1 );
	}

	delete userRequest;
}
