#include "Cursor.h"
#include "userreq.h"
#include "mood_alg.h"

extern int 		e;
extern UserRequest 	*userRequest;
extern void *InpArr[15];
extern char ExecuteTerm(ExecStruct *);
extern ExecStruct *VoidFcn[15];

int OpenCursor(BULK_SCHEMA *InFile, MOODSCursor *OutCur) {
    OutCur->fid = InFile->fid;
/*
    if ((e = sm_BeginTransaction(&TransactionId)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR,e,"transaction con not start");
        return(FALSE);
    }
*/

    if((e = sm_OpenBufferGroup(CURGRPSIZE, BF_MRU, &OutCur->grpindex, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group (Opencursor)");
       return(FALSE);
    }
    if((e = sm_OpenScanWithGroup(&OutCur->fid, PHYSICAL_SCAN, OutCur->grpindex, &OutCur->seqscandesc, NULL)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
       return(FALSE);
    }

    return(TRUE);
}

int GetFirstObject(MOODSCursor *Cur, char *Flag) {
    if((e = sm_ScanNextObject(Cur->seqscandesc, 0, READ_ALL, &Cur->CurUserdesc, Flag)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not scan next object (GetFirstObject)");
       return(FALSE);
    }

    return(TRUE);
}

int GetNextObject(MOODSCursor *Cur, char *Flag) {
    if((e = sm_ScanNextObject(Cur->seqscandesc, 0, READ_ALL, &Cur->CurUserdesc, Flag)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not scan next object (GetFirstObject)");
       return(FALSE);
    }

    return(TRUE);
}

int CloseCursor(MOODSCursor *Cur) {
 if((e = sm_CloseScan(Cur->seqscandesc)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (Close Scan)");
     return(FALSE);
 }

 if((e = sm_CloseBufferGroup(Cur->grpindex)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
    }
//  sm_CommitTransaction(TransactionId);
 return(TRUE);
}


void PrintObjectValue(USERDESC *userdesc, ATTRIBUTE **attr, int arity, int seqGroup) {
int i;
OID *oid;
USERDESC *userdesc2;

    for(i=0;i<arity;++i) {
      switch(attr[i]->attr_type) {
        case REAL : printf("%f ",*(float *)(userdesc->basePtr+attr[i]->offset));
                    break;
        case INTEGER : printf("%d ",*(int *)(userdesc->basePtr+attr[i]->offset));
                    break;
        case TEXT : printf("%s ",(char *)(userdesc->basePtr+attr[i]->offset));
                    break;
        case SIGN_VOID :
                    oid = (OID *)(userdesc->basePtr+attr[i]->offset);
                    if ((e = sm_ReadObject(seqGroup,oid,0,READ_ALL,&userdesc2)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR, e, "can not read object (Cursor)");
                       // return(FALSE);
                    }
                    InpArr[0] = userdesc2->basePtr;
                    ExecuteTerm(VoidFcn[attr[i]->unique]);
                    if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR, e, "can not release object (Cursor)");
                       // return(FALSE);
                    }
                    break; 
       }
    }
    printf("\n");
}
        

int PrintQueryResult(BULK_SCHEMA *QueryResult) {

USERDESC  *userdesc1;
SCANDESC  *seqscandesc;
TID tid;
BOOL      eof = FALSE;
MOODSCursor    *ResCur;
char      Flag;
int i=0;
       
  ResCur = (MOODSCursor *) malloc(sizeof(MOODSCursor));
  printf("\nQUERY RESULTS\n");
  printf("=============\n");

  OpenCursor(QueryResult,ResCur);
  if (!GetFirstObject(ResCur,&Flag)) 
     return(FALSE);
  while(!Flag) {
    PrintObjectValue(ResCur->CurUserdesc,QueryResult->attr,QueryResult->arity, ResCur->grpindex); 
    if (!GetNextObject(ResCur,&Flag))
       return(FALSE);
    i++;
  }
  printf("\n\n%d Objects are listed !\n",i);
  if (!CloseCursor(ResCur)) {
     return(FALSE);
  }
  for(i=0;VoidFcn[i]; ++i)
     delete VoidFcn[i];
  free(ResCur); 
  return(TRUE);
}

