#include "Cursor.h"
#include "opt.h"
#include "sm_SortFile.h"
#include "mood_catalog.h"
#include "mood_error.h"
#include "userreq.h"
#include "lists.h"
#include "set.h"
#include "SortMerge.h"
#include "LinHash.h"
#include "hhpj.h"
#include "proj.h"
#include "mood_alg.h"
#include "dld.h"

#ifndef CatBOOLEAN
#define CatBOOLEAN char
#endif

#define SEQGRPSIZE 20
#define INDGRPSIZE 25


extern ExecStruct *ConvertNewForm(EXPR_TYPE *Head,PLAN *Self);
extern ExecStruct *ConvertSelectExpr(SELECT_ARG *Head, PLAN *Self);
extern char *ExecuteTerm(ExecStruct *Head);
extern void DeletePar(char *AttrName);
extern void *InpArr[15];
extern copyToRelSchema( RELATION_SCHEMA *, UserRequest *, Catalog  *, AttrList *);
extern int BufferGroup;
extern int sm_SortFile(int ,int ,FID ,FID *, SMDATATYPE ,int ,int );
extern  FID CatalogID;
extern  TID TransactionId;
extern UserRequest *userRequest;
extern int SortMerge(int , int , JoinFileInfo *, JoinFileInfo *, BULK_SCHEMA *, Join_Attr_Off *);
extern int HHPJ ( fInfo *, fInfo *, void * , int );
extern char *myAlloc(int);

class RetOidSetDef {
   public:
     FID setFid;
     Set *ResultSet;
};

typedef struct {
    int num;
    int AttrIndx[5];
    int selfoff[5];
    BULK_SCHEMA *Schema;
    FCN_INPUT *fcn[5];
} TraverseArg;

/* execution variables */
int e;
int OrgFile = 0;
int seqGroup;
CatBOOLEAN Flag;
RetOidSetDef RetOidSet;
UserRequest DummyReq;
PLAN *ProjPlan;
int TypeIdOffset;
ExecStruct *VoidFcn[15];

VOLID volid;
char *errorMsg;

int NullOID[] = {0,0,0};

#define CheckTypeId(a,b,c) if((a)!=(b)) goto c
#define IS_NULL_OID(oid) memcmp((char *)(oid),(char *)&NullOID,12)

int CheckAttr(char *str1, char *str2) {
char *p, *q;

  if (!strcmp(str1, str2))
     return TRUE;

  p = strrchr(str2,'.');
  if (p) {
     p += 1;
     if (!strcmp(p,str1))
         return TRUE;
  }
  return FALSE;
}

Attr_Off *GetAttr(BULK_SCHEMA *InpDescr, BULK_SCHEMA *RetDescr) {
   Attr_Off *Curr, *Head, *p;
   int i, j;

   Head = Curr = (Attr_Off *) malloc(sizeof(Attr_Off));
   i = 0;
   for(j=0;j<InpDescr->arity;++j) 
      if (CheckAttr(InpDescr->attr[j]->name,RetDescr->attr[i]->name)) {
            Curr->offset = InpDescr->attr[j]->offset;
            Curr->width = InpDescr->attr[j]->attr_width;
            Curr->next = (Attr_Off *) malloc(sizeof(Attr_Off));
            p = Curr;
            Curr = Curr->next;
            i++;
      }
   free(Curr);
   p->next = NULL;
   return(Head);
}


Join_Attr_Off *GetJoinAttr(BULK_SCHEMA *InpDescr1, BULK_SCHEMA *InpDescr2, BULK_SCHEMA *RetDescr) {
   Join_Attr_Off *Curr, *Head, *p;
   int i, j, order;

   Head = Curr = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
   i = 0;
   order = 0;
   for(j=0;j<InpDescr1->arity;++j)  {
      if (CheckAttr(InpDescr1->attr[j]->name,RetDescr->attr[i]->name)) {
            Curr->offset = InpDescr1->attr[j]->offset;
            Curr->width = InpDescr1->attr[j]->attr_width;
            Curr->log = 0;
            Curr->next = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
            p = Curr;
            Curr = Curr->next;
            i++;
            order = 1;
      }
   }
   
   RetDescr->TypeId = InpDescr1->TypeId;
   if (!order) {
      i = 0;
      RetDescr->TypeId = InpDescr2->TypeId;
   }

   for(j=0;j<InpDescr2->arity;++j)  {
      if (CheckAttr(InpDescr2->attr[j]->name,RetDescr->attr[i]->name)) {
            Curr->offset = InpDescr2->attr[j]->offset;
            Curr->width = InpDescr2->attr[j]->attr_width;
            Curr->log = 1;
            Curr->next = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
            p = Curr;
            Curr = Curr->next;
            i++;
      }
   }
   if (!order) {
      for(j=0;j<InpDescr1->arity;++j)  {
         if (CheckAttr(InpDescr1->attr[j]->name,RetDescr->attr[i]->name)) {
               Curr->offset = InpDescr1->attr[j]->offset;
               Curr->width = InpDescr1->attr[j]->attr_width;
               Curr->log = 0;
               Curr->next = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
               p = Curr;
               Curr = Curr->next;
               i++;
         }
      }
   }
   free(Curr);
   p->next = NULL;
   return(Head);
}

Join_Attr_Off *GetMatAttr(BULK_SCHEMA *InpDescr1, BULK_SCHEMA *InpDescr2, BULK_SCHEMA *RetDescr, int num) {
   Join_Attr_Off *Curr, *Head, *p;
   int i, j, l, order;

   Head = Curr = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
   i = 0;
   for(j=0;j<InpDescr1->arity;++j)  {
      if (CheckAttr(InpDescr1->attr[j]->name,RetDescr->attr[i]->name)) {
            Curr->offset = InpDescr1->attr[j]->offset;
            Curr->width = InpDescr1->attr[j]->attr_width;
            Curr->log = 0;
            Curr->next = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
            p = Curr;
            Curr = Curr->next;
            i++;
      }
   }
   
   for(l=0; l<num; ++l) {
      for(j=0;j<InpDescr2[l].arity;++j)  {
         if (CheckAttr(InpDescr2[l].attr[j]->name,RetDescr->attr[i]->name)) {
            Curr->offset = InpDescr2[l].attr[j]->offset;
            Curr->width = InpDescr2[l].attr[j]->attr_width;
            Curr->log = l+1;
            Curr->next = (Join_Attr_Off *) malloc(sizeof(Join_Attr_Off));
            p = Curr;
            Curr = Curr->next;
            i++;
          }
       }
   }
   free(Curr);
   p->next = NULL;
   return(Head);
}


void CopyFields(void *OutBuf, Attr_Off *FieldInfo, void *InpBuf) {
   while (FieldInfo) {
      memcpy(OutBuf,(void *)(InpBuf+FieldInfo->offset), FieldInfo->width);
      OutBuf = (void *) (OutBuf+FieldInfo->width);
      FieldInfo = FieldInfo->next;
   }
}

void CopyJoinFields(void *OutBuf, Join_Attr_Off *FieldInfo, void **InpBuf) {
   while (FieldInfo) {
      memcpy(OutBuf, (void *)(InpBuf[FieldInfo->log]+FieldInfo->offset), FieldInfo->width);
      OutBuf = (void *) (OutBuf+FieldInfo->width);
      FieldInfo = FieldInfo->next;
   }
}

void FreeAttr(Attr_Off *FieldInfo) {
  Attr_Off *p;

  p = FieldInfo;
  while (FieldInfo) {
     FieldInfo = FieldInfo->next;
     free(p);
     p = FieldInfo;
  }
}

void FreeJoinAttr(Join_Attr_Off *FieldInfo) {
  Join_Attr_Off *p;

  p = FieldInfo;
  while (FieldInfo) {
     FieldInfo = FieldInfo->next;
     free(p);
     p = FieldInfo;
  }
}

int ExecuteFcn(FCN_INPUT *fcn, ATTRIBUTE *attr,void *this_ptr, OID **retOID) {
Function *ExecFunc;
Params *Par;
ExecStruct *FcnPar[15];
int i;
void *retval;

   Par = new Params(fcn->argnum+1);
   Par->add_parameters(this_ptr);
   for(i=0;i<fcn->argnum;++i) {
      if (!(FcnPar[i] = ConvertNewForm(fcn->ParExpr[i],NULL)))
         return FALSE;
      ExecuteTerm(FcnPar[i]);
      Par->add_parameters(FcnPar[i]->Result);
   }

   ExecFunc = new Function(attr->name);
   if (ExecFunc->error)
      return FALSE;
   retval = (void *) ExecFunc->execute(Par);
   if (ExecFunc->error)
      return FALSE;
   *retOID = (OID *) retval;
   return TRUE;
}

int FindTypeIdOffset(BULK_SCHEMA *InpDescr) {
   int i;

   for(i=0;i<InpDescr->arity;++i) {
      if (strstr(InpDescr->attr[i]->name,"typeId"))
         return(InpDescr->attr[i]->offset);
   }
}

mood_select(BULK_SCHEMA *InpDescr, ExecStruct *Head, BULK_SCHEMA *ReturnDescr, int level, int ProjNum)
{
	USERDESC *userdesc;
	OID       retOid;
	OBJHDR    oh;
	SCANDESC  *seqscandesc;
	BOOL      accept= TRUE, eof = FALSE;
        int       TotLen;
        char      *outbuf;
        int       ObjTypeId;
        Attr_Off  *Attrs;
        

	if((e = sm_CreateFile(seqGroup,volid,&ReturnDescr->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create object (select)");
		return(FALSE);
	}


	if((e = sm_OpenScanWithGroup(&InpDescr->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

	if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (select)");
		return(FALSE);
	}
/*
        if ((!level) && (!ProjNum))  {
	   if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create file (select)");
		return(FALSE);
	   }
           RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
           if (Flag) {
                userRequest->setError(SET_ERROR,e,"Can not create set ! (select)");
                return(FALSE);
           }
        }
*/

        ObjTypeId = InpDescr->TypeId;
        TypeIdOffset = FindTypeIdOffset(InpDescr);
        ReturnDescr->TypeId = ObjTypeId;
        outbuf = (char *) malloc(ReturnDescr->record_width);
        TotLen = ReturnDescr->record_width;
        Attrs = GetAttr(InpDescr, ReturnDescr);
	while(!eof){

                CheckTypeId(*(int *)(userdesc->basePtr+TypeIdOffset),ObjTypeId,select_next);
		InpArr[0] = (void *) userdesc->basePtr;
                accept = *ExecuteTerm(Head);
		if(accept) {
                        CopyFields(outbuf,Attrs,userdesc->basePtr);
                //        memcpy((void *)outbuf,(void *)(userdesc->basePtr),TotLen);
			if((e = sm_CreateObject(seqGroup,&ReturnDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,ReturnDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
			    userRequest->setError(EXODUS_ERROR, e, " can not create object (select)");
                            return(FALSE);
			}
/*
                        if ((!level) && (!ProjNum)) {
                           RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
                           if (Flag) {
                              userRequest->setError(SET_ERROR,e,"Can not create set ! (select)");
                              return(FALSE);
                           }
                        }
*/
		}

     select_next :
		if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
				userRequest->setError(EXODUS_ERROR, e, " can not scan next object (select)");
				return(FALSE);
		}
	} /* WHILE */

	if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (select)");
		return(FALSE);
	}

        free(outbuf);
        FreeAttr(Attrs);
	return(TRUE);
}


int ConstructKey(JOIN_ARG *Ptr, KEY *RetVal) {
    if (Ptr->type != CONST) {
       printf("Not a constant value in index selection !\n");
       return(FALSE);
    }
    switch(Ptr->data.cnst.kind) {
    case REAL : RetVal->length = sizeof(float);
                break;
    case INTEGER : RetVal->length = sizeof(int);
                break;
    case TEXT : RetVal->length = MAX_STRING_LEN;
                break;
    }
    RetVal->valuePtr = &Ptr->data.cnst.value;
    return(TRUE);
}
     
int BtreeSelect(BTREE_SELECT_ARG *BtreeArg, BULK_SCHEMA *ReturnDescr, int level,int  ProjNum) {
KEY SelectKey, RetKey;
SMCURSOR IndxCursor;
OBJHDR oh;
OID retOid;
char *outbuf, *outbuf1;
int  eof;
int  ObjTypeId;
Attr_Off *Attrs;

    if (!ConstructKey(BtreeArg->cond->right, &SelectKey)) {
       userRequest->setError(INTERNAL_ERROR,30,"Invalid constant (index selection)");
       return(FALSE);
    }
    switch(BtreeArg->cond->data.op) {
    case EQUAL_OP : 
                   if ((e=sm_FetchInit(&BtreeArg->index_id,seqGroup,&SelectKey,SM_EQ,&SelectKey,SM_EQ,&IndxCursor)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR,e,"Can not initialize index selection");
                       return(FALSE);
                   }
                   break;

    case LESS_THAN_OP : 
                    if ((e=sm_FetchInit(&BtreeArg->index_id,seqGroup,SM_BOF,&SelectKey,SM_L,&IndxCursor)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR,e,"Can not initialize index selecti on");
                       return(FALSE);
                   }
                   break;

    case GREATER_THAN_OP : 
                    if ((e=sm_FetchInit(&BtreeArg->index_id,seqGroup,&SelectKey,SM_G,SM_EOF,&IndxCursor)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR,e,"Can not initialize index selecti on");
                       return(FALSE);
                   }
                   break;

    case LESS_THAN_EQUAL_OP : 
                    if ((e=sm_FetchInit(&BtreeArg->index_id,seqGroup,SM_BOF,&SelectKey,SM_LEQ,&IndxCursor)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR,e,"Can not initialize index selecti on");
                       return(FALSE);
                   }
                   break;

    case GREATER_THAN_EQUAL_OP : 
                    if ((e=sm_FetchInit(&BtreeArg->index_id,seqGroup,&SelectKey,SM_GEQ,SM_EOF,&IndxCursor)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR,e,"Can not initialize index selecti on");
                       return(FALSE);
                   }
                   break;

    default : userRequest->setError(INTERNAL_ERROR,31,"Invalid operator in index selection");
              return(FALSE);
    }
    if((e = sm_CreateFile(seqGroup,volid,&ReturnDescr->fid)) != esmNOERROR) {
      userRequest->setError(EXODUS_ERROR, e, " can not create object (index selection)");
      return(FALSE);
    }

/*
    if (!level && !ProjNum) {
       if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create file (btree select)");
	  return(FALSE);
       }
       RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
       if (Flag) {
           userRequest->setError(SET_ERROR,e,"Can not create set ! (btree select)");
           return(FALSE);
       }
    }
*/

    outbuf = (char *) malloc(BtreeArg->input.record_width); 
    outbuf1 = (char *) malloc(ReturnDescr->record_width);
    RetKey.length = sizeof(CONSTANT);
    RetKey.valuePtr = (void *) malloc(sizeof(CONSTANT));
    if ((e = sm_FetchNext(&IndxCursor,&RetKey,(void *)outbuf,(char *)&eof)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR,e,"Can not scan on index");
       return(FALSE);
    }
    ObjTypeId = BtreeArg->input.TypeId;
    TypeIdOffset = FindTypeIdOffset(&BtreeArg->input);
    ReturnDescr->TypeId = ObjTypeId;

    Attrs = GetAttr(&BtreeArg->input, ReturnDescr);
    while(!eof) {
         CheckTypeId(*(int *)(outbuf+TypeIdOffset),ObjTypeId,BtreeSelect_next);
         CopyFields(outbuf1,Attrs, outbuf); 
         if((e = sm_CreateObject(seqGroup,&ReturnDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,ReturnDescr->record_width,(void*)outbuf1,&retOid)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR, e, " can not create object (index selection)");
            return(FALSE);
         }
/*
         if (!level && !ProjNum) {
            RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
            if (Flag) {
               userRequest->setError(SET_ERROR,e,"Can not create set ! (index select)");
               return(FALSE);
            }
         }
*/

  BtreeSelect_next :

         if ((e = sm_FetchNext(&IndxCursor,&RetKey,(void *)outbuf,(char *)&eof)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR,e,"Can not scan on index");
            return(FALSE);
         }
     }
     free(outbuf);
     free(outbuf1);
     free((char *)RetKey.valuePtr);
     FreeAttr(Attrs);
     return(TRUE);
}
    
int Deref(void *Arg, FID *retfid) {
Set *SetArg;
List *ListArg;
OID   retoid;
int grpindex;
USERDESC *usrdesc;
OBJHDR oh;
CatBOOLEAN stat;

grpindex = seqGroup; 
if((e = sm_CreateFile(grpindex,volid,retfid)) != esmNOERROR) {
	userRequest->setError(EXODUS_ERROR, e, " can not create file (deref)");
	return(FALSE);
}
SetArg = (Set *)Arg;
switch (SetArg->TypeId) {
     case MOODSSET : {
                 if ((e = SetArg->getFirst(&retoid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
                     return(FALSE);
                 }
                 while (!stat) {
                    if ((e = sm_ReadObject(grpindex,&retoid,0,READ_ALL,&usrdesc)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (deref)"); 
                        return(FALSE);
                    }
		    if((e = sm_CreateObject(grpindex,retfid,NEAR_FIRST_PHYSICAL,NULL,&oh,usrdesc->objectSize,usrdesc->basePtr,&retoid)) != esmNOERROR) {
		        userRequest->setError(EXODUS_ERROR, e, " can not create object (Deref)");
                        return(FALSE);
		    }
                    if ((e = sm_ReleaseObject(usrdesc)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR, e, "can no release usrdecscr (deref)");
                       return(FALSE);
                    }
                    SetArg->getNext(&retoid,&stat);
                 }
                 }
                 break;
     case MOODSLIST : {
                 ListArg = (List *) Arg;
                 if ((e = ListArg->getFirst(&retoid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
                     return(FALSE);
                 }
                 while (!stat) {
                    if ((e = sm_ReadObject(grpindex,&retoid,0,READ_ALL,&usrdesc)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (deref)"); 
                        return(FALSE);
                    }
		    if((e = sm_CreateObject(grpindex,retfid,NEAR_FIRST_PHYSICAL,NULL,&oh,usrdesc->objectSize,usrdesc->basePtr,&retoid)) != esmNOERROR) {
		        userRequest->setError(EXODUS_ERROR, e, " can not create object (Deref)");
                        return(FALSE);
		    }
                    if ((e = sm_ReleaseObject(usrdesc)) != esmNOERROR) {
                       userRequest->setError(EXODUS_ERROR, e, "can no release usrdecscr (deref)");
                       return(FALSE);
                    }
                    ListArg->getNext(&retoid,&stat);
                 }
                 }
     } /* SWITCH */
     return(TRUE);
} /* DEREF */                  
                 

InsertSelf(BULK_SCHEMA *InpDescr, BULK_SCHEMA *ReturnDescr, int level)
{
	USERDESC *userdesc;
	OID       retOid;
	OBJHDR    oh;
	int       i, oidsize = sizeof(OID);
	SCANDESC  *seqscandesc;
	BOOL      accept= TRUE, eof = FALSE;
        int       TotLen;
        char      *outbuf;
        int       ObjTypeId;
       

	if((e = sm_OpenScanWithGroup(&InpDescr->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group (InsertSelf)");
		return(FALSE);
	}

	if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (InsertSelf)");
		return(FALSE);
	}
        
        if((e = sm_CreateFile(seqGroup,volid,&ReturnDescr->fid)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, " can not create object (InsertSelf)");
           return(FALSE);
        }

        outbuf = (char *) malloc(ReturnDescr->record_width);
        TotLen = ReturnDescr->record_width;
        ObjTypeId = InpDescr->TypeId;
        TypeIdOffset = FindTypeIdOffset(InpDescr);
        ReturnDescr->TypeId = ObjTypeId;

	while(!eof){

            CheckTypeId(*(int *)(userdesc->basePtr+TypeIdOffset),ObjTypeId, InsertSelf_next);    
            InpArr[0] = (void *) userdesc->basePtr;
            memcpy(outbuf,&userdesc->oid,oidsize);
            memcpy((void *)(outbuf+oidsize),(void *)(userdesc->basePtr),TotLen-oidsize);
	    if((e = sm_CreateObject(seqGroup,&ReturnDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,ReturnDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	      userRequest->setError(EXODUS_ERROR, e, " can not create object (InsertSelf)");
              return(FALSE);
	    }

  InsertSelf_next :
	    if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not scan next object (InsertSelf)");
		return(FALSE);
            }
	} /* WHILE */

	if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (InsertSelf)");
	  return(FALSE);
	}

        free(outbuf);
	return(TRUE);
}

GetSet(BULK_SCHEMA *InpDescr, BULK_SCHEMA *ReturnDescr)
{
	USERDESC *userdesc;
	OID       retOid;
	OBJHDR    oh;
	int       i, oidsize = sizeof(OID);
	SCANDESC  *seqscandesc;
	BOOL      accept= TRUE, eof = FALSE;
        int       TotLen;
        char      *outbuf;
        int       ObjTypeId;
       

	if((e = sm_OpenScanWithGroup(&InpDescr->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group (GetSet)");
		return(FALSE);
	}

	if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (GetSet)");
		return(FALSE);
	}
        
        if((e = sm_CreateFile(seqGroup,volid,&InpDescr->fid)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, " can not create object (GetSet)");
           return(FALSE);
        }

        outbuf = (char *) malloc(InpDescr->record_width);
        TotLen = InpDescr->record_width;
        ObjTypeId = InpDescr->TypeId;
        TypeIdOffset = FindTypeIdOffset(InpDescr);

	while(!eof){

            CheckTypeId(*(int *)(userdesc->basePtr+TypeIdOffset),ObjTypeId, GetSet_next);    
            memcpy((void *)outbuf,(void *)(userdesc->basePtr),TotLen);
	    if((e = sm_CreateObject(seqGroup,&InpDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,TotLen,(void*)outbuf,&retOid)) != esmNOERROR) {
	      userRequest->setError(EXODUS_ERROR, e, " can not create object (GetSet)");
              return(FALSE);
	    }

  GetSet_next :
	    if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not scan next object (GetSet)");
		return(FALSE);
            }
	} /* WHILE */

	if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (GetSet)");
	  return(FALSE);
	}

        free(outbuf);
	return(TRUE);
}

int join(BULK_SCHEMA *InpDesc1, BULK_SCHEMA *InpDesc2,ExecStruct *Head,BULK_SCHEMA *ReturnDescr,int join_type, int level, int ProjNum) {
   USERDESC *userdesc1, *userdesc2;
   OID       retOid,CurrOid;
   OBJHDR    oh, Curroh;
   int       i;
   SCANDESC  *seqscandesc1, *seqscandesc2;
   BOOL      accept= TRUE, eof1 = FALSE, eof2 = FALSE;
   char      *outbuf, order;
   int       ObjTypeId1, ObjTypeId2;
   Join_Attr_Off *Attrs;
   void      *InpPtrs[2];
   int       TypeIdOff1, TypeIdOff2;
       
   if((e = sm_CreateFile(seqGroup,volid,&ReturnDescr->fid)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, " can not create file (join)");
     return(FALSE);
   }

   if((e = sm_OpenScanWithGroup(&InpDesc1->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc1, NULL)) != esmNOERROR) {
	userRequest->setError(EXODUS_ERROR, e, " can not open scan group1");
	return(FALSE);
   }

   if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof1)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not scan next object (join)");
     return(FALSE);
    }

/*
    if (!level && !ProjNum) {
       if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create file (join)");
	  return(FALSE);
       }
       RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
       if (Flag) {
          userRequest->setError(SET_ERROR,e,"Can not create set ! (join)");
          return(FALSE);
       }
    }
*/

    outbuf = (char *) malloc(ReturnDescr->record_width);

    ObjTypeId1 = InpDesc1->TypeId;
    TypeIdOff1 = FindTypeIdOffset(InpDesc1);
    ObjTypeId2 = InpDesc2->TypeId;
    TypeIdOff2 = FindTypeIdOffset(InpDesc2);
    Attrs = GetJoinAttr(InpDesc1, InpDesc2, ReturnDescr);

    while(!eof1){

       CheckTypeId(*(int *)(userdesc1->basePtr+TypeIdOff1),ObjTypeId1, Join_next_1);
       InpArr[0] = (void *) userdesc1->basePtr;

       if ((e = sm_GetFirstOid(seqGroup,&InpDesc2->fid,&CurrOid,&Curroh,&eof2)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR,e,"Error in getting first oid (GetFirstObject)");
        return(FALSE);
       }

       while(!eof2) {
                if ((e = sm_ReadObject(seqGroup,&CurrOid,0,READ_ALL,&userdesc2)) != esmNOERROR) {
                   userRequest->setError(EXODUS_ERROR, e, "can not read object (GetFirstObject)");
                   return(FALSE);
                }

                CheckTypeId(*(int *)(userdesc2->basePtr+TypeIdOff2),ObjTypeId2, Join_next_2);
		InpArr[1] = (void *) userdesc2->basePtr;
                accept = *ExecuteTerm(Head);
		if(accept) {
                        InpPtrs[0] = userdesc1->basePtr;
                        InpPtrs[1] = userdesc2->basePtr;
                        CopyJoinFields(outbuf,Attrs, InpPtrs);
			if((e = sm_CreateObject(seqGroup,&ReturnDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,ReturnDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
			    userRequest->setError(EXODUS_ERROR, e, " can not create object (join)");
                            return(FALSE);
			}
/*
                        if (!level && !ProjNum) {
                           RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
                           if (Flag) {
                              userRequest->setError(SET_ERROR,e,"Can not create set ! (join)");
                              return(FALSE);
                           }
                        }
*/

		}

    Join_next_2 :
                if (( e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
                    userRequest->setError(EXODUS_ERROR,e,"Cn not release userdesc (join)");
                    return(FALSE);
                }
                if ((e = sm_GetNextOid(seqGroup,&CurrOid,&CurrOid,&Curroh,&eof2)) != esmNOERROR) {
                    userRequest->setError(EXODUS_ERROR,e,"Error in getting next oid (
join)");
                    return(FALSE);
                }

	} /* WHILE2 */

  Join_next_1 :

        if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof1)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, "can not scan next object1 (join)");
          return(FALSE);
        }
    } /* WHILE1 */ 

    if((e = sm_CloseScan(seqscandesc1)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor1 (join)");
       return(FALSE);
    }
    free(outbuf);
    FreeJoinAttr(Attrs);
    return(TRUE);
} /* JOIN */

void GetMatArg(MatArg *Mat_Arg_p,PTR_HH_JOIN_ARG *p, PLAN *q) {
char AttrName[MAX_ATTR_NAME_LEN];
char AttrName1[MAX_ATTR_NAME_LEN];

  strcpy(AttrName,p->attr);
  DeletePar(AttrName);
  Mat_Arg_p->Schema = &q->input[0]->logical_property;

  for(int k=0;k<q->input[0]->logical_property.arity;++k) {
     strcpy(AttrName1,q->input[0]->logical_property.attr[k]->name);
     if (!strcmp(AttrName,AttrName1)) {
             Mat_Arg_p->AttrIndx = k;
             break;
          }
   }
}

void GetTraverseArg(TraverseArg *Mat_Arg_p,MAT_ARG *p, PLAN *q) {
char AttrName[MAX_ATTR_NAME_LEN];
char AttrName1[MAX_ATTR_NAME_LEN];
int  matnum, i;

  matnum = p->num;
  Mat_Arg_p->Schema = &q->input[0]->logical_property;
  Mat_Arg_p->num = matnum;
  for(i=0; i<matnum; ++i) {
     strcpy(AttrName,p->attr[i]);
     DeletePar(AttrName);

     for(int k=0;k<q->input[0]->logical_property.arity;++k) {
        strcpy(AttrName1,q->input[0]->logical_property.attr[k]->name);
        if (!strcmp(AttrName,AttrName1)) {
             Mat_Arg_p->AttrIndx[i] = k;
             if (q->input[0]->logical_property.attr[k]->attr_type == METHOD)
                Mat_Arg_p->fcn[i] = p->fcn[i];
             break;
          }
     }
   }
}

int PTR_HH_join(MatArg *Mat_Arg_p,BULK_SCHEMA *InpDescr, BULK_SCHEMA *RetDescr, int level, int ProjNum) {
USERDESC *userdesc1,*userdesc2;
OID       retOid, *MatOID;
OBJHDR    oh;
int       i, k, refoffset;
SCANDESC  *seqscandesc;
BOOL      accept= TRUE, eof = FALSE;
int       TotLen1, TotLen2;
char      *outbuf;
int       ObjTypeId;
struct OneRecord temp;
LinHash *LHash;
Bucket *CurrBuc, *TempBuc;
Join_Attr_Off *Attrs;
void *InpPtrs[2];
       

  if((e = sm_CreateFile(seqGroup,volid,&RetDescr->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create object (PTR_HHH_join)");
		return(FALSE);
	}

  if((e = sm_OpenScanWithGroup(&Mat_Arg_p->Schema->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (PTR_HH_join)");
		return(FALSE);
	}

/*
  if (!level && !ProjNum) {
     if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, " can not create file (PTR_HH_join)");
       return(FALSE);
     }
     RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
     if (Flag) {
        userRequest->setError(SET_ERROR,e,"Can not create set ! (PTR_HH_join)");
        return(FALSE);
     }
  }
*/

  LHash = new LinHash(50,0.7);
  TotLen1 = Mat_Arg_p->Schema->record_width;
  TotLen2 = InpDescr->record_width;
  outbuf = (char *) malloc(TotLen1);
  refoffset =  Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx]->offset; 
  ObjTypeId = Mat_Arg_p->Schema->TypeId;
  TypeIdOffset = FindTypeIdOffset(Mat_Arg_p->Schema);
  Attrs = GetJoinAttr(Mat_Arg_p->Schema, InpDescr, RetDescr);
  while(!eof){
      CheckTypeId(*(int *)(userdesc1->basePtr+TypeIdOffset),ObjTypeId,Ptr_HH_Join_next);
      memcpy((void *)outbuf,(void *)(userdesc1->basePtr),TotLen1);
      MatOID = (OID *)(outbuf+refoffset);
      temp.loid = *MatOID;
      temp.poid = userdesc1->oid;
      LHash->InsertIntoHash(temp);

  Ptr_HH_Join_next :

      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (PTR_H_join)");
        return(FALSE);
      }
   }
   free(outbuf);
   CurrBuc = LHash->HashBuckets;
   TempBuc = CurrBuc;
   k = 0;

   outbuf = (char *) malloc(RetDescr->record_width);
   while(CurrBuc) {
      while(TempBuc) {
         for(i=0;i<TempBuc->RecNum;++i) {
            if ((e = sm_ReadObject(seqGroup,&TempBuc->BucketRecords[i].poid,0,READ_ALL,&userdesc1)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (PTR_HH_join)"); 
                        return(FALSE);
            }
            if ((e = sm_ReadObject(seqGroup,&TempBuc->BucketRecords[i].loid,0,READ_ALL,&userdesc2)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (PTR_HH_join)"); 
                        return(FALSE);
            }
            InpPtrs[0] = userdesc1->basePtr;
            InpPtrs[1] = userdesc2->basePtr;
            CopyJoinFields(outbuf, Attrs, InpPtrs);
            if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	       userRequest->setError(EXODUS_ERROR, e, " can not create object (PTR_HH_join)");
               return(FALSE);
            }

/*
            if (!level && !ProjNum) {
               RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
               if (Flag) {
                  userRequest->setError(SET_ERROR,e,"Can not create set ! (PTR_HH_join)");
                  return(FALSE);
               }
            }
*/
     
            if ((e = sm_ReleaseObject(userdesc1)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not release object (PTR_HH_join)"); 
                        return(FALSE);
            }
            if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not release object (PTR_HH_join)"); 
                        return(FALSE);
            }
         } /* FOR */
         TempBuc = TempBuc->OverFlowBucket;
      } /* INNER WHILE */
      CurrBuc = CurrBuc->NextBucket;
      TempBuc = CurrBuc;
   } /* WHILE */

   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (PTR_HH_join)");
       return(FALSE);
   }

   delete LHash;
   free(outbuf);
   FreeJoinAttr(Attrs);
   return(TRUE);
} /* PTR_HH_join */

int Traverse(TraverseArg *Mat_Arg_p,BULK_SCHEMA *InpDescr, BULK_SCHEMA *RetDescr, int level, int ProjNum) {
USERDESC *userdesc1,*userdesc2[5];
OID       retOid, *MatOID;
OBJHDR    oh;
int       i, refoffset, k;
SCANDESC  *seqscandesc;
BOOL      accept= TRUE, eof = FALSE, OCreated;
int       TotLen1, TotLen2;
char      *outbuf;
int       ObjTypeId;
Join_Attr_Off *Attrs;
void      *InpPtrs[6], *this_ptr;
CatBOOLEAN stat;
Set       *SetAttr;
List      *ListAttr;
int       elemtype, elemnum;
BOOL      SetMethod, RefMethod, ListMethod;
       

  if((e = sm_CreateFile(seqGroup,volid,&RetDescr->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create object (Traverse)");
		return(FALSE);
	}

  if((e = sm_OpenScanWithGroup(&Mat_Arg_p->Schema->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (Traverse)");
		return(FALSE);
	}

/*
  if (!level && !ProjNum) {
     if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, " can not create file (Traverse)");
       return(FALSE);
     }
     RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
     if (Flag) {
        userRequest->setError(SET_ERROR,e,"Can not create set ! (Traverse)");
        return(FALSE);
     }
  }
*/
  

// Check for whether self is inserted !

/*
  for(k=0;k<Mat_Arg_p->num;++k) {
    if (Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[k]]->attr_type== METHOD) {
      Mat_Arg_p->selfoff[k] = 0; 
      for(i=0;i<Mat_Arg_p->Schema->arity;++i) {
        if (Mat_Arg_p->Schema->attr[i]->offset == Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[k]]->offset) {
           if (strstr(Mat_Arg_p->Schema->attr[i]->name,".self")) {
              Mat_Arg_p->selfoff[k] = 12;
              break;
           }
        }
      }
    }  // IF
  } // FOR
*/

  TotLen1 = Mat_Arg_p->Schema->record_width;
  outbuf = (char *) malloc(RetDescr->record_width);
  ObjTypeId = Mat_Arg_p->Schema->TypeId;
  TypeIdOffset = FindTypeIdOffset(Mat_Arg_p->Schema);
  RetDescr->TypeId = ObjTypeId;
  Attrs = GetMatAttr(Mat_Arg_p->Schema, InpDescr, RetDescr, Mat_Arg_p->num);
  OCreated = FALSE;
  while(!eof){
      CheckTypeId(*(int *)(userdesc1->basePtr+TypeIdOffset),ObjTypeId, Traverse_next);
      memcpy((void *)outbuf,(void *)(userdesc1->basePtr),TotLen1);
      InpPtrs[0] = userdesc1->basePtr;
      this_ptr = userdesc1->basePtr;
      for(i=0;i<Mat_Arg_p->num;++i) {
          RefMethod = SetMethod = ListMethod = FALSE;
          if (Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->attr_type== METHOD) {
             /* Put necessary calls for dld */
             if (!ExecuteFcn(Mat_Arg_p->fcn[i],Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]], this_ptr+Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->offset, &MatOID)) {
                userRequest->setError(RUNTIME_ERROR, 1, "Error in Dynamic Linking of function");
                return FALSE;
             } 
             if (OID_IS_INVALID((*MatOID)))
                goto Traverse_next;
             if (Mat_Arg_p->fcn[i]->ret_type == REF)
                RefMethod = TRUE;
             else if (Mat_Arg_p->fcn[i]->ret_type == SET)
                SetMethod = TRUE;
             else 
                ListMethod = TRUE;

          }
          if ((SetMethod) || (Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->attr_type== SET)) {
              OCreated = TRUE;
              if (!SetMethod) {
                 MatOID = (OID *) (userdesc1->basePtr + Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->offset);
                 if (OID_IS_INVALID((*MatOID)))
                    goto Traverse_next;
              }

              SetAttr = new Set(MatOID,&elemtype,&elemnum,&Flag);
              if (Flag) {
                     userRequest->setError(SET_ERROR,e,"Error in getting set (Traverse)");
                     return(FALSE);
              }
              if ((e = SetAttr->getFirst(&retOid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (Traverse)");
                     return(FALSE);
              }
              while (!stat) {
                 if ((e = sm_ReadObject(seqGroup,&retOid,0,READ_ALL,&userdesc2[i])) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (Traverse)");
                        return(FALSE);
                 }
                 InpPtrs[i+1] = userdesc2[i]->basePtr;
                 CopyJoinFields(outbuf,Attrs, InpPtrs);

                 if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	            userRequest->setError(EXODUS_ERROR, e, " can not create object (Traverse)");
                    return(FALSE);
                 }

/*
                 if (!level && !ProjNum) {
                    RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
                    if (Flag) {
                       userRequest->setError(SET_ERROR,e,"Can not create set ! (Traverse)");
                       return(FALSE);
                    }
                 }
*/
      
                 if ((e = sm_ReleaseObject(userdesc2[i])) != esmNOERROR) {
                    userRequest->setError(EXODUS_ERROR, e, "can not release object (Traverse)"); 
                    return(FALSE);
                 }
        
                 SetAttr->getNext(&retOid,&stat);
              }
              break; //Exit from the for loop !
          }
          else if ((ListMethod) || (Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->attr_type== LIST)) {
              OCreated = TRUE;
              if (!ListMethod) {
                 MatOID = (OID *) (userdesc1->basePtr + Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->offset);
                 if (OID_IS_INVALID((*MatOID)))
                    goto Traverse_next;
              }

              ListAttr = new List(MatOID,&elemtype,&elemnum,&Flag);
              if (Flag) {
                     userRequest->setError(SET_ERROR,e,"Error in getting set (Traverse)");
                     return(FALSE);
              }
              if ((e = ListAttr->getFirst(&retOid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (Traverse)");
                     return(FALSE);
              }
              while (!stat) {
                 if ((e = sm_ReadObject(seqGroup,&retOid,0,READ_ALL,&userdesc2[i])) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (Traverse)");
                        return(FALSE);
                 }
                 InpPtrs[i+1] = userdesc2[i]->basePtr;
                 CopyJoinFields(outbuf,Attrs, InpPtrs);

                 if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	            userRequest->setError(EXODUS_ERROR, e, " can not create object (Traverse)");
                    return(FALSE);
                 }

/*
                 if (!level && !ProjNum) {
                    RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
                    if (Flag) {
                       userRequest->setError(SET_ERROR,e,"Can not create set ! (Traverse)");
                       return(FALSE);
                    }
                 }
*/
      
                 if ((e = sm_ReleaseObject(userdesc2[i])) != esmNOERROR) {
                    userRequest->setError(EXODUS_ERROR, e, "can not release object (Traverse)"); 
                    return(FALSE);
                 }
        
                 ListAttr->getNext(&retOid,&stat);
              }
              break; //Exit from the for loop !
          }
          else {
              if (!RefMethod) {
                 refoffset =  Mat_Arg_p->Schema->attr[Mat_Arg_p->AttrIndx[i]]->offset; 
                 MatOID = (OID *)(outbuf+refoffset);
                 if (OID_IS_INVALID((*MatOID)))
                    goto Traverse_next;
              }
              if ((e = sm_ReadObject(seqGroup,MatOID,0,READ_ALL,&userdesc2[i])) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, "can not read object (Traverse)"); 
                        return(FALSE);
              }
          }
          InpPtrs[i+1] = userdesc2[i]->basePtr;
      }
      
      if (!OCreated) {
         CopyJoinFields(outbuf,Attrs, InpPtrs);

         if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	     userRequest->setError(EXODUS_ERROR, e, " can not create object (Traverse)");
             return(FALSE);
         }

/*
         if (!level && !ProjNum) {
            RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
            if (Flag) {
               userRequest->setError(SET_ERROR,e,"Can not create set ! (Traverse)");
               return(FALSE);
            }
         }
*/
      
         for(i=0;i<Mat_Arg_p->num;++i) {
             if ((e = sm_ReleaseObject(userdesc2[i])) != esmNOERROR) {
                 userRequest->setError(EXODUS_ERROR, e, "can not release object (Traverse)"); 
                 return(FALSE);
             }
         }
      } // IF OCCreated 

  Traverse_next :

      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (PTR_H_join)");
        return(FALSE);
      }
   } /* WHILE */

   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (Traverse)");
       return(FALSE);
   }


   free(outbuf);
   FreeJoinAttr(Attrs);
   return(TRUE);
} /* Traverse */

void DeleteExecStruct(ExecStruct *Head) {

  if (Head->Left) {
     DeleteExecStruct(Head->Left);
  }
  if (Head->Right) {
     DeleteExecStruct(Head->Right);
  }
  delete(Head);
}
 

int Unnest(UNNEST_ARG *Infile, BULK_SCHEMA *Outfile, PLAN *self) {
        USERDESC *userdesc;
        OID       retoid;
        OBJHDR    oh;
        int       i, SetOffset;
        SCANDESC  *seqscandesc;
        BOOL      eof = FALSE;
        CatBOOLEAN   stat;
        int       TotLen;
        char      *outbuf;
        Set       *SetAttr;
        List      *ListAttr;
        int       AttrType;
        int       ObjTypeId;
        char      Flag;
        int elemtype, elemnum;


        for(i=0;i<self->logical_property.arity;++i) {
           if (!strcmp(Infile->attr,self->logical_property.attr[i]->name)) {
              SetOffset = self->input[0]->logical_property.attr[i]->offset;
              AttrType = self->input[0]->logical_property.attr[i]->attr_type;
              break;
           }
        } 
        if((e = sm_CreateFile(seqGroup,volid,&Outfile->fid)) != esmNOERROR) {
                userRequest->setError(EXODUS_ERROR, e, " can not create file (Unnest)");
                return(FALSE);
        }

        if((e = sm_OpenScanWithGroup(&self->input[0]->logical_property.fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
                userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
                return(FALSE);
        }

        if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) !=esmNOERROR) {
                userRequest->setError(EXODUS_ERROR, e, "can not scan next object (Unnest)");
                return(FALSE);
        }

        outbuf = (char *) malloc(Outfile->record_width);
        ObjTypeId = self->input[0]->logical_property.TypeId;
        TypeIdOffset = FindTypeIdOffset(&self->input[0]->logical_property);
        Outfile->TypeId = ObjTypeId;
         
        while (!eof) {
            CheckTypeId(*(int *)(userdesc->basePtr+TypeIdOffset),ObjTypeId, Unnest_next);
            memcpy(outbuf,userdesc->basePtr,Outfile->record_width);
            if (AttrType == SET) {
               SetAttr = new Set((OID *)(userdesc->basePtr+SetOffset),&elemtype,&elemnum,&Flag);
               if (Flag) {
                     userRequest->setError(SET_ERROR,e,"Error in getting set (Unnest)");
                     return(FALSE);
               }

               if ((e = SetAttr->getFirst(&retoid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
                     return(FALSE);
                 }
                while (!stat) {
                     memcpy(outbuf+SetOffset,&retoid,sizeof(OID));
                     if((e = sm_CreateObject(seqGroup,&Outfile->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,Outfile->record_width,outbuf,&retoid)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, " can not create object (unnest)");
                        return(FALSE);
                      }
                      SetAttr->getNext(&retoid,&stat);
                }
             }
             else if (AttrType == LIST) {
               ListAttr = new List((OID *)(userdesc->basePtr+SetOffset),&elemtype,&elemnum,&Flag);
               if (Flag) {
                     userRequest->setError(SET_ERROR,e,"Error in getting set (Unnest)");
                     return(FALSE);
               }

               if ((e = ListAttr->getFirst(&retoid,&stat)) != esmNOERROR) {
                     userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
                     return(FALSE);
                 }
                while (!stat) {
                     memcpy(outbuf+SetOffset,&retoid,sizeof(OID));
                     if((e = sm_CreateObject(seqGroup,&Outfile->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,Outfile->record_width,outbuf,&retoid)) != esmNOERROR) {
                        userRequest->setError(EXODUS_ERROR, e, " can not create object (unnest)");
                        return(FALSE);
                      }
                      ListAttr->getNext(&retoid,&stat);
                }
              }

   Unnest_next :

              if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
                   userRequest->setError(EXODUS_ERROR, e, " can not scan next object (Unnest)");
                    return(FALSE);
               }
         }
         free(outbuf);
         return(TRUE);
   }

int Sort(SORT_ARG *SortArg, BULK_SCHEMA *OutDescr, PLAN *self, int level, int ProjNum) {
        int       i, KeyOffset;
        int       KeyLength;
        SMDATATYPE KeyType;
        USERDESC *userdescr1;
        SCANDESC  *seqscandesc;
        BOOL      eof = FALSE;
        CatBOOLEAN   Flag;

        for(i=0;i<self->input[0]->logical_property.arity;++i) {
           if (!strcmp(SortArg->sort_attr[0],self->input[0]->logical_property.attr[i]->name)) {
              KeyOffset = self->input[0]->logical_property.attr[i]->offset;
              KeyLength = self->input[0]->logical_property.attr[i]->attr_width;
              switch(self->input[0]->logical_property.attr[i]->attr_type) {
              case REAL : KeyType = SM_float;
                          break;
              case INTEGER : KeyType = SM_int;
                          break;
              case TEXT : KeyType = SM_string;
                          break;
              } /* Switch */
              break;
           }
        }

        if ((e = sm_SortFile(volid,seqGroup,self->input[0]->logical_property.fid,&OutDescr->fid,KeyType,KeyOffset,KeyLength)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR,e,"Error in sorting !");
           return(FALSE);
        }

/*
        if (!level && !ProjNum) {
           if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
              userRequest->setError(EXODUS_ERROR, e, " can not create file (Sort)");
              return(FALSE);
           }
           RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
           if (Flag) {
              userRequest->setError(SET_ERROR,e,"Can not create set ! (Sort)");
              return(FALSE);
           }
           if((e = sm_OpenScanWithGroup(&OutDescr->fid, PHYSICAL_SCAN, seqGroup,&seqscandesc, NULL)) != esmNOERROR) {
                userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
                return(FALSE);
           }

           if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdescr1, &eof)) != esmNOERROR) {
                userRequest->setError(EXODUS_ERROR, e, "can not scan next object (Traverse)");
                return(FALSE);
           }
           while (!eof) {
              RetOidSet.ResultSet->insertToSet(&userdescr1->oid,&Flag);
              if (Flag) {
                 userRequest->setError(SET_ERROR,e,"Can not create set ! (Sort)");
                 return(FALSE);
              }
              if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdescr1, &eof)) != esmNOERROR) {
                 userRequest->setError(EXODUS_ERROR, e, " can not scan next object (sort)");
                 return(FALSE);
              }
           } 
            
          if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
              userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (Sort)");
              return(FALSE);
          }
       } 
*/

       return(TRUE);
}

int SortMergeJoin(BULK_SCHEMA *InpDesc1, BULK_SCHEMA *InpDesc2,BULK_SCHEMA *ReturnDescr,JOIN_ARG *JoinArg, int level, int ProjNum) {
   int       i;
   JoinFileInfo File1, File2;
   Join_Attr_Off *Attrs;
       
/*
    if (!level && !ProjNum) {
       if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create file (join)");
	  return(FALSE);
       }
       RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
       if (Flag) {
          userRequest->setError(SET_ERROR,e,"Can not create set ! (join)");
          return(FALSE);
       }
    }
*/

    File1.Fid = InpDesc1->fid;
    for(i=0;i<InpDesc1->arity;++i) {
       if (!strcmp(InpDesc1->attr[i]->name, JoinArg->left->data.attr)) {
          File1.FldOffset = InpDesc1->attr[i]->offset;
          File1.FldLen = InpDesc1->attr[i]->attr_width;
          File1.FldType = InpDesc1->attr[i]->attr_type;
          break;
       } 
    }
    File1.ObjLen = InpDesc1->record_width;

    File2.Fid = InpDesc2->fid;
    for(i=0;i<InpDesc2->arity;++i) {
       if (!strcmp(InpDesc2->attr[i]->name, JoinArg->right->data.attr)) {
          File2.FldOffset = InpDesc2->attr[i]->offset;
          File2.FldLen = InpDesc2->attr[i]->attr_width;
          File2.FldType = InpDesc2->attr[i]->attr_type;
          break;
       } 
    }

    File2.ObjLen = InpDesc2->record_width;

    Attrs = GetJoinAttr(InpDesc1, InpDesc2,ReturnDescr);
    if ((i = SortMerge(volid,seqGroup,&File1,&File2,ReturnDescr, Attrs)) == esmFAILURE) {
        userRequest->setError(EXODUS_ERROR,e,"Error in Sort Merge");
        return(FALSE);
    }
    FreeJoinAttr(Attrs);
    return(TRUE);
} /* SORT MERGE JOIN */


int HashPartitionJoin(BULK_SCHEMA *InpDesc1, BULK_SCHEMA *InpDesc2,BULK_SCHEMA *ReturnDescr,JOIN_ARG *JoinArg, int level, int ProjNum) {
   int       i, bufsize, tmp;
   char      order;
   fInfo     File1, File2;
   void      *buffer;
   USERDESC  *userdesc1, *userdesc2;
   OID       JoinPair[2], retOid;
   SCANDESC  *seqscandesc1;
   FILE      *Result;
   BOOL      eof;
   char      *outbuf;
   OBJHDR    oh;
   Join_Attr_Off *Attrs;
   void      *InpPtrs[2];
       
/*
    if (!level && !ProjNum) {
       if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create file (Hash join)");
	  return(FALSE);
       }
       RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
       if (Flag) {
          userRequest->setError(SET_ERROR,e,"Can not create set ! (Hash join)");
          return(FALSE);
       }
    }
*/

    File1.fid = InpDesc1->fid;
    for(i=0;i<InpDesc1->arity;++i) {
       if (!strcmp(InpDesc1->attr[i]->name, JoinArg->left->data.attr)) {
          File1.offs = InpDesc1->attr[i]->offset;
          File1.attrSize = InpDesc1->attr[i]->attr_width;
          File1.attrType = InpDesc1->attr[i]->attr_type;
          break;
       } 
    }
    File1.oSize = InpDesc1->record_width;

    File2.fid = InpDesc2->fid;
    for(i=0;i<InpDesc2->arity;++i) {
       if (!strcmp(InpDesc2->attr[i]->name, JoinArg->right->data.attr)) {
          File2.offs = InpDesc2->attr[i]->offset;
          File2.attrSize = InpDesc2->attr[i]->attr_width;
          File2.attrType = InpDesc2->attr[i]->attr_type;
          break;
       } 
    }

    File2.oSize = InpDesc2->record_width;

   if((e = sm_OpenScanWithGroup(&InpDesc1->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc1, NULL)) != esmNOERROR) {
	userRequest->setError(EXODUS_ERROR, e, " can not open scan group1");
	return(FALSE);
   }

   if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not scan next object (join)");
     return(FALSE);
    }
    File1.numObjs = 0;
    while (!eof) {
       File1.numObjs++;
       if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
         userRequest->setError(EXODUS_ERROR, e, "can not scan next object (join)");
         return(FALSE);
       }
    }
    if((e = sm_CloseScan(seqscandesc1)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor1 (join)");
       return(FALSE);
    }

   if((e = sm_OpenScanWithGroup(&InpDesc2->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc1, NULL)) != esmNOERROR) {
	userRequest->setError(EXODUS_ERROR, e, " can not open scan group1");
	return(FALSE);
   }

   if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not scan next object (join)");
     return(FALSE);
    }
    File2.numObjs = 0;
    while (!eof) {
       File2.numObjs++;
       if((e = sm_ScanNextObject(seqscandesc1, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
         userRequest->setError(EXODUS_ERROR, e, "can not scan next object (join)");
         return(FALSE);
       }
    }
    if((e = sm_CloseScan(seqscandesc1)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor1 (join)");
       return(FALSE);
    }

    bufsize = 0xffff;
    buffer = (void *) malloc(bufsize);
    if (!buffer) {
       userRequest->setError(INTERNAL_ERROR, e, "can not open buffer (HHP join)");
       return(FALSE);
    }

    order = 0;
    if (File1.numObjs > File2.numObjs) {
       if ((i = HHPJ(&File2,&File1,buffer,bufsize)) == esmFAILURE) {
          userRequest->setError(EXODUS_ERROR,e,"Error in Hash Join");
          return(FALSE);
       }
       order = 1;
    }
    else {
       if ((i = HHPJ(&File1,&File2,buffer,bufsize)) == esmFAILURE) {
          userRequest->setError(EXODUS_ERROR,e,"Error in Hash Join");
          return(FALSE);
       }
    }
    free(buffer);
    if((e = sm_CreateFile(seqGroup,volid,&ReturnDescr->fid)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, " can not create file (Hash Join)");
       return(FALSE);
    }

    outbuf = (char *)malloc(ReturnDescr->record_width);
    Attrs = GetJoinAttr(InpDesc1, InpDesc2, ReturnDescr);
    Result = fopen("hhpj.res","r");
    fread(JoinPair,sizeof(OID),2,Result);
    while (!feof(Result)) {
      e = sm_ReadObject(seqGroup,&JoinPair[0],0,READ_ALL,&userdesc1);
      if (e != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, "can not read object (HashPartition)"); 
          return(FALSE);
      }
      e = sm_ReadObject(seqGroup,&JoinPair[1],0,READ_ALL,&userdesc2);
      if (e != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, "can not read object (HashPartition)"); 
          return(FALSE);
      }
      if (order) {
         InpPtrs[0] = userdesc2->basePtr;
         InpPtrs[1] = userdesc1->basePtr;
      }
      else {
         InpPtrs[0] = userdesc1->basePtr;
         InpPtrs[1] = userdesc2->basePtr;
      }
      CopyJoinFields(outbuf,Attrs, InpPtrs);

      if((e = sm_CreateObject(seqGroup,&ReturnDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,ReturnDescr->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
	      userRequest->setError(EXODUS_ERROR, e, " can not create object (HashPartition)");
              return(FALSE);
       }

/*
       if (!level && !ProjNum) {
           RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
           if (Flag) {
               userRequest->setError(SET_ERROR,e,"Can not create set ! (HashPartition)");
               return(FALSE);
           }
        }
     
*/
        if ((e = sm_ReleaseObject(userdesc1)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not release object (HashPartition)"); 
           return(FALSE);
        }
        if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not release object (HashPartition)"); 
           return(FALSE);
        }
        fread(JoinPair,sizeof(OID),2,Result);
    }
                        
    fclose(Result);
    system("rm hhpj.res");
    FreeJoinAttr(Attrs);
    free(outbuf);
    return(TRUE);
} /* HASH PARTITION JOIN */

int ExecuteQuery(PLAN *Head, int level, int ProjNum) {
  PLAN *p;
  int i;
  for(i=0,p=Head;((p->input[i]) && (i<2));++i) {
     if (!ExecuteQuery(p->input[i],level+1, ProjNum))
        return(FALSE);
  }

  switch(Head->algorithm) {
     case FILE_SCAN : {
#ifdef DEBUG
           printf("FILE SCAN 'dayiz.\n");
#endif
                      if (Head->algorithm_argument.file_scan.use_self) {
                         if (!InsertSelf(&Head->algorithm_argument.file_scan.input,&Head->logical_property, level)) {
                            return(FALSE);
                         }
                      }
                      strcpy(Head->logical_property.name,Head->algorithm_argument.file_scan.attr);
                      Head->logical_property.TypeId = Head->algorithm_argument.file_scan.input.TypeId;
                      }
                      break;
      case FILTER  : {
                      ExecStruct *p;
#ifdef DEBUG
           printf("FILTER'dayiz.\n");
#endif
                      p = ConvertSelectExpr(&Head->algorithm_argument.filter,Head);
                      if (!mood_select(&Head->input[0]->logical_property,p,&Head->logical_property,level,ProjNum)) {
                         return(FALSE);
                      }
                      DeleteExecStruct(p);
                      break;
                     }

      case HASH_JOIN : {
#ifdef DEBUG
           printf("HASH JOIN'dayiz.\n");
#endif
                      ExecStruct *p;
		      p = ConvertNewForm((EXPR_TYPE *)&Head->algorithm_argument.hash_join,Head);
                      if (!p)
                         return FALSE;
		      if (!join(&Head->input[0]->logical_property,&Head->input[1]->logical_property,p,&Head->logical_property,HASH_JOIN,level,ProjNum))  {
                         return(FALSE);
                      }
                      DeleteExecStruct(p);
/*
                      if (!HashPartitionJoin(&Head->input[0]->logical_property,&Head->input[1]->logical_property, &Head->logical_property,&Head->algorithm_argument.merge_join,level,ProjNum))
                         return(FALSE);
*/
                      break;
                      }
      case MERGE_JOIN : {
#ifdef DEBUG
          printf("MERGE JOIN'dayiz.\n");
#endif
                      ExecStruct *p;
		      p = ConvertNewForm((EXPR_TYPE *)&Head->algorithm_argument.merge_join,Head);
                      if (!p)
                         return FALSE;
		      if (!join(&Head->input[0]->logical_property,&Head->input[1]->logical_property,p,&Head->logical_property,HASH_JOIN,level,ProjNum)) {
                         return(FALSE);
                      }
                      DeleteExecStruct(p);
/*
                      if (!SortMergeJoin(&Head->input[0]->logical_property,&Head->input[1]->logical_property, &Head->logical_property,&Head->algorithm_argument.merge_join,level,ProjNum))
                         return(FALSE);
*/

                      break;
                      }
      case NESTED_LOOP_JOIN : {
                      ExecStruct *p;
#ifdef DEBUG
          printf("MERGE JOIN'dayiz.\n");
#endif
                      p = ConvertNewForm((EXPR_TYPE *)&Head->algorithm_argument.nested_loop_join,Head);
                      if (!p)
                         return FALSE;
                      if (!join(&Head->input[0]->logical_property,&Head->input[1]->logical_property,p,&Head->logical_property,NESTED_LOOP_JOIN,level,ProjNum)) {
                         return(FALSE);
                      }
                      DeleteExecStruct(p);
                      break;
                      }

      case PTR_HH_JOIN : {
                      MatArg p;
#ifdef DEBUG
                      printf("PTR HH JOIN'dayiz.\n");
#endif
		      GetMatArg(&p,&Head->algorithm_argument.ptr_hh_join,Head);
		      if (!PTR_HH_join(&p,&Head->algorithm_argument.ptr_hh_join.input,&Head->logical_property,level,ProjNum)) {
                         return(FALSE);
                      }
                      break;
                      }
      case BTREE_SELECT : {
#ifdef DEBUG
                      printf("BTREE_SELECT'deyiz\n");
#endif
                      if (!BtreeSelect(&Head->algorithm_argument.btree_select,&Head->logical_property,level,ProjNum)) {
                         return(FALSE);
                      }
                      break;
                      }
      case SORT : {
#ifdef DEBUG
                      printf("SORT 'dayiz\n");
#endif
                      if (!Sort(&Head->algorithm_argument.sort,&Head->logical_property,Head,level,ProjNum)) {
                         return(FALSE);
                      }
                      break;
                      }
      case UNNEST_ALG : {
#ifdef DEBUG
                      printf("UNNEST'deyiz\n");
#endif
                      if (!Unnest(&Head->algorithm_argument.unnest_alg,&Head->logical_property,Head)) {
                         return(FALSE);
                      }
                      break;
                      }
      case TRAVERSE   : {
                      TraverseArg p;
#ifdef DEBUG
                      printf("TRAVERSE'deyiz.\n");
#endif
		      GetTraverseArg(&p,&Head->algorithm_argument.traverse,Head);
		      if (!Traverse(&p,Head->algorithm_argument.traverse.input,&Head->logical_property,level,ProjNum)) {
                         return(FALSE);
                      }
                      break;
                      }
                      
   }
   return TRUE;
}

void GetProjName(JOIN_ARG *OutPList, char *ProjName, int *pos) {
char OutName[MAX_ATTR_NAME_LEN];
  if (OutPList->left)
     GetProjName(OutPList->left,ProjName, pos);
  switch(OutPList->type) {
    case ATTRIB :
                  strcpy(OutName,OutPList->data.attr);
                  break;
    case CONST :  switch(OutPList->data.cnst.kind) {
                     case INTEGER :
                                    sprintf(OutName,"%d",OutPList->data.cnst.value.int_value);
                                    break;
                     case REAL :
                                    sprintf(OutName,"%f",OutPList->data.cnst.value.real_value);
                                    break;
                     case TEXT :    strcpy(OutName,OutPList->data.cnst.value.text_value);
                                    break;
                   }
                   break;
     case OPER : switch(OutPList->data.op) {
                     case ADD : strcpy(OutName," + ");
                                break;
                     case SUB : strcpy(OutName," - ");
                                break;
                     case MUL : strcpy(OutName," * ");
                                break;
                     case DIV : strcpy(OutName," / ");
                                break;
                 }
                 break;
  }
  strcpy((char *)(ProjName + *pos),OutName);
  *pos += strlen(OutName);
  if (OutPList->right)
     GetProjName(OutPList->right,ProjName, pos);
}

char *GetClName(BULK_SCHEMA *bs, char *attname) {
 int i;

   for(i=0;i<bs->arity;++i) {
      if (!strcmp(bs->attr[i]->name,attname))
         return bs->attr[i]->class_name;
   }

   return "WRONG CL NAME !";
}

int GetFieldLen(BULK_SCHEMA *bs, char *attname) {
 int i;

   for(i=0;i<bs->arity;++i) {
      if (!strcmp(bs->attr[i]->name,attname))
         return bs->attr[i]->attr_width;
   }

   return -1;
}

int ConstructProjFile(PLAN *InpDescr, JOIN_ARG **OutPList, int ProjNum)
{
	USERDESC *userdesc;
	OID       retOid;
	OBJHDR    oh;
	SCANDESC  *seqscandesc;
	BOOL      eof = FALSE;
        int       i, AttrOffset, AttrLen, Pos;
        char      *outbuf, *ProjNameList[10];
        ExecStruct *ProjExecStruct[10];
        BULK_SCHEMA *RelInfo;
        int       ObjTypeId;
        int       voidnum;
        char      *chptr;

        
        RelInfo = &InpDescr->logical_property;
        for(i = 0; i<ProjNum; ++i) {
           if (!(ProjExecStruct[i] = ConvertNewForm((EXPR_TYPE *)OutPList[i],InpDescr))) {
               userRequest->setError(RUNTIME_ERROR, 0, " can not create interpreter (ConstructProjFile)");
               return FALSE;
           }
        }

        RelInfo->arity = ProjNum;

	if((e = sm_CreateFile(seqGroup,volid,&RelInfo->fid)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR, e, " can not create file (ConstructProjFile)");
		return(FALSE);
	}
        for(i=0;i<ProjNum;++i) {
           Pos = 0;
           ProjNameList[i] = (char *)malloc(MAX_ATTR_NAME_LEN); 
           GetProjName(OutPList[i],ProjNameList[i], &Pos);
        }

        AttrOffset = 0;
        voidnum = 0;
        for(i=0;i<ProjNum;++i) {
           RelInfo->attr[i] = (ATTRIBUTE *)myAlloc(sizeof(ATTRIBUTE));
           strcpy(RelInfo->attr[i]->name,ProjNameList[i]);
           free(ProjNameList[i]);
           RelInfo->attr[i]->attr_type = ProjExecStruct[i]->operand_type;
           strcpy(RelInfo->attr[i]->class_name,
                     GetClName(&InpDescr->input[0]->logical_property, 
                                RelInfo->attr[i]->name));

           RelInfo->attr[i]->offset = AttrOffset;
           RelInfo->attr[i]->unique = voidnum;
           switch(RelInfo->attr[i]->attr_type) {
              case INTEGER : 
                            AttrOffset += sizeof(int);
                            AttrLen = sizeof(int);
                            break;
              case REAL   :
                            AttrOffset += sizeof(float);
                            AttrLen = sizeof(float);
                            break;
              case TEXT    :
                            AttrOffset += MAX_STRING_LEN;
                            AttrLen = MAX_STRING_LEN;
                            break;
              case SET :
              case LIST :
              case REF    :
                           AttrOffset += sizeof(OID);
                           AttrLen = sizeof(OID);
                           break;
              case SIGN_VOID :
                           AttrOffset += sizeof(OID);
                           AttrLen = sizeof(OID);
                           chptr = strrchr(RelInfo->attr[i]->name,'.');
                           chptr++;
                           sprintf(chptr,"%s()", ProjExecStruct[i]->Op_Inp.Fcn_Inp.Fname);
                           VoidFcn[voidnum++] = ProjExecStruct[i];
                           break;
              case DB_TYPE :
                           AttrLen = GetFieldLen(&InpDescr->input[0]->logical_property, RelInfo->attr[i]->name);
                           AttrOffset += AttrLen;
                           break;
              default     :
                           break;
           }
           RelInfo->attr[i]->attr_width = AttrLen;
        }   
        
        RelInfo->record_width = AttrOffset;
        VoidFcn[voidnum] = NULL;


	if((e = sm_OpenScanWithGroup(&InpDescr->input[0]->logical_property.fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
	    return(FALSE);
	}

	if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (ConstructProjFile)");
		return(FALSE);
	}
/*
	if((e = sm_CreateFile(seqGroup,volid,&RetOidSet.setFid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create file (ConstructProjFile)");
		return(FALSE);
	}
        RetOidSet.ResultSet = new Set(&RetOidSet.setFid,NEAR_FIRST_PHYSICAL,NULL,&Flag);
        if (Flag) {
                userRequest->setError(SET_ERROR,e,"Can not create set ! (ConstructProjFile)");
                return(FALSE);
        }
*/

        outbuf = (char *) malloc(RelInfo->record_width);
        ObjTypeId = InpDescr->input[0]->logical_property.TypeId;
        TypeIdOffset = FindTypeIdOffset(&InpDescr->input[0]->logical_property);
        RelInfo->TypeId = ObjTypeId;

	while(!eof){

                CheckTypeId(*(int *)(userdesc->basePtr+TypeIdOffset),ObjTypeId, Construct_P_next);
		InpArr[0] = (void *) userdesc->basePtr;
                for(i=0;i<ProjNum;++i) {
                   if (ProjExecStruct[i]->operand_type == DB_TYPE) {
                      memcpy((void *)(outbuf+RelInfo->attr[i]->offset),
       (void *)(InpArr[0]+ProjExecStruct[i]->Op_Inp.Attr_Inp.attr_offset),
       RelInfo->attr[i]->attr_width);
                   }
                   else if (ProjExecStruct[i]->operand_type == SIGN_VOID) 
                      memcpy((void *)(outbuf+RelInfo->attr[i]->offset),(void *)(&userdesc->oid),RelInfo->attr[i]->attr_width);
                   else {
                      ExecuteTerm(ProjExecStruct[i]);
                      memcpy((void *)(outbuf+RelInfo->attr[i]->offset),(void *)(ProjExecStruct[i]->Result),RelInfo->attr[i]->attr_width);
                   }
                }
	        if((e = sm_CreateObject(seqGroup,&RelInfo->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RelInfo->record_width,(void*)outbuf,&retOid)) != esmNOERROR) {
		    userRequest->setError(EXODUS_ERROR, e, " can not create object (ConstructProjFile)");
                    return(FALSE);
	        }
/*
                RetOidSet.ResultSet->insertToSet(&retOid,&Flag);
                if (Flag) {
                      userRequest->setError(SET_ERROR,e,"Can not create set ! (ConstructProjFile)");
                      return(FALSE);
                }
*/

  Construct_P_next :

		if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc, &eof)) != esmNOERROR) {
			userRequest->setError(EXODUS_ERROR, e, " can not scan next object (ConstructProjFile)");
			return(FALSE);
		}
	} /* WHILE */

	if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (ConstructProjFile)");
		return(FALSE);
	}
        for(i=0;i<ProjNum;++i) {
           if (ProjExecStruct[i]->operand_type != SIGN_VOID)
              DeleteExecStruct(ProjExecStruct[i]);
        }

        free(outbuf);
	return(TRUE);
} /* ConstructProjFile */

void FreePlan(PLAN *Head) {
int i,k;

 for(k=0;Head->input[k];++k) {
   FreePlan(Head->input[k]);
 }
 for(i=0;i<Head->logical_property.arity;++i) {
    free(Head->logical_property.attr[i]);
 }
}
     
int InitSystem(char **argv) {

    if ((e=sm_ReadConfigFile(NULL, argv[0], &errorMsg)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR,e, "Configuration file error");
        return(FALSE);
    }

   if ((e = sm_Initialize() ) != esmNOERROR)     {
       userRequest->setError(EXODUS_ERROR,e,"Initialization error ");
       return(FALSE);
    }

   volid = atoi(getenv("EVOLID"));
   return(TRUE);
}

int DoTransaction(PLAN *Head, JOIN_ARG **OutPList, int ProjNum, PLAN **RetPlan) {

  char *VolStr;

    VolStr = getenv("TMPVOLID");
    if (!VolStr) {
       userRequest->setError(EXODUS_ERROR, e, " can not mount temporary volume");
       return(FALSE); 
    }
    volid = atoi(VolStr);
   /* 
    if((e = sm_MountVolume(volid)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not mount the volume");
       return(FALSE);
    }
*/
    if((e = sm_OpenBufferGroup(SEQGRPSIZE, BF_MRU, &seqGroup, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group ");
       return(FALSE);
    }
    if (!ExecuteQuery(Head,0,ProjNum)) {
       return FALSE;
    }
    if (ProjNum) {
         ProjPlan = (PLAN *) myAlloc(sizeof(PLAN));
         ProjPlan->input[0] = Head;
         ProjPlan->input[1] = NULL;
         if (!ConstructProjFile(ProjPlan,OutPList,ProjNum)) { 
            return(FALSE);
         }
         *RetPlan = ProjPlan;
    }
    else {
        *RetPlan = Head;
        VoidFcn[0] = NULL;
    }
    
    if((e = sm_CloseBufferGroup(seqGroup)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
    }
    printf("Mood Algebra returned succesfully\n");
    return(TRUE);
}

int asSet(FID *infid, Set *OutSet) {
BOOL Flag;
CatBOOLEAN Flag1;
OID  retOid;
OBJHDR oh;
    if ((e = sm_GetFirstOid(seqGroup,infid,&retOid,&oh,&Flag)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR,e,"Error in getting first oid (asSet)");
        return(FALSE);
    }
    while (!Flag) {
        OutSet->insertToSet(&retOid,&Flag1);
        if (Flag1) {
           userRequest->setError(SET_ERROR,e,"Can not insert set ! (asSet)");
           return(FALSE);
        }
        if ((e = sm_GetNextOid(seqGroup,&retOid,&retOid,&oh,&Flag)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR,e,"Error in getting next oid (asSet)");
            return(FALSE);
        }
    }
    return(TRUE);
}


int asList(FID *infid, List *OutList) {
BOOL Flag;
CatBOOLEAN Flag1;
OID  retOid;
OBJHDR oh;
    if ((e = sm_GetFirstOid(seqGroup,infid,&retOid,&oh,&Flag)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR,e,"Error in getting first oid (asSet)");
        return(FALSE);
    }
    while (!Flag) {
        OutList->insertToList(&retOid,&Flag1);
        if (Flag1) {
           userRequest->setError(SET_ERROR,e,"Can not insert List ! (asList)");
           return(FALSE);
        }
        if ((e = sm_GetNextOid(seqGroup,&retOid,&retOid,&oh,&Flag)) != esmNOERROR) {
            userRequest->setError(EXODUS_ERROR,e,"Error in getting next oid (asList)");
            return(FALSE);
        }
    }
    return(TRUE);
}

int evaluateExpr(JOIN_ARG *jExp, CNST *RetExp) {
ExecStruct *p;

     p = ConvertNewForm((EXPR_TYPE *)jExp,NULL);
     if (!p)
        return FALSE;
    
     ExecuteTerm(p);

     RetExp->kind = p->operand_type;
     switch(p->operand_type) {
      case INTEGER : RetExp->value.int_value = *(int *)p->Result;
                     break;   
      case REAL :    RetExp->value.real_value = *(float *)p->Result;
                     break;
      case TEXT :    strcpy(RetExp->value.text_value,(char *)p->Result);
                     break;
     }
     return(TRUE);

}
   
AttrList *GetAttrList(AttrList *InAttrList, char *AttName) {
AttrList *OutAttrList;

  if (InAttrList->entry.AttributeConstructor == 'T') {
     if (OutAttrList = GetAttrList(InAttrList->nextsub, AttName))
        return(OutAttrList);
     if (InAttrList->next) {
        OutAttrList = GetAttrList(InAttrList->next, AttName); 
        if (OutAttrList)
           return(OutAttrList);
     }
  }

  OutAttrList = InAttrList;
  while (OutAttrList) {
     switch(OutAttrList->entry.AttributeConstructor) {
        case 'R' :
        case 'L' :
        case 'S' :
                  if (!strcmp(OutAttrList->entry.AttributeName,AttName)) {
                     return(OutAttrList);
                  }
        default : OutAttrList = OutAttrList->next;
     }
  }
  return(NULL);
} 
    
char *GetRefName(BULK_SCHEMA *InFile, int AttrNum) {
Catalog CurCat;
AttrList *CurAttrList, *AList;
char ClassName[MAXSTRLEN], AttrName[MAXSTRLEN], AttrName1[MAXSTRLEN],
     *DotPos, *DotPos1, *SelfPos;
MoodsTypes Mtype;
CatBOOLEAN Flag;
int i;

     if (strstr(InFile->attr[AttrNum]->name,"self")) {
        strcpy(AttrName,InFile->attr[AttrNum]->name);
        DotPos = strchr(AttrName,'.'); 
        if (DotPos) {
           *DotPos = 0;
        }
        else {
            return(InFile->attr[AttrNum]->class_name);
        }
        strcpy(ClassName,AttrName);
        strcpy(ClassName,userRequest->getClassName(ClassName)); 
     
        return(ClassName);
     }
     if (InFile->attr[AttrNum]->class_name[0])
        return InFile->attr[AttrNum]->class_name;
     return NULL;
}

int GetRefOid(BULK_SCHEMA *InFile, int ObjNum, int AttrNum, BULK_SCHEMA *RetDescr) {
USERDESC *userdesc1,*userdesc2;
OID       retOid, *MatOID;
OBJHDR    oh;
int       i, refoffset;
SCANDESC  *seqscandesc;
BOOL      eof = FALSE;
int       TotLen1;
char      *outbuf;
int       ObjTypeId;
       

  if((e = sm_OpenBufferGroup(INDGRPSIZE, BF_MRU, &seqGroup, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group ");
       return(FALSE);
  }
  if((e = sm_CreateFile(seqGroup,volid,&RetDescr->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create File (GetRefOid)");
		return(FALSE);
	}

  if((e = sm_OpenScanWithGroup(&InFile->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (PTR_HH_join)");
		return(FALSE);
	}

  TotLen1 = InFile->record_width;
  outbuf = (char *) malloc(TotLen1);
  refoffset =  InFile->attr[AttrNum]->offset; 
  for(i=1;(i<ObjNum) && (!eof);++i) {
      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (GetRefOid)");
        return(FALSE);
      }
  }
  memcpy((void *)outbuf,(void *)(userdesc1->basePtr),TotLen1);
  MatOID = (OID *)(outbuf+refoffset);
  if ((e = sm_ReadObject(seqGroup,MatOID,0,READ_ALL,&userdesc2)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not read object (GetRefOid)"); 
     return(FALSE);
  }
  if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)(userdesc2->basePtr),&retOid)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, " can not create object (GetRefOid)");
     return(FALSE);
  }

  if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not release object (GetRefOid)"); 
     return(FALSE);
   }

   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (GetRefOid)");
       return(FALSE);
   }

   if((e = sm_CloseBufferGroup(seqGroup)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
   }

   free(outbuf);
   return(TRUE);
} /* GetRefOid */

int GetDBObject(BULK_SCHEMA *InFile, int ObjNum, int AttrNum, BULK_SCHEMA *RetDescr) {
USERDESC *userdesc1,*userdesc2;
OID       retOid;
OBJHDR    oh;
int       i, refoffset;
SCANDESC  *seqscandesc;
BOOL      eof = FALSE;
int       TotLen1;
char      *outbuf;
int       ObjTypeId;
       

  if((e = sm_OpenBufferGroup(INDGRPSIZE, BF_MRU, &seqGroup, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group ");
       return(FALSE);
  }
  if((e = sm_CreateFile(seqGroup,volid,&RetDescr->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create File (GetDBObject)");
		return(FALSE);
	}

  if((e = sm_OpenScanWithGroup(&InFile->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (PTR_HH_join)");
		return(FALSE);
	}

  TotLen1 =  InFile->attr[AttrNum]->attr_width;
  outbuf = (char *) malloc(TotLen1);
  refoffset =  InFile->attr[AttrNum]->offset; 
  for(i=1;(i<ObjNum) && (!eof);++i) {
      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (GetDBObject)");
        return(FALSE);
      }
  }
  memcpy((void *)outbuf,(void *)(userdesc1->basePtr+refoffset),TotLen1);
  if((e = sm_CreateObject(seqGroup,&RetDescr->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,RetDescr->record_width,(void*)(outbuf),&retOid)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, " can not create object (GetDBObject)");
     return(FALSE);
  }

   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (GetDBObject)");
       return(FALSE);
   }

   if((e = sm_CloseBufferGroup(seqGroup)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
   }

   free(outbuf);
   return(TRUE);
} /* GetDBObject */


int ExecVoidFcn(BULK_SCHEMA *InFile, int ObjNum, int AttrNum) {
USERDESC *userdesc1,*userdesc2;
OID       retOid, *MatOID;
OBJHDR    oh;
int       i, refoffset;
SCANDESC  *seqscandesc;
BOOL      eof = FALSE;
int       TotLen1;
char      *outbuf;
int       ObjTypeId;
       

  if((e = sm_OpenBufferGroup(INDGRPSIZE, BF_MRU, &seqGroup, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group ");
       return(FALSE);
  }

  if((e = sm_OpenScanWithGroup(&InFile->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (PTR_HH_join)");
		return(FALSE);
	}

  TotLen1 = InFile->record_width;
  outbuf = (char *) malloc(TotLen1);
  refoffset =  InFile->attr[AttrNum]->offset; 
  for(i=1;(i<ObjNum) && (!eof);++i) {
      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (GetRefOid)");
        return(FALSE);
      }
  }
  memcpy((void *)outbuf,(void *)(userdesc1->basePtr),TotLen1);
  MatOID = (OID *)(outbuf+refoffset);
  if ((e = sm_ReadObject(seqGroup,MatOID,0,READ_ALL,&userdesc2)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not read object (GetRefOid)"); 
     return(FALSE);
  }

  InpArr[0] = userdesc2->basePtr;

  ExecuteTerm(VoidFcn[InFile->attr[AttrNum]->unique]);
  if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
     userRequest->setError(EXODUS_ERROR, e, "can not release object (GetRefOid)"); 
     return(FALSE);
   }

   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (GetRefOid)");
       return(FALSE);
   }

   if((e = sm_CloseBufferGroup(seqGroup)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
   }


   free(outbuf);
   return(TRUE);
} /* ExecVoidFcn */

int UnnestList(BULK_SCHEMA *InFile, int ObjNum, int AttrNum, BULK_SCHEMA *OutFile) {
        USERDESC *userdesc1, *userdesc2;
        OID       retoid;
        OBJHDR    oh;
        int       i, SetOffset;
        SCANDESC  *seqscandesc;
        BOOL      eof = FALSE;
        CatBOOLEAN   stat;
        int       TotLen;
        char      *outbuf;
        Set       *SetAttr;
        List      *ListAttr;
        int       AttrType;
        int       elemtype, elemnum;


  if((e = sm_OpenBufferGroup(INDGRPSIZE, BF_MRU, &seqGroup, NOFLAGS)) != esmNOERROR){
       userRequest->setError(EXODUS_ERROR, e, " can not open Buffer group ");
       return(FALSE);
  }
  if((e = sm_CreateFile(seqGroup,volid,&OutFile->fid)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not create File (GetRefOid)");
		return(FALSE);
	}

  if((e = sm_OpenScanWithGroup(&InFile->fid, PHYSICAL_SCAN, seqGroup, &seqscandesc, NULL)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, " can not open scan group");
		return(FALSE);
	}

  if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
		userRequest->setError(EXODUS_ERROR, e, "can not scan next object (PTR_HH_join)");
		return(FALSE);
	}

  AttrType = InFile->attr[AttrNum]->attr_type;
  TotLen = InFile->record_width;
  outbuf = (char *) malloc(TotLen);
  SetOffset =  InFile->attr[AttrNum]->offset; 
  for(i=1;(i<ObjNum) && (!eof);++i) {
      if((e = sm_ScanNextObject(seqscandesc, 0, READ_ALL, &userdesc1, &eof)) != esmNOERROR) {
        userRequest->setError(EXODUS_ERROR, e, " can not scan next object (UnnestList)");
        return(FALSE);
      }
  }

  if (AttrType == SET) {
     SetAttr = new Set((OID *)(userdesc1->basePtr+SetOffset),&elemtype,&elemnum,&Flag);
     if (Flag) {
        userRequest->setError(SET_ERROR,e,"Error in getting set (Unnest)");
        return(FALSE);
     }

     if ((e = SetAttr->getFirst(&retoid,&stat)) != esmNOERROR) {
        userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
        return(FALSE);
     }
     while (!stat) {
        
        if ((e = sm_ReadObject(seqGroup,&retoid,0,READ_ALL,&userdesc2)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not read object (GetRefOid)"); 
           return(FALSE);
        }
        if((e = sm_CreateObject(seqGroup,&OutFile->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,OutFile->record_width,(void*)(userdesc2->basePtr),&retoid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create object (GetRefOid)");
          return(FALSE);
        }
        if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not release object (GetRefOid)"); 
           return(FALSE);
        }
        SetAttr->getNext(&retoid,&stat);
      }
   }
   else if (AttrType == LIST) {
      ListAttr = new List((OID *)(userdesc1->basePtr+SetOffset),&elemtype,&elemnum,&Flag);
      if (Flag) {
         userRequest->setError(SET_ERROR,e,"Error in getting set (Unnest)");
         return(FALSE);
      }

      if ((e = ListAttr->getFirst(&retoid,&stat)) != esmNOERROR) {
         userRequest->setError(SET_ERROR,e,"Error in getting oid (deref)");
         return(FALSE);
      }
      while (!stat) {
        if ((e = sm_ReadObject(seqGroup,&retoid,0,READ_ALL,&userdesc2)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not read object (GetRefOid)"); 
           return(FALSE);
        }
        if((e = sm_CreateObject(seqGroup,&OutFile->fid,NEAR_FIRST_PHYSICAL,NULL,&oh,OutFile->record_width,(void*)(userdesc2->basePtr),&retoid)) != esmNOERROR) {
          userRequest->setError(EXODUS_ERROR, e, " can not create object (GetRefOid)");
          return(FALSE);
        }
      	if ((e = sm_ReleaseObject(userdesc2)) != esmNOERROR) {
           userRequest->setError(EXODUS_ERROR, e, "can not release object (GetRefOid)"); 
           return(FALSE);
        }
        ListAttr->getNext(&retoid,&stat);
      }
   }
   if((e = sm_CloseScan(seqscandesc)) != esmNOERROR) {
       userRequest->setError(EXODUS_ERROR, e, "can not close scan descriptor (UnnestList)");
       return(FALSE);
   }

   if((e = sm_CloseBufferGroup(seqGroup)) != esmNOERROR){
      userRequest->setError(EXODUS_ERROR, e, "can not close buffer group ");
      return(FALSE);
   }
   free(outbuf);
   return(TRUE);
}

BULK_SCHEMA *FindRef(BULK_SCHEMA *InFile, int ObjNum, int AttrNum) {
Catalog CurCat;
AttrList *CurAttrList, *AList;
char ClassName[MAXSTRLEN], AttrName[MAXSTRLEN], AttrName1[MAXSTRLEN],
     *DotPos, *DotPos1;
CatBOOLEAN Flag;
int i;
BULK_SCHEMA *RetSchema;
TID TranId;

     if (InFile->attr[AttrNum]->attr_type == SIGN_VOID) {
        ExecVoidFcn(InFile,ObjNum,AttrNum);
        sm_CommitTransaction(TranId);
        return((BULK_SCHEMA *)-1);
     }
     strcpy(AttrName,InFile->attr[AttrNum]->name);
     DotPos = strchr(AttrName,'.'); 
     if (DotPos) {
        *DotPos = 0;
        strcpy(ClassName,AttrName);
        strcpy(ClassName,userRequest->getClassName(ClassName));
     }

     DotPos1 = NULL;

     if (DotPos) {
        DotPos1 = strchr(DotPos+1,'.');
        if (DotPos1)
           *DotPos1 = 0;
        strcpy(AttrName1,DotPos+1);
     }
     else
        strcpy(AttrName1,AttrName);
     
     if (!strcmp(AttrName1,"self")) {
        return((BULK_SCHEMA *)-1);
     }

     strcpy(ClassName,InFile->attr[AttrNum]->class_name);

     MoodsTypes Mtype;

     RetSchema = (BULK_SCHEMA *) malloc(sizeof(BULK_SCHEMA));
     Mtype.getClassInfo(ClassName, &CurCat, &CurAttrList, &Flag);
     copyToRelSchema(RetSchema,&DummyReq,&CurCat, CurAttrList);
     switch(InFile->attr[AttrNum]->attr_type) {
     case REF :
                if (GetRefOid(InFile,ObjNum,AttrNum,RetSchema)) {
                   return(RetSchema);
                }
                else {
                   return(NULL);
                }
     case SET  :
     case LIST :
                if (UnnestList(InFile,ObjNum,AttrNum,RetSchema)) {
                   return(RetSchema);
                }
                else {
                   return(NULL);
                }
                        
      case DB_TYPE :
                if (GetDBObject(InFile,ObjNum,AttrNum,RetSchema)) {
                   return(RetSchema);
                }
                else {
                   return(NULL);
                }
    }
    return((BULK_SCHEMA *)-1);
}

