#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>
#include "sign.h"

char *FindSignature::EatSpace(char *p) {
     while (*p == ' ') p++;
     return p;
}


void FindSignature::InsertModList(int mod, int vecsize) {

   Type = (ModType *) malloc(sizeof(ModType));
   Type->Modifier = mod;
   Type->vecsize = vecsize;
   Type->next = NULL;
   if (ModTypeHead) {
      backtype->next = Type;
      backtype = Type;
   }
   else
      ModTypeHead = backtype = Type;
}



int FindSignature::check(ArgType *type1, ArgType *type2) {

   ModType *p, *q;

   if (type1->base != type2->base)
      return 0;
   if (type1->base == COBJ)
      if (strcmp(type1->BaseName,type2->BaseName))
         return 0;
   p = type1->ModHead;
   q = type2->ModHead;
 
   while (p && q) {
      if ((p->Modifier == q->Modifier) && (p->vecsize == q->vecsize)) {
         p=p->next;
         q=q->next;
      }
      else
         return 0;
   }
   if (p || q)
      return 0;
   return 1;
}
 
int FindSignature::GetBase(char *BaseStr) {

  switch(BaseStr[0]) {
    case 'i' : if (strcmp(BaseStr,"int"))
                  return COBJ;
               return INTEGER;
    case 'b' : if (strcmp(BaseStr,"boolean"))
                  return COBJ;
               return CHAR;
    case 'l' : if (strcmp(BaseStr,"long"))
                  return COBJ;
               return LONG;
    case 'f' : if (strcmp(BaseStr,"float"))
                  return COBJ;
               return FLOAT;
    case 'd' : if (strcmp(BaseStr,"double"))
                  return COBJ;
               return DOUBLE;
    case 'u' : if (strcmp(BaseStr,"unsigned"))
                  return COBJ;
               return UNSIGNED;
    case 'e' : if (strcmp(BaseStr,"enum"))
                  return COBJ;
               return ENUM;
    case 'v' : if (strcmp(BaseStr,"void"))
                  return COBJ;
               return SIGN_VOID;
    case 's' : if (!strcmp(BaseStr,"short"))
                  return SHORT;
               if (!strcmp(BaseStr,"string"))
                  return STRING;
               return COBJ;
    case 'c' : if (strcmp(BaseStr,"char"))
                  return COBJ;
               return CHAR;
    default   : return COBJ;
   }
}

FindSignature::FindSignature(char *Inp) {

   FuncType *func;
   ArgType  *Current, *Last;
   char *q;
   char* typebuf, *Out;
   char* vecsize;
   char Buf[50];
   ArgType *forward;
   int x,len ,i;
   static char OutBuf[256];

     func = (FuncType *) malloc(sizeof(FuncType));
     Inp = EatSpace(Inp);
     if (q=strchr(Inp,':')) {
        func->ClName = (char *)malloc(q-Inp+1);
        strncpy(func->ClName,Inp,q-Inp);
        func->ClName[q-Inp] = 0;
        Inp = q+2;
     }
     else
        func->ClName = 0;
     q = Buf;
     Inp = EatSpace(Inp);
     while ((*Inp) && (*Inp != ' ') && (*Inp!='('))
        *q++ = *Inp++;

     if (!(*Inp)) {
        Signature[0] = 0;
        return;
     }

     *q = 0;
     func->FuncName = (char *)malloc(strlen(Buf)+1);
     strcpy(func->FuncName,Buf);

     Inp = EatSpace(Inp);

     Inp++;

     Current = Last = NULL;
     backtype = Type = NULL;
     ModTypeHead = NULL;
     ArgTypeHead = NULL;

     typebuf = Buf;
     while(*Inp) {
        switch (*Inp) {
            case '&' : InsertModList(REF,0);
                       Inp++;
                       break;
            case '*' : InsertModList(PTR,0);
                       Inp++;
                       break;
            case '[' : q=strchr(Inp,']');
                       vecsize = (char *)malloc(q-Inp);
                       strncpy(vecsize,Inp+1,q-Inp-1);
                       vecsize[q-Inp] = 0;
                       InsertModList(VEC,atoi(vecsize));
                       Inp = q+1;
                       break;
            case ' ' : Inp = EatSpace(Inp);
                       break;
            case ')' : 
            case ',' : if (typebuf == Buf)
                          func->ArgHead = NULL;
                       else {
                          Current = (ArgType *) malloc(sizeof(ArgType));
                          if (ArgTypeHead) {
                             Last->next = Current;
                             Last = Current;
                          }
                          else {
                             ArgTypeHead = Last = Current;
                          }
                          *typebuf = 0;
                       
                          strcpy(Current->BaseName,Buf);
                          Current->base = GetBase(Buf);
                          typebuf = Buf;
                          Current->ModHead = ModTypeHead;
                          Current->next = NULL;
                          ModTypeHead = Type  = backtype = NULL;
                       }
                       Inp++;
                       break;
              default : *typebuf++ = *Inp++;
        }
     } /* While */
     func->ArgHead = ArgTypeHead;
     typebuf = OutBuf; 
     if (func->ClName) {
        if (strcmp(func->ClName,func->FuncName))  {
           strcpy(typebuf,func->FuncName);
           typebuf += strlen(func->FuncName);
        }
        else {
           strcpy(typebuf,"__ct");
           typebuf += 4;
        }
        *typebuf++='_';
        *typebuf++='_';
        len = strlen(func->ClName);
        if (len/10)    
           *typebuf++ = '0'+len/10;
        *typebuf++ = '0' + len%10;
        strcpy(typebuf,func->ClName);
        typebuf += strlen(func->ClName);
     }
     else {
        strcpy(typebuf,func->FuncName);
        typebuf += strlen(func->FuncName);
        *typebuf++='_';
        *typebuf++='_';
     }
     *typebuf++ = 'F';
     Out = typebuf;
     if (func->ArgHead) {
        Current = func->ArgHead;
        for(;Current;Current = Current->next) {
           i = 0;
           for(Last = func->ArgHead;Last!=Current;Last=Last->next) {
              i++;
              if (check(Last,Current)) {
                 x = 1;
                 forward = Current;
                 while ((forward=forward->next) && x<9) {
                       if (check(forward,Current)) {
                          x++;
                          Current = forward;
                       }
                       else
                          break;
                 }
                 if (x==1)
                    *Out++ = 'T';
                 else {
                    *Out++ = 'N';
                    *Out++ = '0'+x;
                 }
                 if (9<i)
                    *Out++ = '0'+i/10;
                 *Out++ = '0'+i%10;
                 goto label1;
              }
          }  /* 2nd for */
          Type = Current->ModHead;
          while(Type) {
              switch(Type->Modifier) {
                 case VEC : if (Type->vecsize) {
                               *Out++ = 'A';
                               sprintf(Out,"%d\0",Type->vecsize);
                               while(*++Out);
                               *Out++ = '_';
                            }
                            else
                               *Out++ = 'P';
                            Type = Type->next;
                            break;
                 case PTR : *Out++ = 'P';
                            Type = Type->next;
                            break;
                 case REF : *Out++ = 'R';
                            Type = Type->next;
                            break;
              }
          }
          switch(Current->base) {
             case SIGN_VOID : *Out++ = 'v';
                         break;
             case CHAR : *Out++ = 'c';
                         break;
             case SHORT : *Out++ = 's';
                         break;
             case INTEGER  : *Out++ = 'i';
                         break;
             case LONG : *Out++ = 'l';
                         break;
             case FLOAT : *Out++ = 'f';
                         break;
             case DOUBLE : *Out++ = 'd';
                         break;
             case STRING : *Out++ = 'P';
                           *Out++ = 'c';
                         break;
             case COBJ : typebuf = Current->BaseName;
                         if (strstr(typebuf,"struct"))
                            if (strlen(Current->BaseName) == 6)
                                typebuf += 6;
                         x = strlen(typebuf);
                         if (x/10)
                            *Out++ = '0'+x/10;
                         *Out++ = '0'+x%10;
                         while (*Out++ = *typebuf++);
                         Out--;
                         break;
         }
   label1:;
  } /* First For */
  } /* if */
  else
    *Out++ = 'v';
  *Out = 0;
  strcpy(Signature,OutBuf);
}

FindSignature::FindSignature(char *clname, char *fcnname, int *args) {

   FuncType *func;
   ArgType  *Current, *Last;
   char *q;
   char* typebuf, *Out;
   char* vecsize;
   char Buf[50];
   ArgType *forward;
   int x,len ,i;
   static char OutBuf[256];

     func = (FuncType *) malloc(sizeof(FuncType));
     func->ClName = clname;
     q = Buf;
     func->FuncName = fcnname;

     Current = Last = NULL;
     backtype = Type = NULL;
     ModTypeHead = NULL;
     ArgTypeHead = NULL;

     typebuf = Buf;
     for(i=0;args[i];++i) {
         Current = (ArgType *) malloc(sizeof(ArgType));
         if (ArgTypeHead) {
            Last->next = Current;
            Last = Current;
         }
         else {
            ArgTypeHead = Last = Current;
         }
         Current->base = args[i];
         Current->next = NULL;
     } /* for */
     func->ArgHead = ArgTypeHead;
     func->ArgHead->ModHead = NULL; // Only for this version
     typebuf = OutBuf; 
     if (func->ClName[0]) {
        if (strcmp(func->ClName,func->FuncName))  {
           strcpy(typebuf,func->FuncName);
           typebuf += strlen(func->FuncName);
        }
        else {
           strcpy(typebuf,"__ct");
           typebuf += 4;
        }
        *typebuf++='_';
        *typebuf++='_';
        len = strlen(func->ClName);
        if (len/10)    
           *typebuf++ = '0'+len/10;
        *typebuf++ = '0' + len%10;
        strcpy(typebuf,func->ClName);
        typebuf += strlen(func->ClName);
     }
     else {
        strcpy(typebuf,func->FuncName);
        typebuf += strlen(func->FuncName);
        *typebuf++='_';
        *typebuf++='_';
     }
     *typebuf++ = 'F';
     Out = typebuf;
     if (func->ArgHead) {
        Current = func->ArgHead;
        for(;Current;Current = Current->next) {
           i = 0;
           for(Last = func->ArgHead;Last!=Current;Last=Last->next) {
              i++;
              if (check(Last,Current)) {
                 x = 1;
                 forward = Current;
                 while ((forward=forward->next) && x<9) {
                       if (check(forward,Current)) {
                          x++;
                          Current = forward;
                       }
                       else
                          break;
                 }
                 if (x==1)
                    *Out++ = 'T';
                 else {
                    *Out++ = 'N';
                    *Out++ = '0'+x;
                 }
                 if (9<i)
                    *Out++ = '0'+i/10;
                 *Out++ = '0'+i%10;
                 goto label1;
              }
          }  /* 2nd for */
          Type = Current->ModHead;
          while(Type) {
              switch(Type->Modifier) {
                 case VEC : if (Type->vecsize) {
                               *Out++ = 'A';
                               sprintf(Out,"%d\0",Type->vecsize);
                               while(*++Out);
                               *Out++ = '_';
                            }
                            else
                               *Out++ = 'P';
                            Type = Type->next;
                            break;
                 case PTR : *Out++ = 'P';
                            Type = Type->next;
                            break;
                 case REF : *Out++ = 'R';
                            Type = Type->next;
                            break;
              }
          }
          switch(Current->base) {
             case SIGN_VOID : *Out++ = 'v';
                         break;
             case CHAR : *Out++ = 'c';
                         break;
             case SHORT : *Out++ = 's';
                         break;
             case INTEGER  : *Out++ = 'i';
                         break;
             case LONG : *Out++ = 'l';
                         break;
             case FLOAT : *Out++ = 'f';
                         break;
             case DOUBLE : *Out++ = 'd';
                         break;
             case STRING : *Out++ = 'P'; // Burasi sonradan eklendi
                           *Out++ = 'c';
                         break;
             case COBJ : typebuf = Current->BaseName;
                         if (strstr(typebuf,"struct"))
                            if (strlen(Current->BaseName) == 6)
                                typebuf += 6;
                         x = strlen(typebuf);
                         if (x/10)
                            *Out++ = '0'+x/10;
                         *Out++ = '0'+x%10;
                         while (*Out++ = *typebuf++);
                         Out--;
                         break;
         }
   label1:;
  } /* First For */
  } /* if */
  else
    *Out++ = 'v';
  *Out = 0;
  strcpy(Signature,OutBuf);
}

