#include "mood_catalog.h"
#include "keywords.h"

int Sequence::setIncr(int Pincr, CatBOOLEAN *PStatus) 
{
	int err;

	if ( ( Pincr ) <  ( ( maxval - minval ) * INCR_MULTIPLIER ) ) {

		mscat_ReadObject( SeqId, "increment read");

		increment = Pincr ;
		SeqIntern.increment = Pincr ;

		mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "increment write");

		mscat_ReleaseObject("releasing sequence object");

	} else *PStatus = 1 ;

	return TRUE;
}
     
int Sequence::setInitial(int Pinit) 
{
	int err;

	mscat_ReadObject( SeqId, "init read");

	initial = Pinit ;
	SeqIntern.initial = Pinit ;

	mscat_WriteObject(sizeof(SeqTemp), &SeqIntern,"init write");

	mscat_ReleaseObject("release object of set initial");

	return TRUE;
}

int Sequence::setCycOff() 
{
	int err;

	mscat_ReadObject( SeqId, "cyclic read");

	cyclic = 'N' ;
	SeqIntern.cyclic = 'N' ;

	mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "cyclic write");

	mscat_ReleaseObject( "release object in cyc off");

	return TRUE;
}

int Sequence::setCycOn() 
{
	int err;
     
	mscat_ReadObject( SeqId, "cyclic on read");

	cyclic = 'Y' ;
	SeqIntern.cyclic = 'Y' ;

	mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "cyclic on write");

	mscat_ReleaseObject( "release object of cycle on");

	return TRUE;
}

int Sequence::setMinVal(int Pminval, CatBOOLEAN *PStatus) 
{
	int err;

	if ( Pminval < maxval ) {

		mscat_ReadObject( SeqId, "minval read");

		minval = Pminval ;
		SeqIntern.minval = Pminval ;

		if ( minval >= curval ) { 
			curval = minval ;
			SeqIntern.minval = minval ;
		}

		mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "minval write");
		mscat_ReleaseObject( "release object in min value");
	} else *PStatus = 1 ;
	return TRUE;
}

int Sequence::setMaxVal(int Pmaxval, CatBOOLEAN *PStatus) 
{
	int err;

	if ( Pmaxval > minval ) {

		mscat_ReadObject( SeqId, "maxval read");

		maxval = Pmaxval ;
		SeqIntern.maxval = Pmaxval ;

		if ( maxval < curval ) 
			if ( cyclic == 'Y' ) {
				curval = minval ;
				SeqIntern.curval = minval ;
			}
			else {
				curval = maxval ;
				SeqIntern.curval = maxval ;
			}

		mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "maxval write");
		mscat_ReleaseObject( "release object in max val of sequence");
	} else *PStatus = 1 ;

	return TRUE;
}

int  Sequence::getCurVal( int *currentValue ) 
{
     int err;

     mscat_ReadObject( SeqId, "nextval read");
     
     memcpy(&SeqIntern, UserDesc->basePtr, sizeof(SeqTemp));
     curval = SeqIntern.curval ;
     mscat_ReleaseObject( "release object in get current value of sequence");
     *currentValue = curval;
     return TRUE;
}

int  Sequence::getNextVal(int *nextValue, CatBOOLEAN *PStatus) 
{
	int err;
     
	mscat_ReadObject( SeqId, "nextval read");
     
	memcpy(&SeqIntern, UserDesc->basePtr, sizeof(SeqTemp));
     
	if ( (SeqIntern.curval + SeqIntern.increment) <=  (SeqIntern.maxval) ) {
		SeqIntern.curval = SeqIntern.curval + SeqIntern.increment ;
		curval = SeqIntern.curval ;

		mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "nextval write");

		*PStatus = 0 ;
		*nextValue = curval;
		return TRUE;
	} 
	else if ( SeqIntern.cyclic == 'Y' )  {
		SeqIntern.curval = SeqIntern.minval ;
		*PStatus = 0 ;
	} else *PStatus = 1 ;

	curval = SeqIntern.curval ;
	mscat_WriteObject( sizeof(SeqTemp), &SeqIntern, "nextval write");

	mscat_ReleaseObject( "nextval release object");

	*nextValue = curval;
	return TRUE;
}

int Sequence::delSeq(CatBOOLEAN *status) 
{
	int err;

	mscat_DestroyObject( SeqId, "delete sequence");

	*status = 0;
	printf("sequence destroyed successfully\n") ;

	return TRUE;

}

int Sequence::initSequence(FID *SeqFile,char *Pseqname,CatBOOLEAN *Pstatus) 
{
	int      DataSize;
	int      err;
	short    SearchFlag = 0;
	CatBOOLEAN  eof;

        //   search for the sequence table...

	if( !ms_LocateObject( SeqFile, CHAR, Pseqname, 0, &SeqId )) return FALSE;
	
	if( ( OID_IS_INVALID( SeqId ))){
		*Pstatus = 1;
		return TRUE;
	}

        mscat_ReadObject( SeqId, "seq.cons.read.obj");

	memcpy(&SeqIntern,UserDesc->basePtr,sizeof(SeqTemp));
	strcpy(seqname,Pseqname);
	initial   = SeqIntern.initial   ;
	minval    = SeqIntern.minval    ;
	maxval    = SeqIntern.maxval    ;
	cyclic    = SeqIntern.cyclic    ;
	increment = SeqIntern.increment ;
	curval    = SeqIntern.curval    ;

	mscat_ReleaseObject("release object"); 

 	return TRUE;
         
}

/****************** OMIT IT LATER

// Create a sequence with the given parameters .....

int Sequence::initSequence( FID *SeqFile, char *Pseqname, int Pinit, int Pmin, int Pmax, 
                   char Pcyc, int Pinc,CatBOOLEAN *PStatus) 
{
	int      DataSize;
	FID      SeqFile ;
	OID      SeqOid ;
	int      err;
	short    SearchFlag = 0;
	CatBOOLEAN     eof;

         
           if ( strchr("YyNn",Pcyc) == NULL ) Pcyc = 'N' ; 
         
           //  search for the required sequence in the sequence file .....

           // There is no sequence file created , so create a new one...
                printf("Creating Sequence Database...\n");
		mscat_CreateFile( SeqFile, "Seq.cons.create.file");

                err = sm_SetRootEntry(VolumeId, SEQFILE, (char *)&SeqFile, sizeof(FID)); 
                ErrorCheck(err,"Seq.cons.set.root");
                SearchFlag = 1 ; // No need for any search yet !!!!...

           if ( !SearchFlag ) {    // search sequence in file ......
                printf("searching sequence \n");  
                err = sm_GetFirstOid(BufferGroup,&SeqFile,&SeqId,&ObjectHeader,
                                     &eof);
                ErrorCheck(err,"Seq.cons.first.oid");

                SearchFlag = 1 ; // if not found in file create sequence .. 

                if (!eof)  { // if file is not empty ........
                    do   { // search if there is a sequence with given name !!!
		         mscat_ReadObject( SeqId,"seq.cons.read.obj"); 

                         memcpy(&SeqIntern,UserDesc->basePtr,sizeof(SeqTemp));

                         if ( !strcmp(SeqIntern.seqname,Pseqname) ) {
                              *PStatus = 1 ;   //is a sequence same  name.... 
                              SearchFlag = 0 ;
                              eof = 1 ; // exit from loop ....
                         }    
			 mscat_ReleaseObject("release object"); 

                         err = sm_GetNextOid(BufferGroup, &SeqId, &SeqOid, 
                                             &ObjectHeader, &eof);
                         ErrorCheck(err,"next object");
                         memcpy(&SeqId, &SeqOid, sizeof(OID));
                       
                    } while (eof == 0); // check from esm document.....
                } ;	
           };

           if ( SearchFlag ) { // OK. create sequence....
                strcpy(SeqIntern.seqname,Pseqname);
                SeqIntern.initial   = Pinit;
                SeqIntern.minval    = Pmin ;
                SeqIntern.maxval    = Pmax ;
                SeqIntern.cyclic    = Pcyc ;
                SeqIntern.increment = Pinc ;
                SeqIntern.curval    = Pinit;

		mscat_CreateObject(SeqFile, sizeof(SeqTemp),&SeqIntern , &SeqOid, "create sequence");

                memcpy(&SeqId,&SeqOid,S_OID);
           }

     return TRUE;

}
***************************/
