#include "libMv.h"


/* Create a Form widget that has a label on the left and a Text
 * widget to the right.  Attach perimeter edges to form.
 * We use it twice in the program, so make a function out of it.
 */
Widget CreateLabeledTextForm(Widget parent,char *label_name,char *text_name,char *def_text
)
{
    Widget form, label, ret;
 
    form = XtVaCreateWidget(NULL, xmFormWidgetClass, parent,
        XmNorientation,      XmHORIZONTAL,
        NULL);
    label = XtVaCreateManagedWidget(label_name, xmLabelGadgetClass, form,
        XmNleftAttachment,   XmATTACH_FORM,
        XmNtopAttachment,    XmATTACH_FORM,
        XmNbottomAttachment, XmATTACH_FORM,
        NULL);
    ret = XtVaCreateManagedWidget(text_name, xmTextWidgetClass, form,
        XmNleftAttachment,   XmATTACH_WIDGET,
        XmNleftWidget,       label,
        XmNtopAttachment,    XmATTACH_FORM,
        XmNrightAttachment,  XmATTACH_FORM,
        XmNbottomAttachment, XmATTACH_FORM,
        XmNvalue,            def_text,
        NULL);
    XtManageChild(form);
 
    return ret;
}

