#define MENU_EXIT          201
#define MENU_OPEN          202
#define MENU_NEW           203
#define MENU_CLOSE         204
#define MENU_SAVE          205
#define MENU_SAVE_AS       206
#define MENU_PRINT         207
#define MENU_CUT           208
#define MENU_COPY          209
#define MENU_COPY_BY_NAME  210
#define MENU_PASTE         211
#define MENU_PASTE_BY_NAME 212
#define MENU_CLEAR         213
#define DIALOG_FSELECT     300
#define DIALOG_CWARNING    301
#define DIALOG_XWARNING    302
#define DIALOG_NEW         303
#define DIALOG_SAVE        304
#define DIALOG_PRINT       305
#define OPEN_HELP          401
#define NEW_HELP           402

#define GERMAN  0
#define ENGLISH 1

extern Widget text;                 /* Multi-line text widget                */
extern Widget cut_button;           /* Clipboard cut button                  */
extern Widget copy_button;          /* Clipboard copy button                 */
extern Widget copy_by_name_button;  /* Clipboard copy by name button         */
extern Widget paste_button;         /* Clipboard paste button                */
extern Widget paste_by_name_button; /* Clipboard paste by name button        */
extern Widget clear_button;         /* Clipboard clear button                */
extern Widget open_dialog;          /* File selection dialog                 */
extern Widget new_dialog;           /* File name prompt dialog               */
extern Widget close_warning;        /* Special internal selection dialog     */
extern Widget exit_warning;         /* Special internal selection dialog     */
extern Widget general_warning;      /* Warning dialog                        */
extern Widget save_dialog;          /* Save as prompt dialog                 */
extern Widget print_warning;        /* Warning dialog                        */
extern Boolean file_saved;          /* Indicates the present file is saved   */
extern char *filename;              /* String containing file name           */
extern char *text_buffer;           /* Buffer for text widget text value     */
extern int start_pos, end_pos;      /* Start and end position of last action */
extern Boolean by_name;             /* Copy by name flag                     */
extern XmStringCharSet charset;
extern char Error[128];

// Function Prototypes
//-----------------------------------------------------------------------------

void     FileChangedCB (Widget w, XtPointer client_data,XtPointer call_data);
//void     VersionCB (Widget w,XtPointer client_data,XtPointer call_data);
void     AcceptQueryCB (Widget w,Widget client_data,XtPointer call_data);
void     ClearCB (Widget w,Widget client_data,XmDrawingAreaCallbackStruct *cbs);
void     DialogApplyCB (Widget w, XtPointer client_data,XtPointer  call_data);
void     DialogCancelCB (Widget w, XtPointer client_data,XtPointer  call_data);
void     DialogAcceptCB (Widget w, XtPointer client_data,XtPointer  call_data);
void     CopyByName(Widget widget,unsigned long * dataid,int *, int *);
void     CopyFileToClipboard(Time time);
void     PasteItemFromClipboard();
void     PasteByName();
void     VersionCBQ (Widget w,XtPointer client_data,XtPointer call_data);
void     DialogHelpCB (Widget w, XtPointer client_data,XtPointer  call_data);
void     HelpCBQ (Widget w, XtPointer client_data,XtPointer  call_data);
void     MenuCB (Widget w, XtPointer client_data,XtPointer  call_data);
void     SaveFileCB (Widget w, XtPointer client_data, XtPointer call_data);
void     CloseFile();
void     fn_VersionCB (Widget w,XtPointer client_data,XtPointer call_data);
void     fn_HelpCB (Widget w,XtPointer client_data,XtPointer call_data);
void     fn_quitCB (Widget w,XtPointer client_data,XtPointer call_data);
void     fn_create_help();
void     Display_Error(char *err_msg);
void     Display_Warning(char *warn_msg);
Widget   CreateSpecialWarningDialog(Widget,String,String,String,ArgList,int);
Widget   CreateBBoard(Widget,Widget);
Widget   CreateHelpQ (Widget parent);
Widget   CreateMenuBar (Widget parent);
Widget   CreateVersionQ (Widget parent);
Widget   fn_CreateHelp (Widget parent);
Widget   fn_CreateVersion();
Widget   fn_CreateVersion (Widget parent);
XtArgVal GetPixel(char *colorstr);
XtArgVal fn_GetPixel(char *colorstr);
XImage * CreateDefaultImage (char *bits, int width,int  height);
static   void CreateText (Widget parent);
Boolean  SaveFile();
Boolean  OpenFile();

