#ifndef __CLASSDDL_H
#define __CLASSDDL_H

#include "mood_catalog.h"
#include <string.h>
#include "userreq.h"
#include "reqroot.h"
#include "keywords.h"
#include "linklist.h"

typedef char msBOOLEAN;


/*  list of the member types represented as an enumerated type */
typedef enum 
	{ 	cpINT, 
		cpFLOAT, 
		cpBOOLEAN, 
		cpCHAR, 
		cpTUPLE, 
		cpSET, 
		cpLIST, 
		cpREF,
                cpSTRING } memberType;

	
enum my_types{ INT=1, FLT, BL, CHR, STR, TPL=9, ST, LST, RF };

/****************************************************************************

	ClassCreate keeps all information about CREATE INDEX statement

****************************************************************************/



class ClassCreate : public RequestRoot
{
public :
	char 		className[MAXSTRLEN]; // name of the class 
        LinkedList      *inheritList;
        memberNode      *members;
	Stack		classStructure;
        int             typeFlag;

			ClassCreate(UserRequest *userReq);
                        ClassCreate(UserRequest *userReg, int flag );
        		~ClassCreate();
	void 		setClassName(char *);
	void 		connectUserRequest();
        int		parse();
	int		createClass();
        int             createClassParser();
	int             typedefClause( memberNode * );
	int             inheritsClause();
	int             parseClassList();
	int             setListRefDef( memberNode * );
	int             tupleDef( memberNode * );
	int             declarationList( memberNode * );
	int             allTypedefClauses( memberNode * );
        int             stringDef( memberNode * );
        int             notReplicated( memberNode *, char * );
	int		semanticCheck( memberNode * );
	void            deleteMembers( memberNode *);
	inherits*       createInheritNode();
	memberNode*     createMemberNode();	
        int             getTypeId( char * );
        void            printMembers();
        void            printMembers( memberNode * );
        void            strup( char * );
};

inline void ClassCreate::setClassName(char *cName)
{
	strcpy(className, cName);
}

inline void ClassCreate::connectUserRequest()
{
	ur->operation     	 = VOID this;
	ur->operationType 	 = CREATE_CLASS;
	ur->operationTypeOnError = CREATE_CLASS;
}




/****************************************************************************

	parses the following statement :

	... [ UNIQUE ]  indexName ON className attributeName [ ASC | DESC ]

*****************************************************************************/

#endif // __CLASSDDL_H
