


/************************************************************************* 

			ABOUT THIS FILE 



Subject	:

	Exodus Storage Manager client functions are overloaded such that
	they handles error.

Author 	: 

	Cetin Ertan Ozkan

Date	: 

	02/03/1993

Last Test Date :

	02/03/1993

Last Revision Date :

	No revision

Related Files :

	sm_client.h  --> exodus storage manager client header file


*************************************************************************/


/************************************************************************

			GENERIC ERROR HANDLER

************************************************************************/

#ifndef __ESMCALL_H
#define __ESMCALL_H

#define HANDLE_ESM_ERROR(_place);\
	if( e != esmNOERROR){\
		setError(EXODUS_ERROR, e, _place);\
		return(FALSE);\
	}\



/************************************************************************

			TRANSACTION OPERATIONS

*************************************************************************/

#define ms_BeginTransaction(_tid, _place);\
	e = sm_BeginTransaction(_a);\
	HANDLE_ESM_ERROR(_place);

#define ms_CommitTransaction(_tid, _place);\
	e = sm_CommitTransaction(_tid);\
	HANDLE_ESM_ERROR(_place);

#define ms_AbortTransaction(_tid, _place);\
	e = sm_AbortTransaction(_tid);\
	HANDLE_ESM_ERROR(_place);

#define ms_SetTransaction(_tid, _place);\
	e = sm_SetTransaction(_tid);\
	HANDLE_ESM_ERROR(_place);




/***************************************************************************

			OBJECT OPERATIONS

***************************************************************************/


#define ms_ReadObject(_groupIndex, _oid, _start, _length, _userDesc, _place);\
	e = sm_ReadObject(_groupIndex, _oid, _start, _length, _userDesc);\
	HANDLE_ESM_ERROR(_place);

#define ms_ReleaseObject(_userDesc, _place);
	e = sm_ReleaseObject(_userDesc);\
	HANDLE_ESM_ERROR(_place);

#define ms_WriteObject(_groupIndex, _start, _length, _data, _userDesc, _release, _place);\
	e = sm_WriteObject(_groupIndex, _start, _length, _data, _userDesc, _release, _place);\
	HANDLE_ESM_ERROR(_place);

#define ms_InsertInObject( _groupIndex, _oid, _start, _length, _data, _place);\
	e = sm_InsertInObject( _groupIndex, _oid, _start, _length, _data);\
	HANDLE_ESM_ERROR(_place);


#define ms_AppendToObject( _groupIndex, -oid, _length, _data, _place);\
	e = sm_AppendToObject( _groupIndex, -oid, _length, _data);\
	HANDLE_ESM_ERROR(_place);


#define ms_DeleteFromObject( _groupIndex, _oid, _start, _length, _place);\
	e = sm_DeleteFromObject( _groupIndex, _oid, _start, _length);\
	HANDLE_ESM_ERROR(_place);

#define ms_ReadObjectHeader( _groupIndex, _oid, _objHdr, _place);\
	e = sm_ReadObjectHeader( _groupIndex, _oid, _objHdr);\
	HANDLE_ESM_ERROR(_place);

#define ms_SetObjectHeader( _groupIndex, _oid, _objHdr, _place);\
	e = sm_SetObjectHeader( _groupIndex, _oid, _objHdr);\
	HANDLE_ESM_ERROR(_place);

#define ms_DestroyObject( _groupIndex, _oid, _place);\
	e = sm_DestroyObject( _groupIndex, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_CreateVersion( _groupIndex, _nearType, _parentObj, _nearObj, _oid, _place);\
	e = sm_CreateVersion( _groupIndex, _nearType, _parentObj, _nearObj, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_FreezeVersion(_groupIndex, _oid, _place);\
	e = sm_FreezeVersion(_groupIndex, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_UnfreezeVersion( -groupIndex, _oid, _place);\
	e = sm_UnfreezeVersion( -groupIndex, _oid );\
	HANDLE_ESM_ERROR(_place);


/****************************************************************************

			FILE OPERATIONS

****************************************************************************/


#define ms_CreateFile(_groupIndex, _volid, _fid, _flags, _place);\
	e = sm_CreateFile(_groupIndex, _volid, _fid, _flags);\
	HANDLE_ESM_ERROR(_place);

#define ms_DestroyFile( _groupIndex, _fid, _place);\
	e = sm_DestroyFile( _groupIndex, _fid);\
	HANDLE_ESM_ERROR(_place);

#define ms_GetFirstOid( _groupIndex, _fid, _oid, _objHdr, _emptyFlag, _place);\
	e = sm_GetFirstOid( _groupIndex, _fid, _oid, _objHdr, _emptyFlag);\
	HANDLE_ESM_ERROR(_place);

#define ms_GetLastOid( _groupIndex, _fid, _oid, _objHdr, _emptyFlag, _place);\
	e = sm_GetLastOid( _groupIndex, _fid, _oid, _objHdr, _emptyFlag);\
	HANDLE_ESM_ERROR(_place);

#define ms_GetNextOid(_groupIndex, _baseOid, _nextOid, _objHdr, _endMarker, _place);\
	e = sm_GetNextOid(_groupIndex, _baseOid, _nextOid, _objHdr, _endMarker);\
	HANDLE_ESM_ERROR(_place);

#define ms_GetPreviousOid( _groupIndex, _baseOid, _prevOid, _objHdr, _endMarker, _place);\
	e = sm_GetPreviousOid( _groupIndex, _baseOid, _prevOid, _objHdr, _endMarker);\
	HANDLE_ESM_ERROR(_place);

#define ms_OpenScanWithGroup( _fid, _type, _groupIndex, _scanDesc, _oid, _place);\
	e = sm_OpenScanWithGroup( _fid, _type, _groupIndex, _scanDesc, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_OpenScan( _fid, _type, _gorupSize, _scanDesc, _oid, _place);\
	e = sm_OpenScan( _fid, _type, _gorupSize, _scanDesc, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_ScanNextObject(_scanDesc, _start, _length, _retDesc, _eof, _place);\
	e = sm_ScanNextObject(_scanDesc, _start, _length, _retDesc, _eof);\
	HANDLE_ESM_ERROR(_place);

#define ms_ScanNextBytes(_scanDesc, _length, _place);\
	e = sm_ScanNextBytes(_scanDesc, _length);\
	HANDLE_ESM_ERROR(_place);

#define ms_CloseScan(_scanDesc, _place);\
	e = sm_CloseScan(_scanDesc);\
	HANDLE_ESM_ERROR(_place);

#define ms_OpenLoad(_fid, _type, _groupSize, _loadDesc, _place);\
	e = sm_OpenLoad(_fid, _type, _groupSize, _loadDesc);\
	HANDLE_ESM_ERROR(_place);

#define ms_LoadNextObject(_loadDesc, _length, _data, _oid, _place);\
	e = sm_LoadNextObject(_loadDesc, _length, _data, _oid);\
	HANDLE_ESM_ERROR(_place);

#define ms_CloseLoad(_loadDesc, _place);\
	e = sm_CloseLoad(_loadDesc);\
	HANDLE_ESM_ERROR(_place);




/****************************************************************************

			INDEX OPERATIONS

****************************************************************************/

#define ms_CreateIndex( _volume, _groupIndex, _ndxType, _datatype, _maxKeyLen, _elSize, _unique, _ndx, _place);\
	e = sm_CreateIndex( _volume, _groupIndex, _ndxType, _datatype, _maxKeyLen, _elSize, _unique, _ndx);\
	HANDLE_ESM_ERROR(_place);

#define ms_DestroyIndex(_ndx, _groupIndex, _place);\
	e = sm_DestroyIndex(_ndx, _groupIndex);\
	HANDLE_ESM_ERROR(_place);

#define ms_InsertEntry(_ndx, _groupIndex, _key, _elem, _place);\
	e = sm_InsertEntry(_ndx, _groupIndex, _key, _elem, _place);\
	HANDLE_ESM_ERROR(_place);

#define ms_RemoveEntry(_ndx, _groupIndex, _key, _elem, _place);\
	e = sm_RemoveEntry(_ndx, _groupIndex, _key, _elem, _place);\
	HANDLE_ESM_ERROR(_place);

#define ms_FetchInit(_ndx, _gi, _b1, _c1, _b2, _c2, _cursor, _place);\
	e = sm_FetchInit(_ndx, _gi, _b1, _c1, _b2, _c2, _cursor);\
	HANDLE_ESM_ERROR(_place);

#define ms_FetchNext(_cursor, _retKey, _retElem, _place);\
	e = sm_FetchNext(_cursor, _retKey, _retElem);\
	HANDLE_ESM_ERROR(_place);

#endif
