#ifndef __KEYWORDS_H
#define __KEYWORDS_H

// define common things
#ifndef NULL
#define NULL    0
#endif
#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0
#endif

// #define DEBUG
#define TOKENSIZE       1000
#define MAXTEXTLENGTH  	30000
#define MS_NOERROR      1
#define MS_ERROR        2
#define MS_WARNING      3
#define MS_MESSAGE      4
#define VOID (void *)
#define NOT_A_KEYWORD      -1


// define keywords of the MOODSQL 
#define ALL              0
#define ANY              1
#define AVG              2
#define AND              3
#define ASC              4
#define BETWEEN          5
#define BY               6
#define MS_BOOLEAN	 7
//#define BJINDEX	   8
#define CREATE           9
#define CLASS           10
#define CLUSTER         11
#define CONTAINS        12
#define COUNT           13
#define CHAR            14
#define DELETE          15
#define DESC            16
#define DESCRIBE        17
#define DISTINCT        18
#define DROP            19
#define EVERY           20
#define MS_EXISTS       21
#define EXIT            22
#define FROM            23
#define FLOAT           24
#define GROUP           25
#define HOST            26
#define INSERT          27
#define ISSUBSET        28
#define INDEX           29
#define INTEGER         30
#define INTERSECT       31
#define INTO            32
#define MSIS            33 
#define LIKE            34
#define LIST            35
#define MINUS           36
#define MIN             37
#ifndef MAX
#define MAX             38
#endif
#define NOT             39
#define NULLVALUE       40
#define OR              41
#define ON              42
#define ORDER           43
#define RUN             44
#define RECURSE         45
#define REF		46
#define MS_SET          47
#define SET		47
#define STRING          48
#define MS_SELECT	49
#define START           50
#define IN              51
#define SUM             52
#define POINTER         53
#define TYPE            54
#define TUPLE           55
#define MS_UNION        56
#define UPDATE          57
#define MS_UNIQUE       58
#define VERSION         59
#define VIEW            60
#define WHERE           61
#define WITH            62
#define BINARY          63
#define MSJOIN          64
#define GET             65
#define SAVE            66
#define PUBLIC          67
#define PRIVATE         68
#define PROTECTED       69
#define VIRTUAL         70
#define EACH            71
#define INHERITS        72
#define NEW      	73
#define HEADER		74
#define FOOTER		75
#define AUTO		76
#define COMMIT		77
#define ABORT		78
#define ROLLBACK	79
#define SAVEPOINT	80
#define HAVING          81
#define HASH            82
#define FOR             83
#define TO              84
#define USE		85
#define DATABASE	86
#define FUNCTION	87
#define BEGIN		88
#define DECLARATION	89
#define USING		90
#define PARAMETERS	91
#define PROTOTYPE	92
#define HIERARCHY	93
#define MS_DISPLAY	94
#define MS_OF		95
#define MS_FCN		96
#define MS_LS		97
#define MS_DB		98
#define MS_DATABASES    99
#define MS_FUNCTIONS   100
#define MS_DESC	       101
#define MS_TYPES       102
#define MS_OID	       103
#define MS_IID	       104
#define MS_FID         105
#define SIGNATURE      106
#define MS_TRUE	       107
#define MS_FALSE       108

// define others which is returned by tokenizer
#define DOT		801
#define COMMA		802
#define LPAR		803
#define RPAR		804
#define MINUSOP		805
#define PLUS		806
#define SLASH		807
#define STAR		808
#define PERCENT		809
#define SEMICOLON	810
#define LCB		811
#define RCB		812
#define LB		813
#define RB		814
#define STRCONS		998
#define CHRCONS		997
#define INHCONS		999
#define CLSCONS		1000
#define UNSIGNEDINT	996
#define UNSIGNEDREAL	995
#define IDENTIFIER	1001
#define DB_TYPE		4222
#define UNDEFINEDTOKEN	6221

//define Logical operators
#define EQ            200
#define GT            201
#define GE            202
#define LT            203
#define LE            204
#define NE            205
#define ISOP          206
#define ISNOT         207
//#define CONTAINS      208 they are keyword also
//#define ISSUBSET      209 they are keyword also
//#define IN            210 they are keyword also
#define NOTIN         211

#define UNARYMINUS   2000
#define UNARYPLUS    2001
#define MUL          2002
#define MOD          2003
#define ADD          2004
#define SUB          2005
#define DIV          2006

#define NOT_THIS_KEYWORD 	-1
#define CHECK_TOKEN(_tokenType, _errorNo, _errorMsg); \
	getToken();\
	if( tokenType() != _tokenType)\
	{\
		setError(PARSE_ERROR, _errorNo, _errorMsg);\
		return FALSE;\
	}\

#define IS_THIS_KEYWORD(_keywordType); \
	getToken();\
	if( tokenType() != _keywordType)\
	{\
		backtrack();\
		return NOT_THIS_KEYWORD;\
	}\

// define list item types
#define PROJ_ITEM		7001
#define BIND_ITEM       	7002
#define PATH_EXP        	3005
#define OR_TERM 		6668
#define SUBTREE_ITEM 		6669
#define AND_TERM 		6666
#define BIND_AND_TERM 		6667
#define CATALOG_TYPE_ITEM	8111
#define FUNCTION_TYPE_ITEM	8112
#define UPDATE_EXP      	8231
#define NUL_PTR         	8100
#define EXP_PTR         	8101
#define QRY_PTR         	8102
#define NEW_PTR         	8103
#define SET_PTR         	8104
#define LST_PTR         	8105
#define ATR_PTR         	8106
#define OID_PTR         	8107
#define PNW_PTR			8108


#ifndef MAXSTRLEN
#define MAXSTRLEN    		100
#endif
#define VOID         		(void *)
#define ASCENDING    		0
#define DESCENDING   		1
#define INDEXED_ATTRIBUTE 	78536
#define PATH_ATTRIBUTE         0 
#define PATH_FUNCTION          1 
#define PATH_ALL                3003
#define FUNCTION_PARAM          3004
#define PATH_EXP                3005
#define PATH_ITEM               3006
#define UNDEFINED_STRING 	"##########????"

/* below are used in dbi.h */
#define DBICHAR         	48

/* below are used in signature finding in functios */
#define DOUBLE  		4002
#define UNSIGNED 		4003
#define LONG    		4004
#define COBJ    		4005
#define ENUM    		4006
#define SHORT   		4009
#define SIGN_VOID 		4010

#define PTR     		4000
#define VEC     		4011


/********************************************************************
	List Item Type to Structure/Class  Mapping

	Item Type		Structure/Class Name
	______________________  _____________________
	AND_TERM		LinkedList
	SET_PTR			LinkedList
	LST_PTR			LinkedList
	EXP_PTR			Expression
	UPDATE_EXP		Expression
	FUNCTION_PARAM		Expression
	PATH_EXP		PathExpression
	INDEXED_ATTRIBUTE	??????
	PATH_ITEM		PathItem
	BIND_ITEM		BindListItem
	PROJ_ITEM		ProjListItem
	CATALOG_TYPE_ITEM	CatalogTypeItem	
	FUNCTION_TYPE_ITEM	FunctionType
	BIND_AND_TERM		DictItem
	QRY_PTR			Query
	NEW_PTR			NewClause
	ATR_PTR			AttrList
	STRCONS			char *
	CHRCONS			char
	UNSIGNEDINT		unsigned int
	UNSIGNEDREAL		double
	NULLVALUE		None
	EVERY			None
	UNARYPLUS		None
	UNARYMINUS		None
	NOT			None
	AND			None
	OR			None
	MUL			None
	DIV			None
	MOD			None
	ADD			None
	SUB			None
	EQ			None
	NE			None
	GT			None
	GE			None
	LT			None
	LE			None
	CONTAINS		None
	ISSUBSET		None
	IN			None

***************************************************************************/

#endif // __KEYWORDS_H
