#ifndef __LISTS_H
#define __LISTS_H

#include "mood_catdef.h"
#include "mood_catalog.h"



#define  MOODSLIST  105 // Moods List Type Classifier ....


// These definitions will be changed .....

#define  L_EXISTS  12345  /* OID value user wants to insert , already  there */
#define  NOTEXISTS 12346 /* OID value user wants to delete , not in the list */

/*     These definitions will be removed during entegration */

#define  F_NAME  "trial"

/*     Until This point .... */


//  ERTYPE return type means the error value of function ....
//  If an error (ESM or Logical) occurs return value is Error value
//  Otherwise Set to 0........


class MoodsRoot {
    public:
      int TypeId;
};


class List : public MoodsRoot {
      private:
        OID        ListOid;    // Oid of list object .......................
        OID       *ListHead;  // OID members start offset is pointed......
        void      *Buffer;    // Memory buffer to handle operations.......
        int        BufGrp;    // Buffer Group Universal variable is kept..
        TID        Tid;       // Transaction Id Universal variable is kept
        USERDESC  *UserDesc;  // User Descriptor for ESM .................
        FID        FileId;    // File ID (Given For Creation).............
        
        
      public:
        INT32      Size ;     // Size of current list......................
        INT32      ListPos;   // Current Position in list..................
        INT32      ListMax;   // Max size of list .........................

        List(OID *PListOid,TYPEID *PTypeId,SIZTYP *PSize,CatBOOLEAN *PStatus);
        List(FID *PFid,NTYPE PPos,OID *PNearOid, 
             INT32 ListMax ,CatBOOLEAN *PStatus); 
        OID   *operator[](INT32 Subscript);
        void   unpin() { if (UserDesc != NULL) {
                             sm_ReleaseObject(UserDesc);
                             UserDesc = NULL ;
                         };
                       } ;
        void   getNext(OID *,CatBOOLEAN *);
        void   getPrev(OID *,CatBOOLEAN *);
        ERTYPE updateList(OID *, INT32 , CatBOOLEAN *);
        ERTYPE insertToList(OID *,CatBOOLEAN *);
        ERTYPE insertToList(OID *,INT32 ,CatBOOLEAN *);
        ERTYPE deleteFromList(INT32 , INT32 , CatBOOLEAN *);
        ERTYPE isIn(OID ,CatBOOLEAN  *);
        ERTYPE list_Union(List ,List ,CatBOOLEAN *);
        void   intersect(List , List , CatBOOLEAN *);
        ERTYPE isSublist(List ,CatBOOLEAN *);
        ERTYPE isContain(List ,CatBOOLEAN *);
        OID    getListOid(CatBOOLEAN *) ;
        void   getListOid(OID *,CatBOOLEAN *) ;
        ERTYPE getElement(OID *,int ,CatBOOLEAN *)  ;
        ERTYPE getFirst(OID *,CatBOOLEAN *) ;
        ERTYPE getLast(OID *,CatBOOLEAN *)  ;

};
#endif
