

/************************************************************************* 

			ABOUT THIS FILE 



Subject	:

	Error Handler of the MOODS

Author 	: 

	Cetin Ertan Ozkan

Date	: 

	12/02/1993

Last Test Date :

	12/02/1993

Last Revision Date :

	No revision

Related Files :

	../parser/error.c    --> definition of Error functions
	../include/userreq.h --> every user request in the MOODS has an
				 error field of Error type.

*************************************************************************/


#ifndef __ERROR_H
#define __ERROR_H

//#include "smex.h"

#include <stdio.h>
#include <string.h>
#include <sm_client.h>

// define parse error numbers here
#define MISSING_RP		0
#define INVLD_NDX		1
#define ARRY_BOUND		2
#define MISSING_RB      	3
#define TYPE_MISMATCH		4
#define UNKNOWN_SYNTAX  	5
#define CLS_NAME_EXPECTED	6
#define BIND_VAR_EXPECTED	7
#define LOG_OP_EXPECTED		8
#define INVLD_NDX_NAME		9
#define INVLD_ATT_NAME		10
#define MISSING_LP		11
#define UNRECOGNIZED		12
#define FROM_KYWD_ERR		13
#define WITH_KYWD_ERR		14
#define ON_KYWD_ERR		15
#define BY_KYWD_ERR		16
#define INTO_KYWD_ERR		17
#define VALUES_KYWD_ERR		18
#define OF_KYWD_ERR		19
#define UNIDENTIFIED_TOKEN	20
#define JOIN_KYWD_ERR		21
#define INDEX_KYWD_ERR		22
#define SELECT_KYWD_ERR		23
#define DELETE_KYWD_ERR		24
#define ORDER_KYWD_ERR		25
#define UPDATE_KYWD_ERR		26
#define SET_KYWD_ERR		27
#define CLASS_KYWD_ERR		28
#define NEW_KYWD_ERR            29
#define VERSION_ERR		30
#define INVLD_CLSNAME_ERR	31
#define INVLD_BIND_VAR          32
#define NOT_VLD_PRJEXP		33
#define NOT_VLD_BNDEXP		34
#define UNIQUE_KWD_ERROR        35
#define DB_NAME_EXPECTED	36
#define FOR_KWD_ERR		37
#define TO_KWD_ERR		38
#define DECLARATION_KYWD_EXPECTED 39
#define LCB_EXPECTED		40
#define RCB_EXPECTED		41
#define SEMICOLON_EXPECTED	42
#define INVLD_TYPE_NAME		43
#define CLASS_REDEFINITION	44
#define USING_KYWD_EXPECTED	45
#define MISSING_FILE_NAME	46
#define INH_NOT_ALLOWED		47
#define TYPE_INHERITANCE	48
#define PROTOTYPE_KYWD_EXPECTED 49
#define MISSING_PROTOTYPE	50
#define SELNEW_KWD_EXPECTED	51
#define LB_EXPECTED		52
#define TUPLE_EXPECTED		53
#define FUNCTION_KWD_ERR	54
#define FUNCTION_NAME_EXP	55
#define SIGN_PROTO_NAME_ERR	56
#define CYCLIC_DEFINITION	57

#define DIV_BY_ZERO		 0
#define TYPE_NOT_EXIST		 1
#define OVERFLOW_ERROR		 2
#define DB_NOT_EXIST		 3
#define DB_ALR_EXIST		 4
#define TYPE_ALR_EXIST		 5
#define ATT_NOT_EXIST		 6
#define FUNC_NOT_EXIST		 7
#define FUNC_ALR_EXIST		 8 
#define NO_ACTIVE_DB		 9
#define INVALID_FILENAME	10
#define NOT_A_CLSNAME		11
#define NO_DB_IN_USE		12
#define R_TYPE_MISMATCH		13
#define INVLD_QUERY		14
#define CANNOT_GETOBJ		15
#define TOO_MANY_OBJS		16
#define DLD_ERROR		17
#define CLS_NAME_DIFF		18
#define MISSING_ARG		19
#define EXTRA_ARG		20
#define EXP_TYPE_MISMATCH	21
#define NULL_VL_NOT_SUPP	22
#define R_VERSION_ERROR		23
#define ATTR_NOT_FOUND		24
#define CANNOT_DELETE_OBJ	25
#define DIR_NOT_FOUND		26
#define HAS_REFERENCE		27

typedef enum {
		PARSE_ERROR, 
		RUNTIME_ERROR,
		EXODUS_ERROR,
		INTERNAL_ERROR,
		EXCEPTION_ERROR,
		NO_ERROR,
                SET_ERROR,
		COMPILATION_ERROR,
		INITIALIZATION_ERROR
             } ErrorType; // possible error types in the MOODS



#define MAXERRORLEN 80

extern TID TransactionId;

class  MoodsError
{
public :
	ErrorType	errorType; // type of the error 
	int   		errorNo; // associated error number
	char  		errorMsg[MAXERRORLEN]; // error message if exists

	void 	setError(ErrorType, int, char*);
	void 	handleError();
		MoodsError() { errorType = NO_ERROR; }

} ;

#endif // ERROR_H
