#if !defined(__MOODS_H)
#define __MOODS_H

#include "smex.h"

#include <sys/types.h>
#include <sys/time.h>
#include <iostream.h>

// Error status codes
#define  ERR_UNKNOWN      -1
#define  ERR_NOTFOUND     -2
#define  ERR_DUPLICATE    -3
#define  ERR_CATALOG      -4
#define  ERR_BUFFERGRP    -5
#define  ERR_NOROOM       -6
#define  ERR_MEMOUT       -7
#define  ERR_NOTOPEN      -8
#define  ERR_LAST         -9

// Constants 
#define OIDSIZE    (sizeof(OID))

// Macros
#define  OID_Copy(oid1,oid2)      memcpy(&(oid1), &(oid2), OIDSIZE)
#define  OID_Equals(oid1,oid2)   (memcmp(&(oid1), &(oid2), OIDSIZE)==0)

#define  PRT_OID(oid)            cout << (int)(oid).diskAddr.unique

#define  Randomize()             srand(time(NULL))
#define  Rand()                  ((rand()&0x00FFFF00) >> 8)
#define  Random(N)               (Rand() % ((int)(N)))

#define  round(N)                ((int)((N)+0.5))
#define  Ceiling(N)              ((int) ( ( ( (N) - ((int)(N)) ) > 0 ) ? 1 : 0 ))
#define  sfree(P)                { if (P) free(P); }

// Maybe it was a better idea to write the following as a func.
#define  memswap(p1,p2,n)        { char *___t=(char *)malloc(n);      \
                                   memcpy(___t,(p1),(n));             \
                                   memcpy((p1),(p2),(n));             \
                                   memcpy((p2),___t,(n)); free(___t); }


#define  IncCircular(i,size)     if((++(i))==size) (i)=0 
 
#define  sqr(X)                  ((X)*(X))
#define  max(A,B)                ((A)>(B) ? (A) : (B))
#define  min(A,B)                ((A)<(B) ? (A) : (B))
#define  abs(X)                  (((X)<0)?-(X):(X))
#define  swap(A,B)               {int ___tmp;___tmp=(A);(A)=(B);(B)=___tmp;}

#define  MEMCHK(p)               if (p==NULL) { puts("Panic!"); exit(1); }
 
// Since the following is used only for the sorting routine in R*trees,
// the sqrt may be ommitted.
#define  PDIST(x1,y1,x2,y2)      sqrt(sqr((x1)-(x2))+sqr((y1)-(y2)))

#define  false     0
#define  true      1
#define  NO        0
#define  YES       1

#define  ERROR    -1
#define  OK        0

#define  NODISP   -1

typedef  unsigned char    byte;
typedef  byte             uchar;
typedef  unsigned int     uint;
typedef  uint             word;

// Function prototypes
void MoodsError(int);
void trace(char *msg);
void Panic(char *msg);
#endif
