/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/find_bp.c,v 1.16 92/11/18 01:32:50 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

extern COST		zero_cost ;

extern TRACE		trace ;
extern int		indent_value ;

int			fbp_indent = 10 ;


#if DEBUG>=1
extern int		level ;
#endif

#if defined(__cplusplus) || defined (ANSI)
extern char     *error_text (int) ;
extern STATUS find_phy_expr_list_elem (STORAGE_SEG_ANCHOR *,
                                int,
                                PHY_EXPR_LIST_ELEM *,
                                PROPERTY_VECTOR *,
                                PV_COMPARE,
                                PROPERTY_VECTOR *,
                                PV_COMPARE,
                                PV_EXCL_COMPARE,
                                COST *,
                                COMPARE,
                                PHY_EXPR_LIST_ELEM **) ;
extern STATUS optimize (LOG_EXPR_LIST_ELEM *, PROPERTY_VECTOR *,
                 PROPERTY_VECTOR *, COST *,
                 int,
                 EQ_CLASS *, PHY_EXPR_LIST_ELEM *,
                 int,
                 STORAGE_SEG_ANCHOR *,
                 OPT_RETURN *) ;
extern STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *) ;
extern STATUS print_log_expr (LOG_EXPR *, BOOLEAN) ;
#else
extern char     *error_text () ;
extern STATUS find_log_expr_list_elem () ;
extern STATUS optimize () ;
extern STATUS print_phy_expr_list_elem () ;
extern STATUS print_log_expr () ;
#endif

#if defined(__cplusplus) || defined (ANSI)
STATUS find_best_plan (	LOG_EXPR *log_expr, 
			LOG_EXPR_LIST_ELEM *lele, 
			PROPERTY_VECTOR *pv, 
			PV_COMPARE pv_compare_value,
		       	PROPERTY_VECTOR *excl_pv, 
			PV_EXCL_COMPARE pv_excl_compare_value, 
			COST *cost_limit,
		       	int eq_class_index,
		       	EQ_CLASS *eq_class,
		       	int rule_group, 
		       	STORAGE_SEG_ANCHOR *ssa,
			OPT_RETURN *opt_return)
#else
STATUS find_best_plan (log_expr, lele, pv, pv_compare_value,
		       excl_pv, pv_excl_compare_value, cost_limit,
		       eq_class_index,
		       eq_class,
		       rule_group, 
		       ssa,
		       opt_return)
LOG_EXPR		*log_expr ; 
LOG_EXPR_LIST_ELEM	*lele ; 
PROPERTY_VECTOR    	*pv ;
PV_COMPARE		pv_compare_value ; 
PROPERTY_VECTOR    	*excl_pv ;
PV_EXCL_COMPARE		pv_excl_compare_value  ;
COST			*cost_limit ;
int 			eq_class_index ;
EQ_CLASS		*eq_class ;
int			rule_group ;
STORAGE_SEG_ANCHOR  	*ssa ;
OPT_RETURN		*opt_return ;
#endif
{
    PHY_EXPR_LIST_ELEM  	*ret_pele = NULL,  
				*derived_pele = NULL, 
				*temp_pele = NULL ;
    COST 			*found_plan_cost, 
				*fail_cost ;
    COMPARE			cost_compare ;
    COST			cover_cost ;
    PHY_EXPR_LIST_ELEM		*cheapest_cover = NULL ;
    static int			top_level = 0 ;
    int 			check_return = 0 ;
    STATUS 			error ;

#ifdef GET_STATS
    ++ (ssa -> calls_to_fbp) ;
#endif

    if (top_level == 0)
    {
	check_return = 1 ;
        top_level = 1 ;
    }

#if DEBUG>=1
    ++level ;
    if (trace == TRACE_ON)
    {
	printi ("L%d fbp: In find_best_plan. Expression:\n", level) ;
	increment_indent (fbp_indent-2) ;
	CALL (print_log_expr (log_expr, TRUE)) ;
	decrement_indent (fbp_indent-2) ;
	printi ("L%d fbp: property vector:\n", level) ;
	increment_indent (fbp_indent) ;
	print_property_vec (pv) ;
	decrement_indent (fbp_indent) ;
	printi ("L%d fbp: excl. property vector:\n", level) ;
	increment_indent (fbp_indent) ;
	print_property_vec (excl_pv) ;
	decrement_indent (fbp_indent) ;
#ifdef GET_STATS
	printi ("L%d fbp: Calls to find best plan = %d\n", level, 
                 ssa -> calls_to_fbp) ;
#endif
	printi ("L%d fbp: cost limit: \n", level) ;
	increment_indent (fbp_indent) ;
	print_cost (cost_limit) ;
	decrement_indent (fbp_indent) ;
    }
#endif

#if SAFETY>=1
    if (log_expr == NULL)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }

    if (lele == NULL)
    {
	FAIL (ERR_NULL_POINTER) ;
    }

    if (pv == NULL || excl_pv == NULL)
    {
	FAIL (ERR_NULL_POINTER) ;
    }

    if (eq_class_index < 0 || eq_class_index > ssa -> eq_class_count)
    {
	FAIL (ERR_INDEX_OUT_OF_RANGE) ;
    }

    if (eq_class -> eq_class_index != eq_class_index)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }

    if (eq_class == NULL)
    {
	FAIL (ERR_NULL_POINTER) ;
    }

    if (opt_return == NULL)
    {
	FAIL (ERR_NULL_POINTER) ;
    }

    if (eq_class_index != lele -> eq_class_index)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }
#endif

    opt_return -> error = OPTIMIZATION_FAILED ;
    opt_return -> pele = NULL ;

#ifdef USE_MACROS
    mfind_phy_expr_list_elem (eq_class,
				(PHY_EXPR_LIST_ELEM *) NULL, 
				pv, excl_pv, 
				&ret_pele) ;
#else
    CALL (find_phy_expr_list_elem (ssa, eq_class_index, 
				(PHY_EXPR_LIST_ELEM *) NULL, 
				pv, PV_EQUAL, excl_pv, PV_EQUAL,
				PV_EXCL_NOT_SET, (COST *) NULL,
				COMPARE_NOT_SET,
				&ret_pele)) ;
#endif

    if (ret_pele != NULL)
    {
#if DEBUG>=1
	if (trace == TRACE_ON)
	{
	    printi ("L%d fbp: progress flag:\n", level) ;
	    increment_indent(fbp_indent) ;
	    print_progress_flag (ret_pele -> progress_flag) ;
	    decrement_indent(fbp_indent) ;
        }
#endif
#if SAFETY>=1
#ifdef USE_MACROS
	mfind_phy_expr_list_elem (eq_class,
				    ret_pele, 
				    pv, excl_pv, 
				    &temp_pele) ;
#else
	CALL (find_phy_expr_list_elem (ssa, eq_class_index, 
				ret_pele, 
				pv, PV_EQUAL, excl_pv, PV_EQUAL,
				PV_EXCL_NOT_SET, (COST *) NULL,
				COMPARE_NOT_SET, 
				&temp_pele)) ;
#endif
	if (temp_pele) 
	{
	   FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; 
	}
#endif

	if (ret_pele -> progress_flag == COMPLETE && ret_pele -> expr)
	{
	    found_plan_cost = &(ret_pele -> expr -> cost) ;
	    derived_pele = ret_pele -> expr -> derived_pele ;
	    if (cost_not_set (found_plan_cost))
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	    if (derived_pele == NULL)
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	
#if DEBUG>=1
#ifdef PRINT
	    if (trace == TRACE_ON)
	    {
		printi ("L%d fbp: Plan exists:\n", level) ;
		increment_indent(fbp_indent-2) ;
		CALL (print_phy_expr_list_elem (ret_pele)) ;
		decrement_indent(fbp_indent-2) ;
	    }
#endif
#endif

	    compare_cost (found_plan_cost, cost_limit, &cost_compare) ;

	    if (cost_compare == LESS_THAN)
	    {
#if DEBUG>=1
#ifdef PRINT
		if (trace == TRACE_ON)
		{
		    printi ("L%d fbp: Plan beats limit, will return.\n", level) ;
		}
#endif
                --level ;
#endif
		opt_return -> pele = ret_pele -> expr -> derived_pele ; 
		opt_return -> error = OPTIMIZATION_SUCCESSFUL ;
		opt_return -> reason = REASON_NOT_SET ;

		return (OKAY) ;
	    }
	    else  /* must fail */
	    {
#if DEBUG>=1
#ifdef PRINT
		if (trace == TRACE_ON)
		{
		    printi ("L%d fbp: Plan does NOT beat limit, will return.\n",
                            level) ;
		}
#endif
                --level ;
#endif
		opt_return -> pele = NULL ; 
		opt_return -> error = OPTIMIZATION_FAILED ;
		opt_return -> reason = FOUND_PLAN_COST_EXCEEDS_LIMIT ;
		return (OKAY) ;
	    }

	}
	else
	{
	    found_plan_cost = NULL ;
	}

       /*
	if (ret_pele -> progress_flag == COMPLETE && 
		ret_pele -> failure_exists == TRUE)
       */
       /* changed 11-16-92 */
	if (ret_pele -> failure_exists == TRUE)
	{

#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi ("L%d fbp: Cost bound exists :\n", level) ;
		increment_indent (fbp_indent) ; 	
		print_cost (&(ret_pele -> fail_cost)) ;
		decrement_indent (fbp_indent) ; 	

		if (ret_pele -> fail_reason == COST_LIMIT_EXCEEDED)
		{
		    printi ("L%d fbp: Cost limit passed :\n", level) ; 
		    increment_indent (fbp_indent) ; 	
                    print_cost (cost_limit) ;
		    decrement_indent (fbp_indent) ; 	
		}

		printi ("L%d fbp: Reason: ", level) ; 
                print_failure_reason (ret_pele -> fail_reason) ;
	    }
#endif

	    fail_cost = &(ret_pele -> fail_cost) ;
	    if (cost_not_set (fail_cost))
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }

	    if (found_plan_cost)
	    {
		compare_cost (found_plan_cost, cost_limit, &cost_compare) ;
		if (cost_compare == LESS_THAN)
		{
		    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		}
	    }

	    compare_cost (cost_limit, fail_cost, &cost_compare) ;
	    if ((ret_pele -> fail_reason == COST_LIMIT_EXCEEDED 
		  && (cost_compare == LESS_THAN || cost_compare == EQUAL_TO)) || 
		ret_pele -> fail_reason == OPTIMIZATION_NOT_POSSIBLE) 
	    {

		opt_return -> error = OPTIMIZATION_FAILED ;

		if (ret_pele -> fail_reason == COST_LIMIT_EXCEEDED)
		    opt_return -> reason = LIMITING_COST_BOUND_EXISTS ;
		else if (ret_pele -> fail_reason == OPTIMIZATION_NOT_POSSIBLE)
		    opt_return -> reason = OPTIMIZATION_NOT_POSSIBLE ;
		else
		    FAIL (ERR_UNKNOWN_VALUE) ;
#if DEBUG>=1
		if (trace == TRACE_ON)
		{
		    printi ("L%d fbp: Will fail and return.\n", level) ;
		}
                --level ;
#endif
		opt_return -> pele = NULL ;
		return (OKAY) ;
	    }
	}

    }

   /* Otherwise, have to optimize. */

    cheapest_cover = NULL ;
    copy_cost (&cover_cost, cost_limit) ;
    
    for (temp_pele = eq_class -> phy_expr_list.first; 
	    temp_pele != NULL;
	    temp_pele = temp_pele -> next)
    {

	if (temp_pele -> expr == NULL)
	    continue ;

	compare_cost (&(temp_pele -> expr -> cost),
		      &cover_cost,
		      &cost_compare) ;

	if (cost_compare == LESS_THAN)
	{
	    PV_COMPARE	temp_pv_compare ;
	    compare_property_vec 
		   (&(temp_pele -> property_vector),
		    pv, 
		    &(eq_class -> system_property),
		    &(eq_class -> logical_property), &temp_pv_compare) ; 

	    if (temp_pv_compare == PV1_COV_PV2 
		|| temp_pv_compare == PV_EQUAL)
	    {
		compare_property_vec 
			(&(temp_pele -> excl_property_vector),
			excl_pv, 
			&(eq_class -> system_property),
			&(eq_class -> logical_property), 
			&temp_pv_compare) ; 
		if (temp_pv_compare == PV1_COV_PV2 
		    || temp_pv_compare == PV_EQUAL)
		{
			cheapest_cover = temp_pele -> expr -> derived_pele;
			copy_cost (&cover_cost, &(cheapest_cover -> expr -> cost)) ;
		}
	    }
	}
	
    }

#if DEBUG>=1
    if (trace == TRACE_ON)
    {
	printi ("L%d fbp: Have to call optimize from find_best_plan\n", level) ;
    }
    if (cheapest_cover)
    {
	if (trace == TRACE_ON)
	{
	    printi ("L%d fbp: covering plan exists:\n", level) ;
	    printi ("L%d fbp:   cover cost:\n", level) ;
	    increment_indent(fbp_indent) ;
	    print_cost (&(cheapest_cover -> expr -> cost)) ;
	    decrement_indent(fbp_indent) ;
	}
#ifdef PRINT
	if (trace == TRACE_ON)
	{
	    printi ("L%d fbp: Covering plan:\n", level) ;
	    CALL (print_phy_expr_list_elem (cheapest_cover)) ;
	}
#endif
    }
#endif

#if SAFETY>=1
    if (cheapest_cover)
    {
	PV_COMPARE	temp_pv_compare ;
	compare_property_vec 
	       (&(cheapest_cover -> property_vector),
		pv, 
		&(eq_class -> system_property),
		&(eq_class -> logical_property), &temp_pv_compare) ; 

	if (temp_pv_compare != PV1_COV_PV2 
		&& temp_pv_compare != PV_EQUAL)
	{
#if DEBUG>=1 
            if (trace == TRACE_ON)
	    {
		printi ("L%d fbp: Property vector:\n", level) ;
		increment_indent (fbp_indent) ;
		print_property_vec (
		    &(cheapest_cover -> property_vector)) ;
		decrement_indent (fbp_indent) ;
		printi (
		   "        does not cover or equal property vector\n") ;
		increment_indent (fbp_indent) ;
		print_property_vec (pv) ;
		decrement_indent (fbp_indent) ;
	    }
#endif
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}
    }
#endif
	
    CALL (optimize (lele, pv, excl_pv, &cover_cost, 
			eq_class_index, eq_class, cheapest_cover,
			rule_group, ssa, opt_return)) ;

#if SAFETY>=1
    if (opt_return -> pele == NULL && cheapest_cover)
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

    if (opt_return -> pele)
    {
	PV_COMPARE	temp_pv_compare ;

	compare_cost (&(opt_return -> pele -> expr -> cost),
		      cost_limit,
		      &cost_compare) ;

	if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO)
	{
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}

	compare_property_vec 
	       (&(opt_return -> pele -> property_vector),
		pv, 
		&(eq_class -> system_property),
		&(eq_class -> logical_property), &temp_pv_compare) ; 

	if (temp_pv_compare != PV1_COV_PV2 
	    && temp_pv_compare != PV_EQUAL)
	{
#if DEBUG>=1 
            if (trace == TRACE_ON)
	    {
		printi ("L%d fbp: Property vector:\n", level) ;
		increment_indent(fbp_indent) ;
		print_property_vec (
		    &(opt_return -> pele -> property_vector)) ;
		decrement_indent(fbp_indent) ;
		printi (
		   "        does not cover or equal property vector\n") ;
		increment_indent(fbp_indent) ;
		print_property_vec (pv) ;
		decrement_indent(fbp_indent) ;
	    }
#endif
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}

    }
#endif

#if DEBUG>=1
    if (trace == TRACE_ON)
    {
	printi ("L%d fbp: Returned from optimize.\n", level) ;
	printi ("L%d fbp: Return reason: ", level) ;
	print_failure_reason (opt_return -> reason) ;
	printi ("L%d fbp: Return error: ", level) ;
	print_optimization_error (opt_return -> error) ;
    }
    if (opt_return -> error == OPTIMIZATION_SUCCESSFUL)
    {
#ifdef PRINT
	if (trace == TRACE_ON)
	{
	    printi ("L%d fbp: Plan:\n", level) ;
	    CALL (print_phy_expr_list_elem (opt_return -> pele)) ;
	}
#endif
    }
    if (trace == TRACE_ON)
    {
	printi ("L%d fbp: Exiting find_best_plan.\n", level) ;
    }
    -- level ;
#endif

    if (check_return == 1)
    {
	if (opt_return -> error != OPTIMIZATION_SUCCESSFUL)
	{
	    return (ERR_OPTIMIZER_FAILED) ;
	}
	else
	{
	    return (OKAY) ;
	}
    }
    else
    {
	return (OKAY) ;
    }

} /* find_best_plan */
