/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/gen_all_trans.c,v 1.16 92/11/18 01:32:53 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

#if defined(__cplusplus) || defined(ANSI)
extern char     *error_text (int) ;
extern STATUS match_trans_rule (LOG_EXPR_LIST_ELEM *, LOG_EXPR *, int,
                         STORAGE_SEG_ANCHOR *) ;
STATUS generate_all_transformations (LOG_EXPR_LIST_ELEM *, int,
				     STORAGE_SEG_ANCHOR *) ;
#if defined(PRINT) && DEBUG>=3
STATUS print_log_expr (LOG_EXPR *, BOOLEAN) ;
#endif
#else
extern STATUS match_trans_rule () ;
extern char     *error_text () ;
STATUS generate_all_transformations () ;
#if defined(PRINT) && DEBUG>=3
STATUS print_log_expr () ;
#endif
#endif

extern int              opt_arity[] ;

extern TRACE		trace ;
extern int		indent_value ;

#if defined(__cplusplus) || defined(ANSI)
STATUS generate_all_transformations (LOG_EXPR_LIST_ELEM *lele, 
    int rule_group, STORAGE_SEG_ANCHOR *ssa)
#else
STATUS generate_all_transformations (lele, rule_group, ssa)
LOG_EXPR_LIST_ELEM	*lele ;
int			rule_group ;
STORAGE_SEG_ANCHOR  	*ssa ;
#endif
{
    LOG_EXPR_LIST_ELEM	*current_lele, *end_lele ;
    LOG_EXPR		*log_expr ;
    int			i ;
    EQ_CLASS		*eq_class ;
    STATUS		error ;

#if DEBUG>=3
    if (trace == TRACE_ON)
    {
	printi ("in generate_all_trans\n") ;
    }
#endif
 
#if SAFETY>=1
    if (lele == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif

#if DEBUG>=3
    if (trace == TRACE_ON)
    {
	printi ("entered generate_all_transformations\n") ;
    }
#endif

    for (i = MAX_OPERATOR_ARITY; --i >= 0;)
    {
	EQ_CLASS	*input_eq_class ;

	if (lele -> expr.input[i] == NULL) 
	    continue ;

	get_eq_class_addr (ssa, lele -> expr.input[i] -> eq_class_index,
				&input_eq_class) ;

	if (input_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
	{
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	} 

	if (input_eq_class -> trans_flag == NO_TRANSFORMATIONS)
	{
	    CALL (generate_all_transformations 
			(lele -> expr.input[i], 
			 rule_group, ssa)) ;
	}
	
    }

    get_eq_class_addr (ssa, lele -> eq_class_index, &eq_class) ;
    if (eq_class -> trans_flag != NO_TRANSFORMATIONS)
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

    eq_class -> trans_flag = TRANSFORMATIONS_IN_PROGRESS ;

    for (current_lele = lele,
         end_lele = eq_class -> log_expr_list.last ;
	 current_lele != NULL; )
    {
       /*
	if (current_lele -> last_rule != -1)
	{
	    FAIL (ERR_SANITY_CHECK) ;
	}	
       */

	log_expr = &(current_lele -> expr) ;

#if DEBUG>=3
#ifdef PRINT
	if (trace == TRACE_ON)
	{
	    printi ("  next log. expr:\n") ;
	    CALL (print_log_expr (log_expr, TRUE)) ;
	}
#endif
#endif

	for (;;)	
	{
	    CALL (match_trans_rule (current_lele,log_expr, rule_group,
				  ssa)) ; 
	    if (current_lele -> last_rule == NO_MORE)
		break ;
	} 

	if (current_lele == end_lele)
	{
	    get_eq_class_addr (ssa, lele -> eq_class_index, &eq_class) ;
	    end_lele = eq_class -> log_expr_list.last ;
	}
	current_lele = current_lele -> next ;
	
    } /* for */ 

    get_eq_class_addr (ssa, lele -> eq_class_index, &eq_class) ;
    eq_class -> trans_flag = TRANSFORMATIONS_COMPLETE ;

#if DEBUG>=3
    if (trace == TRACE_ON)
    {
	printi ("exiting generate_all_trans\n") ;
    }
#endif

    return (OKAY) ;

} 
