/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/opt_print.c,v 1.16 92/11/18 01:32:55 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "global.h"

extern int opt_arity [] ;
extern int algo_arity [] ;

extern int	indent_value ;

#ifdef PRINT
#if defined(__cplusplus) || defined (ANSI)
STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *, BOOLEAN) ;
STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *) ;
STATUS print_log_expr (LOG_EXPR *, BOOLEAN) ;
STATUS print_phy_expr (PHY_EXPR *) ;
STATUS print_query (QUERY *) ;
STATUS print_plan (PLAN *) ;
extern char     *error_text (int) ;
#else
STATUS print_log_expr_list_elem () ;
STATUS print_phy_expr_list_elem () ;
STATUS print_log_expr () ;
STATUS print_phy_expr () ;
STATUS print_plan () ;
extern char     *error_text () ;
#endif 
#endif 

#if defined (PRINT)
#if defined(__cplusplus) || defined (ANSI)
STATUS print_eq_class (EQ_CLASS * eq_class, BOOLEAN all, 
		       int direction)
#else
STATUS print_eq_class (eq_class, all, direction)
EQ_CLASS *eq_class ;
BOOLEAN all ;
int direction ;
#endif
{
    STATUS error ;

    if (eq_class == NULL)
    {
        printi ("equivalence class is NULL\n") ;
    }
    else
    {
	LOG_EXPR_LIST_ELEM *lep ;
	PHY_EXPR_LIST_ELEM *pep ;

	if (direction == FORWARD)
        {
	    lep = eq_class -> log_expr_list.first ;
	    pep = eq_class -> phy_expr_list.first ;
	}
	else
	{
	    if (direction == BACKWARD)
	    {
		lep = eq_class -> log_expr_list.last ;
		pep = eq_class -> phy_expr_list.last ;
	    }
	    else
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	}

        printi ("index entry of eq. class = %d\n",
		 eq_class -> eq_class_index) ;

	if (eq_class -> log_expr_list.first == NULL
			||
	    eq_class -> log_expr_list.last == NULL)
	{
	    printi ("  no logical expressions in equivalence class\n") ;
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}

        if (all)
        {
	    for ( ; lep != NULL ; )
	    {
		printi ("  -- next log. expr. elem. of equivalence class: --\n") ;
		CALL (print_log_expr_list_elem (lep, TRUE)) ;
		if (direction == FORWARD)
		    lep = lep -> next ;
		else
		    lep = lep -> prev ;

	    }

	    if (pep == NULL)
            {
                printi ("  no physical expressions\n") ;
            }
	    for ( ; pep != NULL ; )
	    {
		printi ("  -- next phy. expr. elem. of equivalence class: --\n") ;
		CALL (print_phy_expr_list_elem (pep)) ;
		if (direction == FORWARD)
		    pep = pep -> next ;
		else
		    pep = pep -> prev ;

	    }
	}
        else
	{

	   /*------------------ Print logical expressions. --------------------*/

	    printi ("  -- first log. expr. elem. of equivalence class: --\n") ;
	    CALL (print_log_expr_list_elem (eq_class -> log_expr_list.first,
						 TRUE)) ;

	    printi ("  last log. expr. elem. of equivalence class:\n") ;
	    CALL (print_log_expr_list_elem (eq_class -> log_expr_list.last, TRUE )) ;

	   /*----------------- Print physical expressions. --------------------*/

	    printi ("  -- first phy. expr. elem. of equivalence class: --\n") ;
            if (eq_class -> phy_expr_list.first != NULL)
	    {
		CALL (print_phy_expr_list_elem
			 (eq_class -> phy_expr_list.first)) ;
	    }
            else 
            {
                printi ("   first element is NULL\n") ;
		if (eq_class -> phy_expr_list.last != NULL)
		    FAIL (ERR_POINTER_PROBLEM) ;
            }

	    printi ("  last phy. expr. elem. of equivalence class:\n") ;
            if (eq_class -> phy_expr_list.last != NULL)
	    {
		CALL (print_phy_expr_list_elem
			 (eq_class -> phy_expr_list.last)) ;
            }
            else 
            {
                printi ("   last element is NULL\n") ;
		if (eq_class -> phy_expr_list.first != NULL)
		    FAIL (ERR_POINTER_PROBLEM) ;
            }

	}
      
        printi ("  system properties:\n") ;
	increment_indent(4) ;
        print_sys_props (&(eq_class -> system_property)) ;
	decrement_indent(4) ;
        printi ("  logical properties:\n") ;
	increment_indent(4) ;
        print_logical_prop (&(eq_class -> logical_property)) ;
	decrement_indent(4) ;
	printi ("transformation flag: ") ;
	print_transformation_flag (eq_class -> trans_flag) ;
#ifdef GET_STATS
	printi ("eq. class count = %lf\n", eq_class -> count) ;
#endif
    }

    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *pele) 
#else
STATUS print_phy_expr_list_elem (pele)
PHY_EXPR_LIST_ELEM *pele ;
#endif
{
    STATUS error ;

    if (pele == NULL) 
    {
	printi ("NULL pointer passed to print_phy_expr_list_elem\n") ;
        return (OKAY) ;
    }

    printi ("eq_class_index = %d\n", pele -> eq_class_index) ;
    printi ("node address = %#x\n", pele) ;
    printi ("property vector:\n") ;
    increment_indent(2) ;
    print_property_vec (&(pele -> property_vector)) ;
    decrement_indent(2) ;
    printi ("excluding property vector:\n") ;
    increment_indent(2) ;
    print_property_vec (&(pele -> excl_property_vector)) ;
    decrement_indent(2) ;
    printi ("failure exists: ") ; (pele -> failure_exists == TRUE) ?
					printf ("TRUE\n") : printf ("FALSE\n") ;
    printi ("fail_reason: ") ; print_failure_reason (pele -> fail_reason) ;
    printi ("fail cost :\n") ; 
    increment_indent(2) ;
    print_cost (&(pele -> fail_cost)) ;
    decrement_indent(2) ;
    printi ("progress flag:\n") ;
    increment_indent(2) ;
    print_progress_flag (pele -> progress_flag) ; 
    decrement_indent(2) ;
    printi ("logical expression list elem. address = %#x\n", pele -> lele) ;
    printi ("physical expression address = %#x\n", pele -> expr) ;
    printi ("physical expression :\n") ;
    CALL (print_phy_expr (pele -> expr )) ;
 
    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS print_phy_expr (PHY_EXPR *phy_expr) 
#else
STATUS print_phy_expr (phy_expr) 
PHY_EXPR *phy_expr ;
#endif
{
    STATUS error ;
    int i ;

    if (phy_expr == NULL)
    {
	printi ("NULL expression\n") ;
	return (OKAY) ;
    }

    printi ("algorithm: ") ; print_algorithm (phy_expr -> algorithm) ;
    printi ("algorithm arg.\n") ; 
    increment_indent(2) ;
    print_algorithm_arg (&(phy_expr -> algorithm_argument),
					&(phy_expr -> algorithm)) ;
    decrement_indent(2) ;
#ifdef GET_STATS
    printi("ref_count = %d\n", phy_expr -> ref_count) ;
#endif
    printi ("cost: \n") ; 
    increment_indent(2) ;
    print_cost (&(phy_expr -> cost)) ;
    decrement_indent(2) ;
    printi ("address of derived_pele = %#x\n", phy_expr -> derived_pele) ; 
    for (i = -1 ; ++i < MAX_ALGORITHM_ARITY ; )
    {
	printi ("input %d:\n", i) ;
	if (phy_expr -> input[i] != NULL)
	{
	    CALL (print_phy_expr_list_elem (phy_expr -> input[i])) ;
	}
	else 
	{
	    printi ("  NULL\n") ;
	}
		
    }

    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *log_expr_list_elem, 
				 BOOLEAN inputs)
#else 
STATUS print_log_expr_list_elem (log_expr_list_elem, inputs)
LOG_EXPR_LIST_ELEM *log_expr_list_elem ;
BOOLEAN inputs ;
#endif
{
    STATUS error ;

#if SAFETY>=1
    if (log_expr_list_elem == NULL) 
	FAIL (ERR_NULL_POINTER) ;
#endif

    printi ("eq_class_index = %d\n", log_expr_list_elem -> eq_class_index) ;
    printi ("rule_generated_from = %d\n", log_expr_list_elem -> rule_generated_from) ;
    printi ("depth = %d\n", log_expr_list_elem -> depth) ;
#ifdef GET_STATS
    printi ("ref_count = %d\n", log_expr_list_elem -> ref_count) ;
#endif
    printi ("logical expression :\n") ;
    CALL (print_log_expr (&(log_expr_list_elem -> expr), inputs)) ;
 
    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS print_log_expr (LOG_EXPR *log_expr, BOOLEAN inputs) 
#else
STATUS print_log_expr (log_expr, inputs) 
LOG_EXPR *log_expr ;
BOOLEAN inputs ;
#endif
{
    STATUS error ;
    int i ;

#if SAFETY>=1
    if (log_expr == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif

    printi ("operator: ") ; print_operator (log_expr -> my_operator) ;
    printi ("operator arg.\n") ; 
    increment_indent(2) ;
    print_operator_arg (&(log_expr -> argument),
		 &(log_expr -> my_operator) ) ;
    decrement_indent(2) ;
    if (inputs) 
	for (i = -1 ; ++i < MAX_OPERATOR_ARITY ; )
	{
	    printi ("input %d:\n", i) ;
	    if (log_expr -> input[i] != NULL)
            {
		CALL (print_log_expr_list_elem (log_expr -> input[i],
                                          TRUE)) ;
            }
            else 
            {
                printi ("  NULL\n") ;
            }
		
	}

    return (OKAY) ;

}

/*
#if defined(__cplusplus) || defined (ANSI)
STATUS print_hash_chain (LOG_EXPR_LIST_ELEM * anchor, BOOLEAN all, 
			 int direction)
#else
STATUS print_hash_chain (anchor, all, direction)
LOG_EXPR_LIST_ELEM *anchor ;
BOOLEAN all ;
int direction ;
#endif
{
    LOG_EXPR_LIST_ELEM *tmp ;
    STATUS error ;

    if (anchor == NULL)
    {
	printi ("hash entry has no members\n") ;
    }
    else
    {
	for (tmp = anchor ; tmp != NULL ; )
	{
	    CALL (print_log_expr_list_elem (tmp, all)) ; 
	    if (direction == FORWARD)
		tmp = tmp -> hash_next ;
	    else
	    {
		if (direction != BACKWARD)
		{
		    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		}
		else
		    tmp = tmp -> hash_prev ;
	    }
	}
    }

    return (OKAY) ;

}
#endif
*/

#if defined(__cplusplus) || defined (ANSI)
STATUS print_query (QUERY *query) 
#else
STATUS print_query (query) 
QUERY	*query ;
#endif
{
    STATUS 	error ;
    int		i ;

    printi ("Operator: ") ; print_operator (query -> my_operator) ;
    printi ("Operator arg.:\n") ;
    increment_indent(2) ;
    print_operator_arg (&(query -> argument),
				&(query -> my_operator)) ;
    decrement_indent(2) ;
    for (i = -1 ; ++i < opt_arity[(int) (query -> my_operator)] ; )
    {
	printi ("input %d:\n", i) ;
	if (query -> input[i] != NULL)
	{
	    CALL (print_query (query -> input[i])) ;
	}
	else 
	{
	    printi ("  NULL\n") ;
	}
    }

    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS print_plan (PLAN *plan) 
#else
STATUS print_plan (plan) 
PLAN	*plan ;
#endif
{
    STATUS error ;
    int i ;

    printi ("Algorithm: ") ; print_algorithm (plan -> algorithm) ;
    printi ("Algorithm arg.\n") ; 
    increment_indent(2) ;
    print_algorithm_arg (&(plan -> algorithm_argument),
					&(plan -> algorithm)) ;
    decrement_indent(2) ;
    printi ("Operator: ") ; print_operator (plan -> my_operator) ;
    increment_indent(2) ;
    print_operator_arg (&(plan -> operator_argument),
					&(plan -> my_operator)) ;
    decrement_indent(2) ;
    printi ("Cost: ") ; 
    increment_indent(2) ;
    print_cost (&(plan -> cost)) ;
    decrement_indent(2) ;
    printi ("Logical properties:\n") ;
    increment_indent(2) ;
    print_logical_prop (&(plan -> logical_property)) ;
    decrement_indent(2) ;
    printi ("Property vector:\n") ;
    increment_indent(2) ;
    print_property_vec (&(plan -> property_vector)) ;
    decrement_indent(2) ;
    printi ("Excluding property vector:\n") ;
    increment_indent(2) ;
    print_property_vec (&(plan -> excl_property_vector)) ;
    decrement_indent(2) ;
    printi ("System properties:\n") ;
    increment_indent(2) ;
    print_sys_props (&(plan -> system_property)) ;
    decrement_indent(2) ;

    for (i = -1 ; ++i < MAX_ALGORITHM_ARITY ; )
    {
	printi ("input %d:\n", i) ;
	if (plan -> input[i] != NULL)
	{
	    CALL (print_plan (plan -> input[i])) ;
	}
	else 
	{
	    printi ("  NULL\n") ;
	}
		
    }

    return (OKAY) ;
}
#endif
