%{
#include "grammar.h"
#if defined(__cplusplus) || defined (ANSI)
int yylook () ;
extern int yywrap () ;
int yyreject () ;
int yyback (int *, int) ;
void exit (int) ;
#else
int yylook () ;
extern int yywrap () ;
int yyreject () ;
int yyback () ;
void exit () ;
#endif
%}

char		[A-Z_a-z]
digit		[0-9]
space		[ \t\n]
number		{digit}+
o_paren		[(]
c_paren		[)]

oper_def	"%operator "
algo_def	"%algorithm "
enfo_def	"%enforcer "
impl_rule_def	"%impl_rule "
trans_rule_def	"%trans_rule "
prio		"%pr "
og		"%og "
op_var		"?op"{number}
input_var	"?"{number}
op_arg_var	"?op_arg"{number}
al_arg_var	"?al_arg"{number}
line		.*

%%

			extern int include_it ;

^{oper_def}		{return (OPER_DEF);} 
^{algo_def}		{return (ALGO_DEF) ;}
^{enfo_def}	  	{return (ENFO_DEF) ;}
^{impl_rule_def}	{return (IMPL_RULE_DEF) ;}
^{trans_rule_def}	{return (TRANS_RULE_DEF) ;}
{og}			{return (OG) ;}
{prio}			{return (PRIO) ;}
"("			{return (OPEN_PAREN) ;}
")"			{return (CLOSE_PAREN) ;}
"("			{return (O_PAREN) ;}
")"			{return (C_PAREN) ;}
"->"			{return (ONE_WAY) ;}
"->!"			{return (ONE_WAY_ONCE) ;}
"<->"			{return (TWO_WAY) ;}
{input_var}		{return (INPUT_VAR) ;}
{op_arg_var}		{return (OP_ARG_VAR) ;}
{al_arg_var}		{return (AL_ARG_VAR) ;}
{op_var}		{return (OP_VAR) ;}
^"%cond_code"		{return (COND_CODE) ;}
^"%appl_code"		{return (APPL_CODE) ;}
^"{{"			{return (BEGIN_CC);}
^"}}"			{return (END_CC);}
{char}+			{return (IDENT) ;}
{char}+{number}		{return (IDENT) ;}
{char}+{number}{char}+	{return (IDENT) ;}
{number}		{return (NUMBER) ;}
"--".*			;
^{line}			{if (include_it == 0) REJECT;
				return (C_CODE) ;}
"."			{return (NIL) ;}
{space}		;

%%

#if defined (__cplusplus) || defined (ANSI)
yyerror (char text[])
#else
yyerror (text)
char text [] ;
#endif
{
    extern char yytext [] ;
    extern int yylineno ;
    fprintf (stderr," %s: last token was \"%s\", line %d\n",
		text, yytext, yylineno) ;
    exit (-1) ;
}

