#include "mood_parser.h"
char *Query::checkAltintas()
{
	char		   *retClassName;
	BindListItem	   *bli;
	ProjectionListItem *pli;
	PathExpression	   *pexp;
	PathItem	   *pi;
	char		   iname[80];

	retClassName = NULL;

	// Check projectionList contains only one bind var i.e. s

	// only one item must be projected
	if( projectionList -> size != 1 ) {
		setError( PARSE_ERROR, NOT_VLD_PRJEXP, "");
		return NULL;
	}

	pli = ( ProjectionListItem *) projectionList->firstItem->item;

	// expression must not be in projection list
	if( pli->projExpression->size != 1 ) {
		setError( PARSE_ERROR, NOT_VLD_PRJEXP, "");
		return NULL;
	}

	// only a path exp. can be projected
	if( pli->projExpression->firstItem->itemType != PATH_EXP ){
		setError( PARSE_ERROR, NOT_VLD_PRJEXP, "");
		return NULL;
	}

	pexp = (PathExpression *) pli->projExpression->firstItem->item;

	// path expressions must contain only bind variable
	if( pexp->pathItems->size !=  1){
		setError( PARSE_ERROR, NOT_VLD_PRJEXP, "");
		return NULL;
	}

	// hey guy, lets get bind variable now
	pi = ( PathItem * ) pexp->pathItems->firstItem->item;

	strcpy( iname, pi->itemName );


	// get class name 
	bli = bindList->contains( iname );

	if( bli->bindExpression->size != 1 ){
		setError( PARSE_ERROR, NOT_VLD_BNDEXP, "");
		return NULL;
	}
	if( bli->bindExpression->firstItem->itemType != PATH_EXP ) {
		setError( PARSE_ERROR, NOT_VLD_BNDEXP, "");
		return NULL;
	}

	pexp = (PathExpression *) bli->bindExpression->firstItem->item;

	// path expressions must contain only bind variable
	if( pexp->pathItems->size !=  1) {
		setError( PARSE_ERROR, NOT_VLD_BNDEXP, "");
		return NULL;
	}

	// hey guy, lets get bind variable now
	pi = ( PathItem * ) pexp->pathItems->firstItem->item;

	retClassName = (char *) myAlloc(32);

	strcpy( retClassName, pi->itemName ); 
	return retClassName;
}
	

