#include <Cursor.h>
#include "mood_parser.h"
#include <lists.h>
#include <set.h>
#include <mood_catalog.h>
#include <memory.h>

int UpdateClause::findLinkedList( PathExpression *pe, LinkedList *pathChain )
{
	MoodsTypes	mt;
	Catalog		cat;
	CatBOOLEAN	status = FALSE;
	AttrList	*attrList, *currentAttr;
	int		i, size = pe->size();
	AttributeType	*attrType;
	char		*currentAttrName;

	if( !mt_getClassInfo( className, &cat, &attrList, &status ) || status) 
		return FALSE;

	currentAttr = attrList;

	for( i = 1; i < size; i++ ){
		currentAttrName = (char *)(pe->listAt(i)->item);
		// find the attribute inside the currentAttr
		currentAttr = currentAttr->nextsub;
		
		status = TRUE;
		while( status ){
			if( strcmp( currentAttr->entry.AttributeName, currentAttrName ) == 0 ){
				switch( currentAttr->entry.AttributeConstructor ){
					case 'S' : attrType = new AttrList;
						   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
						   pathChain->insert(ATTR_PTR, VOID attrType );
						   currentAttr ->= nextSub;
						   attrType = new AttrList;
						   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
						   pathChain->insert(ATTR_PTR, VOID attrType );
						   break;
					case 'L' : attrType = new AttrList;
                                                   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATTR_PTR, VOID attrType );
                                                   currentAttr ->= nextSub;
                                                   attrType = new AttrList;
                                                   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATTR_PTR, VOID attrType );
                                                   break;
					case 'R' : attrType = new AttrList;
                                                   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATTR_PTR, VOID attrType );
                                                   currentAttr ->= nextSub;
                                                   attrType = new AttrList;
                                                   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATTR_PTR, VOID attrType );
                                                   break;
					case 'T' : 

				}
				attrType = new AttrList;
				memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
				pathChain->insert( ATTR_PTR, VOID attrType );  	
				status = FALSE;
			} else {
				curentAttr = currentAttr->next;
				status = ( currentAttr == NULL );
			}
		}		
	}

		
}


int UpdateClause::update( OID *oid, LinkedList *pathChain, int position, int expPosition )
{
	OID		nextOid;
	AttributeType 	*p = (AttributeType *)(pathChain->listAt(position));
	int		err, s_type, s_size;
	USERDESC	*UserDesc;
	CatBOOLEAN	status = FALSE;
		
	if( position == (pathChain->size()-1) ){
		assign( oid, pathChain->listAt(position), expPosition );
		return TRUE;
	}

	// read the object corresponding to the oid
	err = sm_ReadObject( BufferGroup, oid, 0, READ_ALL, &UserDesc );
	if( err != esmNOERROR ){
		ur->setError( EXODUS_ERROR, 1, "" );
		return FALSE;
	}
	
	// copy  the corresponding oid
	memcpy( &nextOid, (char *)UserDesc->basePtr+p->AttributeOffset), sizeof(OID));
	sm_ReleaseObject( UserDesc );

	if( !OID_IS_INVALID( nextOid ) ){
		switch(p->AttributeConstructor){
			case 'S' : Set s( &nextOid, &s_type, &s_size, &status );
				   if( status ){ 
					ur->setError( INTERNAL_ERROR, 0, _errorMessage );
					return FALSE;
				   }
				   for( i = 0; i < s_size; i++ ){
					s.getElement( &nextOid, i, status );
					update( &nextOid, pathChain, 
				   }
		}
	}
 
	return TRUE;	
}


int UpdateClause::getLastAttrNameAndType( PathExpression *pe, char *attrName, int Type )
{
	MoodsTypes	mt;
	Catalog		cat;
	CatBOOLEAN	status=FALSE;
	AttrList	*attributes;
	int 		size = pe->size(), i;
	char		currentClass[ MAXSTRLEN ];

	strcpy( currentClass, className );	
	
	// get the name of the last attribute
	attrName = ( char * )(pe->listAt( size - 1 )->item);	

	// get the type of the last attribute
	for( i = 1; i < size-1; i++ ){
		mt.getClassInfo( currentClass, &cat, &attributes, &status );	
	} 
}

int UpdateClause::traverse( PathExpression *pe, char *Object )
{
	int i, size = pe->size() - 1;

	for( i = 1; i < size; i++ ){

	} 
}


int UpdateClause::pathUpdate( OID *oid, AttributeType *p, int pos )
{
	AttrList	*attributes;
	MoodsTypes	mt;
	Catalog		cat;
	CatBOOLEAN	status = FALSE;

	if( !mt.getClassInfo( className, &cat, &attributes, &status ) || status ){
		ur->setError( INTERNAL_ERROR, 0, "Cannot read Class Info" );
		return FALSE;
	}

	 	
	
}


int UpdateClause::update(OID *oid, int &position )
{
	AttributeType	*p = (AttributeType *)(updateExpression->listAt(position)->item);
	unsigned	itemType = updateExpression->listAt(position)->itemType;

	switch( itemType ){
		case PATH_EXP : if( !pathUpdate( oid, p, position + 1 ) ) return FALSE;
				position+=2;
				return TRUE;
		// case FUNCTION : lhfdkjhfdgkjhfdkj;
	}

}


int UpdateClause::update( OID *oid )
{
	char 	flag = 1;
	int	position = 0;

	while( flag ) flag = update( oid, position );
}

int UpdateClause::execute()
{
	Query           *query;
	OID             oid;
	UserRequest	*userreq;
	char 		*bindVar, Flag;

	// Convert UPDATE Clause to a SELECT Clause and execute it...
	bindVar = getBindVar();
	className = getClassName();

	query = new Query(ur);

	userreq = new UserRequest( bindVar );
	projectionList = ProjectionExpression new( userreq );
	projectionList->parse();
	delete userreq;

	query->projectionList = projectionList;
	query->bindList = bindList;
	query->whereP = whereP;

	if( !query->generateAllTree() ) return FALSE;
	if( !query->generatePlan() ) return FALSE;

	OpenCursor(query->solutionFile,&ResCur);

	if (!GetFirstObject(&ResCur,&Flag))
		return(FALSE);

	while( !Flag ){

		memcpy((char *)&oid, (char *)ResCur.CurUserdesc->basePtr, sizeof(OID));
		update( &oid );

	}	

	if( !CloseCursor( &ResCur ) ) return FALSE;

	return TRUE;
}
