#include "mood_parser.h"

void DeleteClause::printOn()
{
	printf("\n ------ Delete Clause ------\n");
	if(whereP)
	{
		printf("\n Where Predicate :\n");
		whereP->printOn();
	}
	if(projectionList)
	{
		printf("\n Projection List : \n");
		projectionList->printOn();
	}
	if(bindList)
	{
		printf("\n Bind List : \n");
		bindList->printOn();
	}
	printf("\n ---------------------------\n");
}

DeleteClause::parse()
{
	return deleteClause();
}


DeleteClause::deleteClause()
{

	connectUserRequest();

	CHECK_TOKEN(DELETE, 23, ""); // Check DELETE keyword

	projectionList = new ProjectionExpression( ur );

	if( !projectionList->parse() ) return FALSE;

	if(! fromClause() ) 	 return FALSE;
	if(! whereClause() )     return FALSE;
	return TRUE;
}


DeleteClause::fromClause()
{
	CHECK_TOKEN(FROM, FROM_KYWD_ERR, ""); // there must be FROM keyword

	bindList = new BindExpression( ur );

	if( !bindList->parse() ) return FALSE;

	return TRUE;
}

DeleteClause::whereClause()
{
	IS_THIS_KEYWORD(WHERE); // check WHERE keyword

	whereP = new Expression( ur );

	if( !whereP->parse()) return FALSE;

	return TRUE;
}

