
#include <stdlib.h>
#include "mood_error.h"


/* Erros given by the MSQL parser */
char *parseErrors[80] = {
/*  0 */        "missing right paranthesis",
/*  1 */        "invalid index",
/*  2 */        "lower bound can not be greater than upper bound",
/*  3 */        "missing right bracket",
/*  4 */        "type mismatch in set constant",
/*  5 */        "syntax error",
/*  6 */        "class name is expected",
/*  7 */        "bind variable is expected",
/*  8 */        "logical operator is expected",
/*  9 */        "invalid index name",
/* 10 */        "invalid attribute name",
/* 11 */        "missing left paranthesis",
/* 12 */        "No such MOODSQL statement",
/* 13 */        "FROM keyword is expected",
/* 14 */        "WITH keyword is expected",
/* 15 */        "ON keyword is expected",
/* 16 */        "BY keyword is expected",
/* 17 */        "INTO keyword is expected",
/* 18 */        "VALUES keyword is expected",
/* 19 */        "OF keyword is expected",
/* 20 */        "Invalid token",
/* 21 */        "JOIN keyword is expected",
/* 22 */        "INDEX keyword is expected",
/* 23 */        "SELECT keyword is expected",
/* 24 */	"DELETE keyword is expected",
/* 25 */	"ORDER keyword is expected",
/* 26 */	"UPDATE keyword is expected",
/* 27 */	"SET keyword is expected",
/* 28 */	"CLASS keyword is expected",
/* 29 */	"NEW keyword is expected",
/* 30 */	"This version does not support ",
/* 31 */	"Invalid Class Name- ",
/* 32 */        "Invalid Bind Variable- ",
/* 33 */	"Not a valid projection expression in this context",
/* 34 */	"Not a valid bind expression in this context",
/* 35 */        "UNIQUE keyword is expected",
/* 36 */	"Invalid Database Name : ",
/* 37 */	"FOR keyword is expected",
/* 38 */ 	"TO keyword is expected",
/* 39 */	"DECLARATION keyword expected",
/* 40 */	"{ expected",
/* 41 */	"} expected",
/* 42 */	"; expected",
/* 43 */ 	"Invalid type name",
/* 44 */	"Class already exists",
/* 45 */	"USING keyword is expected",
/* 46 */	"Missing file name ",
/* 47 */	"Iheritance is not allowed inside a TYPE definition",
/* 48 */	"Types can not be inherited",
/* 49 */	"Prototype keyword  is expected",
/* 50 */	"Missing prototype declaration",
/* 51 */	"SELECT or NEW keyword expected",
/* 52 */	" [ is expected",
/* 53 */	"TUPLE keyword expected",
/* 54 */	"FUNCTION keywords is expected",
/* 55 */	"Invalid function name",
/* 56 */	"SIGNATURE/PROTOTYPE/NAME keyword is expected",
/* 57 */	"Cyclic definition of class:"
};

/* Runtime error given by MSQL */
char 	*runtimeErrors[120] = 
{
/* 000 */	"Division by zero",
/* 001 */	"Class/Type does not exist-",
/* 002 */	"Overflow error",
/* 003 */	"Database not found-",
/* 004 */	"Database already exists-", 
/* 005 */	"Class/type already exists-",
/* 006 */	"No such attribute-",
/* 007 */	"Function Does Not Exist",
/* 008 */	"Function already exist",
/* 009 */	"There is no active database",
/* 010 */       "Invalid File Name",
/* 011 */	"Not a class name",
/* 012 */	"There is no database in use",
/* 013 */	"Type mismatch for argument",
/* 014 */	"Invalid query",
/* 015 */	"Can not get object",
/* 016 */	"Too many objects as a result of the query",
/* 017 */	"Error in dynamic linking",
/* 018 */	"Class names should be the same",
/* 019 */	"Missing argument",
/* 020 */	"Extra argument",
/* 021 */	"Type mismatch in expression",
/* 022 */	"NULL value is not allowed for this type",
/* 023 */	"Sorry, this version does not support ",
/* 024 */	"Attribute not found",
/* 025 */	"Cannot delete object",
/* 026 */	"Database directory not found-",
/* 027 */	"Class list has referenced by "
};

void MoodsError::setError(ErrorType type, int no, char *msg)
{
        errorType = type;
        errorNo   = no;
        strcpy(errorMsg, msg);
}
void MoodsError::handleError()
{

	printf("\n");

        switch(errorType) {

        case NO_ERROR :
		printf(" %s\n\n", errorMsg );
		errorType = NO_ERROR;
		strcpy( errorMsg, "");
                return;

        case PARSE_ERROR :
 /*  int i,count=0,j=0;
       char place[80];
       for(i=0;i<=prevpos;i++) {
         count++;
         if(query[i]=='\n') count = 0;
        }
 
        for( i=(prevpos-count+1); query[i] != ';' && query[i] != '\n' ;i++)
          place[j++] = query[i];
        if(query[i] == ';') place[j++] = query[i];
        place[j] = '\0';
         printf("\n%s\n",place);
 
 
        for(i=0,j=0;i<count;i++) place[j++]=' ';
        place[j++]='^';place[j]='\0';
        printf("%s\n",place); */
 
		printf("\n parse error-%d : %s %s  \n\n", errorNo, parseErrors[errorNo], errorMsg );
		strcpy( errorMsg, "");
		errorType = NO_ERROR;
		return;
        case RUNTIME_ERROR  :
                printf("\nError-%4d : %s %s\n\n", errorNo, runtimeErrors[errorNo],errorMsg);
                strcpy(errorMsg, "");
                errorType = NO_ERROR;
                return;
 
        case EXODUS_ERROR   :
              if(errorNo < 0 ) {
                        printf("\nStorage Manager Error : %d\n", errorNo);
                        printf("Error = %s\n", sm_Error(sm_errno));
                        printf("location = %s\n\n", errorMsg);
                }
                errorType = NO_ERROR;
                sm_AbortTransaction(TransactionId);
                strcpy(errorMsg, "");
                exit(1);

	case INITIALIZATION_ERROR :
		printf("%s\n", errorMsg );
		exit(1);

	case COMPILATION_ERROR :
		printf(" Compilation Error\n");
		strcpy( errorMsg, "");
		errorType = NO_ERROR;
		return;
 
        case INTERNAL_ERROR :
                errorType = NO_ERROR;
                printf("\nInternal Error : %s\n\n", errorMsg);
                printf("Please report to Cetin Ertan Ozkan\n");
                printf(" certan@srdc.metu.edu.tr \n");
                exit(1);
        }
}


