#include "opt_defs.h"
#include "dbi_gen.h"
#include "opt.h"
#include "dbi.h"
#include "global.h"
#include "mood_parser.h"
#include "vol_util.h"
#include "mood_alg.h"


extern int  DoTransaction(PLAN *, JOIN_ARG **, int, PLAN **);
extern void printPlan( QUERY *);
extern void prnt_qry ( QUERY * , FILE   * );
extern PLAN *get_pln ( FILE   *fp );
extern void freeQUERY( QUERY * );
extern void freeExecVars(PLAN *, PLAN *, JOIN_ARG ** , int );

PLAN *RetPlan;

Query::generatePlan()
{
	FILE		*fp;
	PLAN 		*plan = NULL ;	
	char 		VolPath[2*MAXSTRLEN];
	JOIN_ARG	**prjList;
	int 		error;

	if( !queryTree ) {
		//printf(" NULL PLAN IS GENERATED BY CERTAN \n ");
		return TRUE;
	}

	// The followings are done to avoid extensive memory usage of Volcano

	// write query into $(MOOD_HOME)/tmp/queryFile
	sprintf(VolPath,"%s/tmp/queryFile",MoodHome);
	fp = fopen( VolPath, "w" );
	prnt_qry( queryTree, fp );
	fclose( fp );
	//printPlan( queryTree );
	freeQUERY( queryTree );
	queryTree = NULL;

	// call optimizer as an external process
	if( !MoodBin )
		sprintf(VolPath,"VolOpt > %s/tmp/plan_file.out", MoodHome );
	else
		sprintf(VolPath,"%s/VolOpt > %s/tmp/plan_file.out",MoodBin, MoodHome );

	moodTimer.Start();
	system(VolPath);
	moodTimer.Stop();
	ur->optimizeTime = moodTimer.RealTime();

	// read optimized plan from $(MOOD_HOME)/tmp/planFile
	sprintf(VolPath,"%s/tmp/planFile",MoodHome);
	fp = fopen(VolPath,"r");
        if (!fp)
	{
	   ur->setError( INTERNAL_ERROR, 0, " plan file not generated\n" );
           return FALSE;
	}

	plan = get_pln(fp);

	// remove plan file
	unlink( VolPath );

	// remove query file
	sprintf(VolPath,"%s/tmp/queryFile",MoodHome);
	unlink( VolPath );
	
	RetPlan = NULL;
	solutionFile = NULL;
	printf ("Optimizer returned successfully.\n") ;
	moodTimer.Start();
	prjList = projectionList->convertToMehmet();
	if (!DoTransaction(plan,prjList, projectionList->size, &RetPlan))
	{
		freeExecVars( plan, RetPlan, prjList,  projectionList->size );
		return FALSE;
	}

	moodTimer.Stop();
	ur->actualTime = moodTimer.RealTime();
	
	solutionFile = (RELATION_SCHEMA *) malloc( sizeof( RELATION_SCHEMA ) );
	solutionFile->arity = 0;
	solutionFile->copy(  &RetPlan->logical_property );
	//solutionFile = &RetPlan->logical_property;
		
	freeExecVars( plan, RetPlan, prjList,  projectionList->size );

	return TRUE;
}

