/************************************************************************* 

			ABOUT THIS FILE 



Subject	:

	The member functions of ListItem, LinkedList, and Stack
	are declared in this file. 

Author 	: 

	Cetin Ertan Ozkan

Date	: 

	15/02/1993

Last Test Date :

	15/02/1993

Last Revision Date :

	No revision

Related Files :

	../include/linklist.h --> related class declarations

*************************************************************************/
#include <stdio.h>
#include "keywords.h"
#include "linklist.h"
#include "mood_catalog.h"

 
/***************************************************************************

			LinkedList Methods

****************************************************************************/

// get first item from list
void *LinkedList::getFirstEntry() {
  if (( firstItem == NULL ) || ( firstItem->item == NULL )) {
         printf("no items found\n");
         exit(1);
     } ;

     curItem = firstItem ;
     return(curItem->item);
};

void *LinkedList::getNextEntry() {
     if ( !curItem->next )  return( NULL );
     curItem = curItem->next ;
     return(curItem->item);
};

// traverse all items of a list
void LinkedList::traverseList()
{
	ListItem *p;
	p = firstItem;
	while(p){
		p->printOn();
		p  = p->next;
	}
}

LinkedList* LinkedList::extractVariables()
{
	ListItem *p;
	char *bindVar; 
	SortedStringList *outKey = new SortedStringList();
	p = firstItem;
	while(p)
	{
		if( p->itemType == PATH_EXP )
		{
			bindVar = (char *) myAlloc(80);
			strcpy( bindVar,	
				( char *) ( ( PathExpression * ) p->item)->
					 pathItems->firstItem->item  );
			outKey->insertSorted( STRCONS, VOID bindVar);
		}
		p = p->next;
	}
	return ( LinkedList * ) outKey;

}



// returns list item at index i
ListItem *LinkedList::listAt(unsigned i)
{
        if(i>=size) return NULL;

        unsigned int j;
        ListItem *p;

        j = i;
        p = firstItem;

        while( p && j ){
                p = p->next;
                j--;
        }
        if(j) return NULL;
        return p;
}

// extract a sublist from a list between to list items
LinkedList *LinkedList::subList( ListItem *stItem, ListItem *endItem)
{
	LinkedList 	*aList;
	ListItem 	*q, *anItem;
	aList = new LinkedList();
	if( !stItem || !endItem ) return aList;
	q = stItem;
	while( (q) && (q != endItem->next) ) 
	{
		anItem = new ListItem( q->itemType, q->item);
		aList->insertItem(anItem);
		q = q->next;
	}
	return aList;
}
	

// remove list item at index "index"
LinkedList::removeItem(unsigned index)
{
	if( index >= size || size <= 0 ) return FALSE;

	unsigned j;
	ListItem *p;
	p = firstItem;
	j = index;

	// find item to be deleted
	while( p && j ) {
		p = p->next;
		j--;
	}

	if(j) return FALSE;

	removeItem( p );

        return TRUE;

}


// remove a list item "listItem"
LinkedList::removeItem(ListItem *listItem)
{

	if(!listItem) return FALSE;


	if(listItem == firstItem){
		firstItem = listItem->next; // adjust first item
		listItem->next->prev = NULL;
	}
        else if(listItem == lastItem){
		 lastItem = listItem->prev; // adjust last item
		 listItem->prev->next = NULL;
	}
	else {
		listItem->prev->next = listItem->next;
		listItem->next->prev = listItem->prev;
	}
		

	delete listItem; // delete item 

	return TRUE;
}


// insert a list item
void LinkedList::insertItem(ListItem *listItem)
{
        if(size == 0){
                firstItem = listItem;
                lastItem  = listItem;
        }
        else {
                lastItem->next  = listItem;
		listItem->prev  = lastItem;
                lastItem        = listItem;
        }
        size++;
}


// insert an item by using item type and item
void LinkedList::insert(unsigned itype, void *i)
{
        ListItem *p = new ListItem(itype, i);
        insertItem(p);
}





/***************************************************************************

			Stack Methods

****************************************************************************/

// push to the stack
void Stack::push(unsigned itype, void *i)  
{
	LinkedList::insert(itype, i);
}

// pop from the stack
ListItem *Stack::pop()
{
	ListItem *p = LinkedList::lastItem;
	LinkedList::removeItem(LinkedList::lastItem);
	return(p);
}

