#include "mood_parser.h"
#include "mood_error.h"
#include <stdio.h>

Query::generateAllTree()
{
	if( whereP )
	{
		if( !generateTree() ) return FALSE;
	}
	else
	{
		if( !generateTreeForNoPredicate() ) return FALSE;
	}
	return TRUE;
}

char *Query::getClassName( char * bindVar )
{
	return bindList->getClassName( bindVar );
}

void Query::normalizeQuery()
{
	ORTerms = new AndTerms();
	//whereP->stack2tree( whereP->lastItem );
	whereP->normalize( ORTerms );
}

void Query::printOn()
{
	printf("\n --------------    QUERY     --------------\n");
	if( ORTerms != NULL )
	{
		printf(" ------- OR TERMS ------\n ");
		ORTerms->printOn();
	}
	if(whereP != NULL ) {
		printf("WHERE PREDICATE :\n");
		whereP->printOn();
	}
	if(startWithP){
		printf("Start With Predicate:\n");
		startWithP->printOn();
	}
	if(havingP){
		printf("Start With Predicate:\n");
		 havingP->printOn();
	}
	if(projectionList){
		printf("Projection List :\n");
		projectionList->printOn();
	}
	/* if(groupByList){
		printf("Start With Predicate:\n");
		groupByList->printOn();
	if(orderByList){
		printf("Start With Predicate:\n");
		orderByList->printOn();*/

	if(bindList){
		printf("Bind List:\n");
		bindList->printOn();
	}
	printf("   --------------- END QUERY  ------------------\n");
}

int Query::parse()
{
        return selectClause();
}

Query::selectClause()
{
#ifdef DEBUG
	printf("\n***************  SELECT  ****************\n");
#endif
	CHECK_TOKEN(MS_SELECT, SELECT_KYWD_ERR, ""); // Check SELECT keyword


	projectionList = new ProjectionExpression( ur );
	getToken();
	if( tokenType() != STAR )
	{
		backtrack();
		if( !projectionList->parse() ) return FALSE;
	}

	if(! fromClause() ) 	 return FALSE;
	//if(! recurseOnClause() ) return FALSE;
	if(! whereClause() )     return FALSE;
	//if(! groupByClause() )   return FALSE;
	//if(! orderByClause() )   return FALSE;
#ifdef DEBUG
	printf("OKKKK");
#endif
	return TRUE;
}

Query::fromClause()
{
#ifdef DEBUG
	printf("\n************* FROM CLAUSE *****************\n");
#endif
	CHECK_TOKEN(FROM, FROM_KYWD_ERR, ""); // there must be FROM keyword

	bindList = new BindExpression( ur );

	if( !bindList->parse() ) return FALSE;

	return TRUE;
}

Query::recurseOnClause()
{
	IS_THIS_KEYWORD(RECURSE);

	CHECK_TOKEN(ON, ON_KYWD_ERR, "");

	//if(!pathExpression(&qry->recurseOnatt)) return FALSE;
	//if(!startWithClause(qry)) return FALSE;

	return TRUE;
}

Query::startWithClause()
{
	IS_THIS_KEYWORD(START); // Check START keyword

	CHECK_TOKEN(WITH, WITH_KYWD_ERR, "");

	startWithP = new Expression( ur);

	if( !startWithP->parse() ) return FALSE;

	return TRUE;
}

Query::whereClause()
{
#ifdef DEBUG
	printf("\n****************** WHERE CLAUSE **************\n");
#endif
	IS_THIS_KEYWORD(WHERE); // check WHERE keyword

	whereP = new Expression( ur );

	if(!whereP) { printf("HATA"); exit(1); }

	if( !whereP->parse()) return FALSE;

	return TRUE;
}

Query::groupByClause()
{
	IS_THIS_KEYWORD(GROUP);

	CHECK_TOKEN(BY, 16, "");

	groupByList = new ProjectionExpression( ur );

	if( ! groupByList->parse() ) return FALSE;

	return TRUE;
}

Query::havingClause()
{
	IS_THIS_KEYWORD(HAVING);
	// Complete it later
}

Query::orderByClause()
{
	IS_THIS_KEYWORD(ORDER);

	CHECK_TOKEN(BY, ORDER_KYWD_ERR, "");

	orderByList = new ProjectionExpression( ur );

        if( !orderByList->parse() ) return FALSE; 

	return TRUE;
}



