#include <Cursor.h>
#include "mood_parser.h"
#include <lists.h>
#include <set.h>
#include <mood_catalog.h>
#include <memory.h>

extern evaluateExpr(JOIN_ARG *, CNST *);

int UpdateClause::findLinkedList( PathExpression *pe, LinkedList *pathChain )
{
	MoodsTypes	mt;
	Catalog		cat;
	CatBOOLEAN	status = FALSE;
	AttrList	*attrList, *currentAttr, *attrType;
	int		i, size = pe->pathItems->size;
	char		*currentAttrName;

	if( !mt.getClassInfo( className, &cat, &attrList, &status ) || status) 
		return FALSE;

	currentAttr = attrList;

	for( i = 1; i < size; i++ ){
		currentAttrName = (char *)(pe->pathItems->listAt(i)->item);
		// find the attribute inside the currentAttr
		currentAttr = currentAttr->nextsub;
		
		status = TRUE;
		while( status ){
			if( strcmp( currentAttr->entry.AttributeName, currentAttrName ) == 0 ){
				switch( currentAttr->entry.AttributeConstructor ){
					case 'S' : attrType = new AttrList;
						   memcpy( VOID attrType, VOID &currentAttr->entry, sizeof( AttributeType) );
						   pathChain->insert(ATR_PTR, VOID attrType );
						   currentAttr = currentAttr->nextsub;
						   attrType = new AttrList;
						   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
						   pathChain->insert(ATR_PTR, VOID attrType );
						   break;
					case 'L' : attrType = new AttrList;
                                                   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATR_PTR, VOID attrType );
                                                   currentAttr = currentAttr->nextsub;
                                                   attrType = new AttrList;
                                                   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATR_PTR, VOID attrType );
                                                   break;
					case 'R' : attrType = new AttrList;
                                                   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATR_PTR, VOID attrType );
                                                   currentAttr = currentAttr->nextsub;
                                                   attrType = new AttrList;
                                                   memcpy( attrType,  &currentAttr->entry, sizeof( AttributeType) );
                                                   pathChain->insert(ATR_PTR, VOID attrType );
       //                                            break;
					case 'T' : 
					default  : attrType = new AttrList;
						   memcpy( attrType, &currentAttr->entry, sizeof( AttributeType ) );
						   pathChain->insert(ATR_PTR, VOID attrType );
						   break;

				}
			} else {
				currentAttr = currentAttr->next;
				status = ( currentAttr == NULL );
			}
		}		
	}

	return TRUE;		
}


/*
int UpdateClause::update( OID *oid, LinkedList *pathChain, int position, int expPosition )
{
	OID		nextOid;
	AttributeType 	*p = (AttributeType *)(pathChain->listAt(position));
	int		err, s_type, s_size;
	USERDESC	*UserDesc;
	CatBOOLEAN	status = FALSE;
		
	if( position == (pathChain->size-1) ){
		assign( oid, pathChain->listAt(position), expPosition );
		return TRUE;
	}

	// read the object corresponding to the oid
	err = sm_ReadObject( BufferGroup, oid, 0, READ_ALL, &UserDesc );
	if( err != esmNOERROR ){
		ur->setError( EXODUS_ERROR, 1, "" );
		return FALSE;
	}
	
	// copy  the corresponding oid
	memcpy( &nextOid, (char *)UserDesc->basePtr+p->AttributeOffset), sizeof(OID));
	sm_ReleaseObject( UserDesc );

	if( !OID_IS_INVALID( nextOid ) ){
		switch(p->AttributeConstructor){
			case 'S' : Set s( &nextOid, &s_type, &s_size, &status );
				   if( status ){ 
					ur->setError( INTERNAL_ERROR, 0, _errorMessage );
					return FALSE;
				   }
				   for( i = 0; i < s_size; i++ ){
					s.getElement( &nextOid, i, status );
					update( &nextOid, pathChain, 
				   }
		}
	}
 
	return TRUE;	
}


int UpdateClause::traverse( PathExpression *pe, char *Object )
{
	int i, size = pe->size - 1;

	for( i = 1; i < size; i++ ){

	} 
}

*/

int UpdateClause::pathUpdate( OID *oid, int pos )
{
	LinkedList	list;
	PathExpression	*pe = (PathExpression *)(updateExpression->listAt(pos)->item);
	AttributeType	*attribute;
	USERDESC	*UserDesc;
	int		err, offset;
	char		*Object, errorMsg[MAXSTRLEN];
	Expression	*exp;
	JOIN_ARG	*jExp;
	CNST		*retVal;
	OID		*tempOid;

	retVal = (CNST *)malloc(sizeof(CNST));
	
	findLinkedList( pe, &list );

	 // read the object corresponding to the oid
        err = sm_ReadObject( BufferGroup, oid, 0, READ_ALL, &UserDesc );
        if( err != esmNOERROR ){
                ur->setError( EXODUS_ERROR, 1, "" );
		free(retVal );
                return FALSE;
        }

	attribute = (AttributeType *)(list.listAt(0)->item);
	Object = UserDesc->basePtr;
	offset = attribute->AttributeOffset;

	switch( attribute->AttributeConstructor ){
	case 'N' : exp = (Expression *) (updateExpression->listAt(pos)->item);
		   jExp = exp->convertToIlker( exp->lastItem );
		   evaluateExpr( jExp, retVal );
		   switch(retVal->kind){
		   case INTEGER :  
			if (strcmp(attribute->AttrTypeName,"INTEGER")){
				sprintf( errorMsg, "(%s was expected)",
				attribute->AttrTypeName);
				ur->setError(RUNTIME_ERROR,R_TYPE_MISMATCH,errorMsg);
				return FALSE;
			}
			sm_WriteObject(BufferGroup,offset,sizeof(int),(char *)&retVal->value.int_value, UserDesc, TRUE );
			break;
                   case REAL:
                        if (strcmp(attribute->AttrTypeName,"FLOAT")){
                                sprintf( errorMsg, "(%s was expected)",
                                attribute->AttrTypeName);
                                ur->setError(RUNTIME_ERROR,R_TYPE_MISMATCH,errorMsg);
                                return FALSE;
                        }
			sm_WriteObject(BufferGroup,offset,sizeof(float),(char *)&retVal->value.real_value, UserDesc, TRUE );
                        break;
		   case TEXT :
			if (strcmp(attribute->AttrTypeName,"STRING")) {
			  	sprintf( errorMsg, "(%s was expected)",
				attribute->AttrTypeName);
				ur->setError( RUNTIME_ERROR, R_TYPE_MISMATCH, errorMsg);
				return FALSE;
			}
			sm_WriteObject(BufferGroup,offset,attribute->AttributeLength,(char *)&retVal->value.text_value, UserDesc, TRUE );
			break;
		   }
	case 'R' : tempOid = (OID *)(Object+offset);
		   if( !OID_IS_INVALID( *tempOid ) ){

		   }

	}		

	free(retVal);
	return TRUE;

}


int UpdateClause::update(OID *oid, int &position )
{
	AttributeType	*p = (AttributeType *)(updateExpression->listAt(position)->item);
	unsigned	itemType = updateExpression->listAt(position)->itemType;

	switch( itemType ){
		case PATH_EXP : if( !pathUpdate( oid, position + 1 ) ) return FALSE;
				position+=2;
				return TRUE;
		// case FUNCTION : lhfdkjhfdgkjhfdkj;
	}
	
	return TRUE;
}


int UpdateClause::update( OID *oid )
{
	char 	flag = 1;
	int	size = updateExpression->size, position = 0;

	while( position < size ) if( !update( oid, position ) ) return FALSE;

	return TRUE;
}

char *UpdateClause::getBindVar()
{
	BindListItem 	*bli;

	bli = ( BindListItem *)(bindList->firstItem->item);
	return bli->alias;
}

char *UpdateClause::getClassName()
{
        BindListItem    *bli;

        bli = ( BindListItem *)(bindList->firstItem->item);
        return bli->classInfo.name;
}

int UpdateClause::executeUpt()
{
	Query           *query;
	OID             oid;
	UserRequest	*userreq;
	char 		*bindVar, Flag;
	MOODSCursor	ResCur;

	// Convert UPDATE Clause to a SELECT Clause and execute it...
	bindList->checkSemantic();
	bindVar = getBindVar();
	className = getClassName();

	query = new Query(ur);

	userreq = new UserRequest( bindVar );
	projectionList = new ProjectionExpression( userreq );
	projectionList->parse();
	delete userreq;

	query->projectionList = projectionList;
	query->bindList = bindList;
	query->whereP = whereP;

	if( !query->generateAllTree() ) return FALSE;
	if( !query->generatePlan() ) return FALSE;

	OpenCursor(query->solutionFile,&ResCur);

	if (!GetFirstObject(&ResCur,&Flag))
		return(FALSE);

	while( !Flag ){

		memcpy((char *)&oid, (char *)ResCur.CurUserdesc->basePtr, sizeof(OID));
		update( &oid );

	}	

	if( !CloseCursor( &ResCur ) ) return FALSE;

	return TRUE;
}
