#include <stdio.h>
#include "timer.h"

const int THOU = 1000;

// The Start() function starts the collecting of time for a Unix process.
void Timer::Start() 
{
    //Save the current time in buffer area 1.
    getrusage(RUSAGE_SELF, &rusage1);
    gettimeofday(&time1, NULL);
    return;
}


// The Stop() function stops the collecting of time for a Unix process.
void Timer::Stop() 
{
    // Save the final times in buffer area 2.
    gettimeofday(&time2, NULL);
    getrusage(RUSAGE_SELF, &rusage2);
    return;
}


// The RealTime() function returns the elapsed real time in micro-seconds 
// (as measured by Unix) between the Start() call and the last Stop() call.
float Timer::RealTime() 
{
    return 1000000.0 * (time2.tv_sec - time1.tv_sec) + 
//    return 1000.0 * (time2.tv_sec - time1.tv_sec) + 
           (time2.tv_usec - time1.tv_usec);
}


// The UserTime() function returns the Unix process elapsed user time 
// in micro-seconds between the Start() call and the last Stop() call.
float Timer::UserTime() 
{
    return 1000000. * (rusage2.ru_utime.tv_sec - rusage1.ru_utime.tv_sec) +
           (rusage2.ru_utime.tv_usec - rusage1.ru_utime.tv_usec);
}


// The SystemTime() function returns the Unix process elapsed system time 
// in micro-seconds between the Start() call and the last Stop() call.
float Timer::SystemTime() 
{
    return 1000000.0 * (rusage2.ru_stime.tv_sec - rusage1.ru_stime.tv_sec) +
           (rusage2.ru_stime.tv_usec - rusage1.ru_stime.tv_usec);
}
